"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = require("react");

function useStateCallback(initialState) {
  var _a = react_1.useState(initialState),
      state = _a[0],
      _setState = _a[1];

  var callbackRef = react_1.useRef();
  var isFirstCallbackCall = react_1.useRef(true);
  var setState = react_1.useCallback(function (setStateAction, callback) {
    callbackRef.current = callback;

    _setState(setStateAction);
  }, []);
  react_1.useEffect(function () {
    if (isFirstCallbackCall.current) {
      isFirstCallbackCall.current = false;
      return;
    }

    if (typeof callbackRef.current === 'function') {
      callbackRef.current(state);
    }
  }, [state]);
  return [state, setState];
}

exports["default"] = useStateCallback;