"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var useAlertBox_1 = __importDefault(require("./useAlertBox"));

var classnames_1 = __importDefault(require("classnames"));

require("./alertBox.less");

var lodash_1 = require("lodash");

var AlertBox = function AlertBox(_a) {
  var _b = _a.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      _c = _a.type,
      type = _c === void 0 ? 'default' : _c,
      _d = _a.className,
      className = _d === void 0 ? '' : _d,
      _e = _a.closeBtn,
      closeBtn = _e === void 0 ? true : _e,
      _f = _a.title,
      title = _f === void 0 ? '' : _f,
      _g = _a.alertcontent,
      alertcontent = _g === void 0 ? '' : _g,
      _h = _a.visible,
      visible = _h === void 0 ? true : _h;

  var _j = useAlertBox_1["default"](),
      fadeOut = _j.fadeOut,
      isShow = _j.isShow,
      handleClickClose = _j.handleClickClose;

  if (!visible || lodash_1.isEmpty(alertcontent) || lodash_1.isArray(alertcontent) && lodash_1.isEmpty(alertcontent.filter(function (_a) {
    var _ = _a[0],
        _b = _a[1],
        b = _b === void 0 ? true : _b;
    return b;
  }))) {
    return null;
  }

  return isShow ? react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-alertbox " + prefixCls + "-alertbox-" + type, className, {
      'fadeout-alert': fadeOut
    })
  }, closeBtn ? react_1["default"].createElement("a", {
    onClick: handleClickClose,
    className: classnames_1["default"](prefixCls + "-alertbox-icon")
  }, react_1["default"].createElement("i", {
    className: 'iconfont icon-error-o'
  })) : null, react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-alertbox-info")
  }, title ? react_1["default"].createElement("h3", {
    className: classnames_1["default"](prefixCls + "-alertbox-title")
  }, title) : null, react_1["default"].createElement("p", {
    className: classnames_1["default"](prefixCls + "-alertbox-text")
  }, lodash_1.isArray(alertcontent) ? alertcontent.filter(function (_a) {
    var _ = _a[0],
        _b = _a[1],
        b = _b === void 0 ? true : _b;
    return b;
  }).map(function (_a) {
    var s = _a[0];
    return s;
  }) : alertcontent))) : null;
};

exports["default"] = AlertBox;