"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = require("react");

var useToastr = function useToastr(delay) {
  var timer;

  var _a = react_1.useState(false),
      isShow = _a[0],
      setIsShow = _a[1];

  var handleShowAlert = function handleShowAlert() {
    setIsShow(true);
    timer = setTimeout(function () {
      setIsShow(false);
    }, delay * 1000);
  };

  react_1.useEffect(function () {
    return function () {
      clearTimeout(timer);
    };
  }, []);
  return {
    isShow: isShow,
    handleShowAlert: handleShowAlert
  };
};

exports["default"] = useToastr;