"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var lodash_1 = __importDefault(require("lodash"));

require("./breadcrumb.less");

var react_router_dom_1 = require("react-router-dom");

var Breadcrumb = function Breadcrumb(props) {
  var _a = props.prefixCls,
      prefixCls = _a === void 0 ? 'ult' : _a,
      _b = props.langCode,
      langCode = _b === void 0 ? window.LangCode || 'en' : _b,
      _c = props.routes,
      routes = _c === void 0 ? [] : _c,
      _d = props.params,
      params = _d === void 0 ? {} : _d,
      _e = props.hiddenLinkDesc,
      hiddenLinkDesc = _e === void 0 ? false : _e,
      _f = props.webName,
      webName = _f === void 0 ? '' : _f,
      _g = props.separator,
      separator = _g === void 0 ? '/' : _g,
      _h = props.className,
      className = _h === void 0 ? '' : _h;

  if (lodash_1["default"].isEmpty(routes)) {
    return null;
  }

  var route = lodash_1["default"].last(routes);
  var title = lodash_1["default"].get(window, "LanguageData." + langCode + "." + lodash_1["default"].get(route, 'langCode'), lodash_1["default"].get(route, 'name'));
  var description = lodash_1["default"].get(window, "LanguageData." + langCode + "." + lodash_1["default"].get(route, 'descLangCode'), '');

  if (webName) {
    document.title = webName + "  " + title;
  }

  return react_1["default"].createElement("div", {
    className: prefixCls + "-breadcrumb " + className
  }, react_1["default"].createElement("div", null, react_1["default"].createElement("span", {
    className: "title"
  }, title), react_1["default"].createElement("span", {
    className: "description"
  }, description)), react_1["default"].createElement("ul", null, hiddenLinkDesc ? null : routes.map(function (item, index) {
    var linkName = lodash_1["default"].get(window, "LanguageData." + langCode + "." + lodash_1["default"].get(item, 'langCode'), lodash_1["default"].get(item, 'name'));
    var linkPath = item.path || '';
    Object.keys(params).forEach(function (key) {
      linkPath = linkPath.replace(new RegExp(":" + key, 'g'), params[key]);
    });

    if (index === routes.length - 1) {
      return react_1["default"].createElement("li", {
        key: item.key
      }, linkName);
    } else {
      if (item.path) {
        return react_1["default"].createElement("li", {
          key: item.key
        }, react_1["default"].createElement(react_router_dom_1.Link, {
          href: linkPath,
          to: linkPath
        }, linkName), react_1["default"].createElement("span", {
          className: prefixCls + "-breadcrumb-separator"
        }, separator));
      }

      return react_1["default"].createElement("li", {
        key: item.key,
        className: "disabled"
      }, linkName);
    }
  })));
};

exports["default"] = Breadcrumb;