"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var ButtonList_1 = __importDefault(require("./ButtonList"));

var ButtonGroup_1 = __importDefault(require("./ButtonGroup"));

var useButton_1 = __importDefault(require("./useButton"));

require("./button.less");
/**
 * Button 展示组件
 * @param props
 */


var Button = function Button(props, ref) {
  var _a = useButton_1["default"](props),
      clazzName = _a.clazzName,
      animatClazz = _a.animatClazz,
      handleClick = _a.handleClick,
      handleMouseDown = _a.handleMouseDown;

  var _b = props.htmlType,
      htmlType = _b === void 0 ? 'button' : _b,
      _c = props.title,
      title = _c === void 0 ? '' : _c,
      children = props.children,
      _d = props.name,
      name = _d === void 0 ? '' : _d,
      _e = props.icon,
      icon = _e === void 0 ? '' : _e,
      _f = props.iconStyleExtra,
      iconStyleExtra = _f === void 0 ? {} : _f,
      _g = props.iconRight,
      iconRight = _g === void 0 ? false : _g,
      _h = props.loading,
      loading = _h === void 0 ? false : _h;

  var togglePosition = function togglePosition(e1, e2, b) {
    if (b) {
      return react_1["default"].createElement(react_1["default"].Fragment, null, e1, e2);
    } else {
      return react_1["default"].createElement(react_1["default"].Fragment, null, e2, e1);
    }
  };

  var _icon = loading ? 'loading' : icon;

  return react_1["default"].createElement("button", {
    ref: ref,
    type: htmlType,
    className: clazzName,
    "data-animate": animatClazz,
    onClick: handleClick,
    onMouseDown: handleMouseDown,
    title: title
  }, togglePosition(!!children || !!name ? react_1["default"].createElement("span", null, " ", children || name, " ") : null, _icon ? react_1["default"].createElement("i", {
    className: classnames_1["default"]('iconfont', "icon-" + _icon),
    style: iconStyleExtra
  }) : null, iconRight));
};

var RefButton = react_1["default"].forwardRef(Button);
RefButton.List = ButtonList_1["default"];
RefButton.Group = ButtonGroup_1["default"];
exports["default"] = RefButton;