"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = require("react");

var classnames_1 = __importDefault(require("classnames"));
/**
 * Button Hook
 * @param param0
 */


var useButton = function useButton(_a) {
  var _b;

  var _c = _a.prefixCls,
      prefixCls = _c === void 0 ? 'ult' : _c,
      _d = _a.name,
      name = _d === void 0 ? '' : _d,
      _e = _a.icon,
      icon = _e === void 0 ? '' : _e,
      _f = _a.type,
      type = _f === void 0 ? 'default' : _f,
      _g = _a.size,
      size = _g === void 0 ? 'medium' : _g,
      _h = _a.disabled,
      disabled = _h === void 0 ? false : _h,
      _j = _a.block,
      block = _j === void 0 ? false : _j,
      _k = _a.loading,
      loading = _k === void 0 ? false : _k,
      _l = _a.className,
      className = _l === void 0 ? '' : _l,
      children = _a.children,
      onClick = _a.onClick,
      onMouseDown = _a.onMouseDown;
  var originClazzName = classnames_1["default"]((_b = {}, _b[prefixCls + "-btn"] = true, _b[prefixCls + "-btn-" + type] = !!type, _b[prefixCls + "-btn-" + size] = !!size, _b[prefixCls + "-icon-only"] = !children && !name && (icon || loading), _b[prefixCls + "-btn-block"] = block, _b[prefixCls + "-btn-disabled"] = disabled, _b[prefixCls + "-btn-loading"] = loading, _b), className);

  var _m = react_1.useState(false),
      btnClicked = _m[0],
      setBtnClicked = _m[1];

  var _o = react_1.useState(''),
      animatClazz = _o[0],
      setAnimatClazz = _o[1];

  var handleClick = function handleClick(e) {
    if (type !== 'text') {
      setBtnClicked(true);
    }

    if (onClick && !disabled) {
      onClick(e);
    }
  };

  var handleMouseDown = function handleMouseDown(e) {
    if (onMouseDown && !disabled) {
      onMouseDown(e);
    }
  };

  react_1.useEffect(function () {
    if (btnClicked && !disabled) {
      setAnimatClazz('btn-clicked');
    } else {
      setAnimatClazz('');
    }
  }, [btnClicked, disabled]);
  react_1.useEffect(function () {
    var timer;

    if (btnClicked) {
      timer = setTimeout(function () {
        setBtnClicked(false);

        if (timer) {
          clearTimeout(timer);
        }
      }, 400);
    }

    return function () {
      if (timer) {
        clearTimeout(timer);
      }
    };
  }, [btnClicked]);
  return {
    clazzName: originClazzName,
    animatClazz: animatClazz,
    handleClick: handleClick,
    handleMouseDown: handleMouseDown
  };
};

exports["default"] = useButton;