import React from 'react';
import 'rc-calendar/assets/index.css';
import { Moment } from 'moment';
import 'moment/locale/zh-cn';
import 'moment/locale/en-gb';
import './calendar.less';
export interface CalendarProps {
    prefixCls?: string;
    className?: string;
    fullscreen?: boolean;
    defaultValue?: Moment;
    value?: Moment;
    defaultType?: 'date' | 'month' | undefined;
    type?: 'date' | 'month' | undefined;
    onChange?: (value: Moment) => void;
    onSelect?: (value: Moment) => void;
    onTypeChange?: (type: string) => void;
    monthCellRender?: (date: Moment) => React.ReactNode;
    dateCellRender?: (date: Moment) => React.ReactNode;
    monthCellContentRender?: (date: Moment) => React.ReactNode;
    dateCellContentRender?: (date: Moment) => React.ReactNode;
    disabledDate?: (current: Moment) => boolean;
}
/**
 * Calendar 展示组件
 * @param props
 */
declare const Calendar: (props: CalendarProps) => JSX.Element;
export default Calendar;
