"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var FullCalendar_1 = __importDefault(require("rc-calendar/lib/FullCalendar"));

require("rc-calendar/assets/index.css");

var zh_CN_1 = __importDefault(require("rc-calendar/lib/locale/zh_CN"));

var en_GB_1 = __importDefault(require("rc-calendar/lib/locale/en_GB"));

require("moment/locale/zh-cn");

require("moment/locale/en-gb");

var Select_1 = __importDefault(require("../Select"));

var useCalendar_1 = __importDefault(require("./useCalendar"));

require("./calendar.less"); // 国际化


var locale = window.LangCode || 'en';
var localData = locale === 'zh_CN' ? zh_CN_1["default"] : en_GB_1["default"];
/**
 * Calendar 展示组件
 * @param props
 */

var Calendar = function Calendar(props) {
  var _a = useCalendar_1["default"](props),
      currentValue = _a.currentValue,
      currentType = _a.currentType,
      handleChange = _a.handleChange,
      handleSelect = _a.handleSelect,
      handleTypeChange = _a.handleTypeChange;

  var _b = props.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      _c = props.className,
      className = _c === void 0 ? '' : _c,
      _d = props.fullscreen,
      fullscreen = _d === void 0 ? false : _d,
      _e = props.defaultValue,
      defaultValue = _e === void 0 ? undefined : _e,
      _f = props.defaultType,
      defaultType = _f === void 0 ? 'date' : _f,
      _g = props.monthCellRender,
      monthCellRender = _g === void 0 ? undefined : _g,
      _h = props.dateCellRender,
      dateCellRender = _h === void 0 ? undefined : _h,
      _j = props.monthCellContentRender,
      monthCellContentRender = _j === void 0 ? undefined : _j,
      _k = props.dateCellContentRender,
      dateCellContentRender = _k === void 0 ? undefined : _k,
      _l = props.disabledDate,
      disabledDate = _l === void 0 ? undefined : _l;
  var classes = classnames_1["default"](prefixCls + "-fullCalendar", className);
  return react_1["default"].createElement("div", {
    className: classes,
    style: {
      zIndex: 1000,
      position: 'relative'
    }
  }, react_1["default"].createElement(FullCalendar_1["default"], {
    style: {
      margin: 10
    },
    Select: Select_1["default"],
    fullscreen: fullscreen,
    onChange: handleChange,
    onSelect: handleSelect,
    defaultValue: defaultValue,
    locale: localData,
    value: currentValue,
    defaultType: defaultType,
    type: currentType,
    onTypeChange: handleTypeChange,
    monthCellRender: monthCellRender,
    dateCellRender: dateCellRender,
    monthCellContentRender: monthCellContentRender,
    dateCellContentRender: dateCellContentRender,
    disabledDate: disabledDate
  }));
};

exports["default"] = Calendar;