"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = require("react");
/**
 * Calendar Hook
 * @param param0
 */


var useCalendar = function useCalendar(_a) {
  var _b = _a.value,
      value = _b === void 0 ? undefined : _b,
      _c = _a.defaultValue,
      defaultValue = _c === void 0 ? undefined : _c,
      _d = _a.type,
      type = _d === void 0 ? 'date' : _d,
      _e = _a.defaultType,
      defaultType = _e === void 0 ? 'date' : _e,
      _f = _a.onChange,
      onChange = _f === void 0 ? undefined : _f,
      _g = _a.onSelect,
      onSelect = _g === void 0 ? undefined : _g,
      _h = _a.onTypeChange,
      onTypeChange = _h === void 0 ? undefined : _h;

  var _j = react_1.useState(value || defaultValue),
      currentValue = _j[0],
      setCurrentValue = _j[1];

  var _k = react_1.useState(type || defaultType),
      currentType = _k[0],
      setCurrentType = _k[1];

  function handleSelect(value) {
    if (onSelect) {
      onSelect(value);
    }
  }

  function handleTypeChange(type) {
    setCurrentType(type);

    if (onTypeChange) {
      onTypeChange(type);
    }
  }

  function handleChange(value) {
    setCurrentValue(value);

    if (onChange) {
      onChange(value);
    }
  }

  react_1.useEffect(function () {
    setCurrentValue(value || defaultValue);
  }, [value, defaultValue]);
  react_1.useEffect(function () {
    setCurrentType(type || defaultType);
  }, [type, defaultType]);
  return {
    currentValue: currentValue,
    currentType: currentType,
    handleChange: handleChange,
    handleSelect: handleSelect,
    handleTypeChange: handleTypeChange
  };
};

exports["default"] = useCalendar;