"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var useCheckBox_1 = __importDefault(require("./useCheckBox"));

require("./checkBox.less");
/**
 * CheckBox 展示组件
 * @param props
 */


var CheckBox = function CheckBox(props) {
  var _a;

  var _b = useCheckBox_1["default"](props),
      currentChecked = _b.currentChecked,
      handleChange = _b.handleChange,
      handleClick = _b.handleClick;

  var _c = props.inline,
      inline = _c === void 0 ? false : _c,
      _d = props.title,
      title = _d === void 0 ? '' : _d,
      _e = props.disabled,
      disabled = _e === void 0 ? false : _e,
      _f = props.labelTitle,
      labelTitle = _f === void 0 ? '' : _f,
      _g = props.prefixCls,
      prefixCls = _g === void 0 ? 'ult' : _g,
      _h = props.className,
      className = _h === void 0 ? '' : _h,
      _j = props.btnStyle,
      btnStyle = _j === void 0 ? false : _j,
      _k = props.checkStyle,
      checkStyle = _k === void 0 ? false : _k,
      _l = props.value,
      value = _l === void 0 ? '' : _l;
  var classes = classnames_1["default"](prefixCls + "-checkbox", className, (_a = {}, _a[prefixCls + "-checkbox-inline"] = inline, _a['checked'] = currentChecked, _a['disabled'] = disabled, _a));
  var tip = labelTitle || (typeof title === 'string' ? title : '') || '';

  if (btnStyle) {
    return react_1["default"].createElement("label", {
      title: tip,
      className: classnames_1["default"](prefixCls + "-btn", {
        'checked': currentChecked,
        'disabled': disabled
      })
    }, react_1["default"].createElement("input", {
      type: "checkbox",
      checked: currentChecked,
      name: name,
      value: value,
      onChange: handleChange,
      disabled: disabled
    }), title);
  }

  if (checkStyle) {
    return react_1["default"].createElement("label", {
      title: tip,
      className: classnames_1["default"](prefixCls + "-check-type-btn", {
        'checked': currentChecked,
        'disabled': disabled
      })
    }, react_1["default"].createElement("input", {
      type: "checkbox",
      checked: currentChecked,
      name: name,
      value: value,
      onChange: handleChange,
      disabled: disabled
    }), react_1["default"].createElement("div", {
      className: classnames_1["default"]("active-box", {
        'hidden': !currentChecked
      })
    }, react_1["default"].createElement("div", {
      className: "active-box-selected-container"
    }), react_1["default"].createElement("i", {
      className: "iconfont icon-correct"
    })), title);
  }

  return react_1["default"].createElement("label", {
    title: tip,
    className: classes
  }, react_1["default"].createElement("span", {
    className: prefixCls + "-checkbox-inner " + prefixCls + "-checkbox-type"
  }), react_1["default"].createElement("input", {
    type: "checkbox",
    onClick: handleClick,
    checked: currentChecked,
    name: name,
    value: value,
    onChange: handleChange,
    disabled: disabled
  }), title);
};

exports["default"] = CheckBox;