"use strict";

var __createBinding = void 0 && (void 0).__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = void 0 && (void 0).__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = void 0 && (void 0).__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var CheckBox_1 = __importDefault(require("./CheckBox"));

var useCheckboxGroup_1 = __importStar(require("./useCheckboxGroup"));

require("./checkBox.less");
/**
 * CheckboxGroup 展示组件
 * @param props
 */


var CheckboxGroup = react_1.forwardRef(function (props, ref) {
  var _a = useCheckboxGroup_1["default"](props),
      checkedItems = _a.checkedItems,
      classes = _a.classes,
      handleChange = _a.handleChange;

  var items = props.items,
      _b = props.inline,
      inline = _b === void 0 ? false : _b,
      _c = props.btnStyle,
      btnStyle = _c === void 0 ? false : _c,
      _d = props.checkStyle,
      checkStyle = _d === void 0 ? false : _d,
      _e = props.name,
      name = _e === void 0 ? 'radioGroup' : _e;
  return react_1["default"].createElement("div", {
    className: classes,
    ref: ref
  }, items.map(function (item) {
    return react_1["default"].createElement(CheckBox_1["default"], {
      key: item.id || item.value,
      id: item.id || item.value,
      name: name,
      value: item.id || item.value,
      title: item.name || item.title,
      labelTitle: item.labelTitle || '',
      disabled: item.disabled || false,
      checked: useCheckboxGroup_1.handleChecked(checkedItems, item.value) || false,
      onChange: handleChange,
      inline: inline,
      btnStyle: btnStyle,
      checkStyle: checkStyle
    });
  }));
});
exports["default"] = CheckboxGroup;