"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var useRadio_1 = __importDefault(require("./useRadio"));

require("./checkBox.less");
/**
 * Radio 展示组件
 * @param props
 */


var Radio = function Radio(props) {
  var _a;

  var _b = useRadio_1["default"](props),
      handleChange = _b.handleChange,
      handleClick = _b.handleClick;

  var _c = props.title,
      title = _c === void 0 ? '' : _c,
      _d = props.inline,
      inline = _d === void 0 ? false : _d,
      _e = props.disabled,
      disabled = _e === void 0 ? false : _e,
      _f = props.checked,
      checked = _f === void 0 ? false : _f,
      _g = props.prefixCls,
      prefixCls = _g === void 0 ? 'ult' : _g,
      _h = props.className,
      className = _h === void 0 ? '' : _h,
      _j = props.btnStyle,
      btnStyle = _j === void 0 ? false : _j,
      _k = props.checkStyle,
      checkStyle = _k === void 0 ? false : _k,
      _l = props.value,
      value = _l === void 0 ? '' : _l,
      _m = props.labelTitle,
      labelTitle = _m === void 0 ? '' : _m;
  var classes = classnames_1["default"](prefixCls + "-checkbox", className, (_a = {}, _a[prefixCls + "-checkbox-inline"] = inline, _a['checked'] = checked, _a['disabled'] = disabled, _a));
  var tip = labelTitle || (typeof title === 'string' ? title : '') || '';

  if (btnStyle) {
    return react_1["default"].createElement("label", {
      title: tip,
      className: classnames_1["default"](prefixCls + "-btn", {
        'checked': checked,
        'disabled': disabled
      })
    }, react_1["default"].createElement("input", {
      type: "radio",
      checked: checked,
      name: name,
      value: value,
      onChange: handleChange,
      disabled: disabled
    }), title);
  }

  if (checkStyle) {
    return react_1["default"].createElement("label", {
      title: tip,
      className: classnames_1["default"](prefixCls + "-check-type-btn", {
        'checked': checked,
        'disabled': disabled
      })
    }, react_1["default"].createElement("input", {
      type: "radio",
      checked: checked,
      name: name,
      value: value,
      onChange: handleChange,
      disabled: disabled
    }), react_1["default"].createElement("div", {
      className: classnames_1["default"]("active-box", {
        'hidden': !checked
      })
    }, react_1["default"].createElement("div", {
      className: "active-box-selected-container"
    }), react_1["default"].createElement("i", {
      className: 'iconfont icon-correct'
    })), title);
  }

  return react_1["default"].createElement("label", {
    title: tip,
    className: classes
  }, react_1["default"].createElement("span", {
    className: prefixCls + "-checkbox-inner " + prefixCls + "-radio-type"
  }), react_1["default"].createElement("input", {
    type: "radio",
    onClick: handleClick,
    checked: checked,
    name: name,
    value: value,
    onChange: handleChange,
    disabled: disabled
  }), title);
};

exports["default"] = Radio;