"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = require("react");
/**
 * CheckBox Hook
 * @param param0
 */


var useCheckBox = function useCheckBox(_a) {
  var _b = _a.checked,
      checked = _b === void 0 ? false : _b,
      _c = _a.defaultChecked,
      defaultChecked = _c === void 0 ? false : _c,
      _d = _a.disabled,
      disabled = _d === void 0 ? false : _d,
      _e = _a.onChange,
      onChange = _e === void 0 ? undefined : _e,
      _f = _a.onToggle,
      onToggle = _f === void 0 ? undefined : _f,
      _g = _a.onClick,
      onClick = _g === void 0 ? undefined : _g;

  var _h = react_1.useState(checked || defaultChecked),
      currentChecked = _h[0],
      setCurrentChecked = _h[1];

  var handleChange = function handleChange(e) {
    if (disabled) {
      return;
    }

    setCurrentChecked(e.target.checked);

    if (onChange) {
      onChange(e.currentTarget.value);
    }

    if (onToggle) {
      onToggle(e.target.checked);
    }
  };

  var handleClick = function handleClick(e) {
    if (onClick) {
      onClick(e);
    }
  };

  react_1.useEffect(function () {
    setCurrentChecked(checked || defaultChecked);
  }, [checked, defaultChecked]);
  return {
    currentChecked: currentChecked,
    handleChange: handleChange,
    handleClick: handleClick
  };
};

exports["default"] = useCheckBox;