"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleChecked = void 0;

var react_1 = require("react");

var classnames_1 = __importDefault(require("classnames"));

function handleChecked(checkedItems, item) {
  if (checkedItems.length) {
    var targIndex = checkedItems.findIndex(function (value) {
      return value === item;
    });
    return targIndex > -1;
  }
}

exports.handleChecked = handleChecked;
/**
 * CheckboxGroup Hook
 * @param param0
 */

var useCheckboxGroup = function useCheckboxGroup(_a) {
  var _b;

  var _c = _a.defaultValue,
      defaultValue = _c === void 0 ? [] : _c,
      _d = _a.onChange,
      onChange = _d === void 0 ? undefined : _d,
      _e = _a.prefixCls,
      prefixCls = _e === void 0 ? 'ult' : _e,
      _f = _a.btnStyle,
      btnStyle = _f === void 0 ? false : _f,
      _g = _a.checkStyle,
      checkStyle = _g === void 0 ? false : _g,
      _h = _a.inline,
      inline = _h === void 0 ? false : _h,
      _j = _a.className,
      className = _j === void 0 ? '' : _j;

  var _k = react_1.useState(defaultValue || []),
      checkedItems = _k[0],
      setCheckedItems = _k[1];

  var classes = classnames_1["default"]((_b = {}, _b[prefixCls + "-checkbox-group"] = !btnStyle && !checkStyle, _b[prefixCls + "-btn-group"] = btnStyle && inline, _b[prefixCls + "-btn-group-vertical"] = btnStyle && !inline, _b[prefixCls + "-check-btn-group"] = checkStyle, _b), className);

  var handleChange = function handleChange(value) {
    var values = checkedItems;
    var decide = handleChecked(values, value);
    var newValue;

    if (decide) {
      newValue = values.filter(function (item) {
        return item !== value;
      });
    } else {
      newValue = values.concat(value);
    }

    setCheckedItems(newValue);

    if (onChange) {
      onChange(newValue);
    }
  };

  react_1.useEffect(function () {
    setCheckedItems(defaultValue);
  }, [defaultValue]);
  return {
    checkedItems: checkedItems,
    classes: classes,
    handleChange: handleChange
  };
};

exports["default"] = useCheckboxGroup;