"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = require("react");

var classnames_1 = __importDefault(require("classnames"));
/**
 * RadioGroup Hook
 * @param param0
 */


var useRadioGroup = function useRadioGroup(_a) {
  var _b;

  var _c = _a.defaultValue,
      defaultValue = _c === void 0 ? '' : _c,
      items = _a.items,
      _d = _a.setValue,
      setValue = _d === void 0 ? '' : _d,
      _e = _a.onChange,
      onChange = _e === void 0 ? undefined : _e,
      _f = _a.prefixCls,
      prefixCls = _f === void 0 ? 'ult' : _f,
      _g = _a.btnStyle,
      btnStyle = _g === void 0 ? false : _g,
      _h = _a.checkStyle,
      checkStyle = _h === void 0 ? false : _h,
      _j = _a.inline,
      inline = _j === void 0 ? false : _j,
      _k = _a.className,
      className = _k === void 0 ? '' : _k;

  var _l = react_1.useState(defaultValue || ''),
      checked = _l[0],
      setChecked = _l[1];

  var classes = classnames_1["default"]((_b = {}, _b[prefixCls + "-radio-group"] = !btnStyle && !checkStyle, _b[prefixCls + "-btn-group"] = btnStyle && inline, _b[prefixCls + "-btn-group-vertical"] = btnStyle && !inline, _b[prefixCls + "-check-btn-group"] = checkStyle, _b), className);

  var handleChange = function handleChange(value) {
    setChecked(value);

    if (onChange) {
      onChange(value);
    }
  };

  react_1.useEffect(function () {
    setChecked(defaultValue || setValue);
  }, [defaultValue, items, setValue]);
  return {
    checked: checked,
    classes: classes,
    handleChange: handleChange
  };
};

exports["default"] = useRadioGroup;