"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __createBinding = void 0 && (void 0).__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = void 0 && (void 0).__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = void 0 && (void 0).__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
/* eslint react/jsx-handler-names: 0 */

/**
 * @Author: SiMeiyu
 * @Date: 2017-07-04 09:59:38
 */

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var Input_1 = __importDefault(require("../Input"));

require("rc-calendar/assets/index.css");

var rc_calendar_1 = __importDefault(require("rc-calendar"));

var Picker_1 = __importDefault(require("rc-calendar/lib/Picker"));

var zh_CN_1 = __importDefault(require("rc-calendar/lib/locale/zh_CN"));

var en_GB_1 = __importDefault(require("rc-calendar/lib/locale/en_GB"));

require("rc-time-picker/assets/index.css");

var Panel_1 = __importDefault(require("rc-time-picker/lib/Panel"));

require("./datePicker.less");

var moment_1 = __importDefault(require("moment"));

require("moment/locale/zh-cn");

require("moment/locale/en-gb");

var language_1 = __importDefault(require("./language"));

var MonthPicker_1 = __importDefault(require("./MonthPicker"));

var RangePicker_1 = __importDefault(require("./RangePicker")); // 国际化


var locale = window.LangCode || 'en';
var localeMap = {
  'en': 'en-gb',
  'zh_CN': 'zh-cn'
};
var localData = locale === 'zh_CN' ? zh_CN_1["default"] : en_GB_1["default"];
var now = moment_1["default"]();
moment_1["default"].locale(localeMap[locale]); // now.locale('zh-cn').utcOffset(8)

now.locale(localeMap[locale]).utcOffset(8); // const defaultCalendarValue = now.clone()
// defaultCalendarValue.add(-1, 'month');

function myDisabledTime(cur) {
  if (cur) {
    var date = moment_1["default"]();

    if (date.valueOf() < cur.valueOf()) {
      return null;
    } else {
      var hh = date.hour();
      var disabledHH_1 = [];

      for (var i = 0; i < hh; i++) {
        disabledHH_1.push(i);
      }

      return {
        disabledHours: function disabledHours() {
          return disabledHH_1;
        }
      };
    }
  }
}

function myDisabledDate(current) {
  if (!current) {
    // allow empty select
    return false;
  } // can not select days before today


  return moment_1["default"](current.format('YYYY-MM-DD')).isBefore(moment_1["default"]().format('YYYY-MM-DD'));
}

var getFormat = function getFormat(time, format) {
  var _format = time ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD';

  return format ? format : _format;
};

var renderTimePicker = function renderTimePicker(props) {
  return react_1["default"].createElement(Panel_1["default"], __assign({}, props.timePickerOption, {
    defaultValue: moment_1["default"]('00:00:00', 'HH:mm:ss')
  }));
};

var renderCalendar = function renderCalendar(props) {
  var _a = props.prefixCls,
      prefixCls = _a === void 0 ? 'ult' : _a,
      _b = props.showTime,
      showTime = _b === void 0 ? false : _b,
      _c = props.showDateInput,
      showDateInput = _c === void 0 ? false : _c,
      _d = props.isDisabledBefore,
      isDisabledBefore = _d === void 0 ? true : _d,
      disabledDate = props.disabledDate,
      _e = props.showToday,
      showToday = _e === void 0 ? true : _e,
      format = props.format;
  var renderFooter;

  if (!showToday) {
    renderFooter = function renderFooter() {
      return react_1["default"].createElement("div", {
        className: "footer-no-today"
      }, language_1["default"][window.LangCode]['Today']);
    };
  }

  return react_1["default"].createElement(rc_calendar_1["default"], {
    className: prefixCls + "-datePicker-calendar",
    locale: localData,
    style: {
      zIndex: 1000
    },
    dateInputPlaceholder: "\u8BF7\u8F93\u5165...",
    formatter: getFormat(showTime, format),
    disabledDate: isDisabledBefore ? myDisabledDate : disabledDate,
    disabledTime: showTime ? myDisabledTime : null,
    timePicker: showTime ? renderTimePicker(props) : null,
    // defaultValue={defaultCalendarValue}
    showDateInput: showDateInput,
    defaultValue: now,
    showToday: showToday,
    renderFooter: renderFooter
  });
};

var DatePicker = function DatePicker(props) {
  var _a = props.prefixCls,
      prefixCls = _a === void 0 ? 'ult' : _a,
      _b = props.className,
      className = _b === void 0 ? '' : _b,
      _c = props.placeholder,
      placeholder = _c === void 0 ? locale === 'zh_CN' ? '请选择日期' : 'Select Date' : _c,
      _d = props.icon,
      icon = _d === void 0 ? '' : _d,
      _e = props.iconRight,
      iconRight = _e === void 0 ? false : _e,
      _f = props.disabled,
      disabled = _f === void 0 ? false : _f,
      _g = props.showTime,
      showTime = _g === void 0 ? false : _g,
      _h = props.getCalendarContainer,
      getCalendarContainer = _h === void 0 ? null : _h,
      format = props.format,
      defaultValue = props.defaultValue;
  var classes = classnames_1["default"](prefixCls + "-datePicker-input", className);

  var _j = react_1.useState(defaultValue),
      value = _j[0],
      setValue = _j[1];

  var onChange = function onChange(value) {
    setValue(value);

    if (props.onChange) {
      props.onChange(value && value.format(getFormat(showTime, format)));
    }
  };

  react_1.useEffect(function () {
    setValue(defaultValue);
  }, [defaultValue]);
  return react_1["default"].createElement(Picker_1["default"], {
    animation: "slide-up",
    disabled: disabled,
    calendar: renderCalendar(props),
    value: value,
    onChange: onChange,
    getCalendarContainer: getCalendarContainer
  }, function (_a) {
    var value = _a.value;
    return react_1["default"].createElement(Input_1["default"], {
      className: classes,
      placeholder: placeholder,
      value: value && value.format(getFormat(showTime, format)) || '',
      icon: icon,
      iconRight: iconRight,
      disabled: disabled,
      readOnly: true
    });
  });
};

DatePicker.RangePicker = RangePicker_1["default"];
DatePicker.MonthPicker = MonthPicker_1["default"];
exports["default"] = DatePicker;