"use strict";

var __createBinding = void 0 && (void 0).__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = void 0 && (void 0).__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = void 0 && (void 0).__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
/* eslint react/jsx-handler-names: 0 */

/*
 * @Author: SiMeiyu
 * @Date: 2017-07-04 09:59:49
 */

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var Input_1 = __importDefault(require("../Input"));

require("rc-calendar/assets/index.css");

var MonthCalendar_1 = __importDefault(require("rc-calendar/lib/MonthCalendar"));

var Picker_1 = __importDefault(require("rc-calendar/lib/Picker"));

var zh_CN_1 = __importDefault(require("rc-calendar/lib/locale/zh_CN"));

var en_GB_1 = __importDefault(require("rc-calendar/lib/locale/en_GB"));

var moment_1 = __importDefault(require("moment"));

require("moment/locale/zh-cn");

require("moment/locale/en-gb");

var format = 'YYYY-MM'; // 国际化

var locale = window.LangCode || 'en';
var localeMap = {
  'en': 'en-gb',
  'zh_CN': 'zh-cn'
};
var localData = locale === 'zh_CN' ? zh_CN_1["default"] : en_GB_1["default"];
var now = moment_1["default"](); // now.locale('zh-cn').utcOffset(8)

now.locale(localeMap[locale]).utcOffset(8);
var defaultCalendarValue = now.clone(); // defaultCalendarValue.add(-1, 'month');

function disabledDate(current) {
  if (!current) {
    // allow empty select
    return false;
  }

  var date = moment_1["default"]();
  return (current.year() < date.year() || current.year() === date.year()) && current.month() < date.month(); // can not select days before today
}

var renderCalendar = function renderCalendar(props) {
  var _a = props.prefixCls,
      prefixCls = _a === void 0 ? 'ult' : _a,
      _b = props.isDisabledBefore,
      isDisabledBefore = _b === void 0 ? true : _b;
  return react_1["default"].createElement(MonthCalendar_1["default"], {
    className: prefixCls + "-monthPicker-calendar",
    defaultValue: defaultCalendarValue,
    disabledDate: isDisabledBefore ? disabledDate : null,
    locale: localData,
    style: {
      zIndex: 1000
    }
  });
};

var MonthPicker = function MonthPicker(props) {
  var _a = props.prefixCls,
      prefixCls = _a === void 0 ? 'ult' : _a,
      _b = props.className,
      className = _b === void 0 ? '' : _b,
      _c = props.icon,
      icon = _c === void 0 ? '' : _c,
      _d = props.iconRight,
      iconRight = _d === void 0 ? false : _d,
      _e = props.disabled,
      disabled = _e === void 0 ? false : _e,
      _f = props.placeholder,
      placeholder = _f === void 0 ? '请选择月份' : _f,
      defaultValue = props.defaultValue,
      _g = props.getCalendarContainer,
      getCalendarContainer = _g === void 0 ? null : _g;
  var classes = classnames_1["default"](prefixCls + "-monthPicker-input", className);

  var _h = react_1.useState(defaultValue),
      value = _h[0],
      setValue = _h[1];

  var onChange = function onChange(value) {
    setValue(value);

    if (props.onChange) {
      props.onChange(value && value.format(format));
    }
  };

  react_1.useEffect(function () {
    setValue(defaultValue);
  }, [defaultValue]);
  return react_1["default"].createElement(Picker_1["default"], {
    animation: "slide-up",
    disabled: disabled,
    calendar: renderCalendar(props),
    value: value,
    onChange: onChange,
    getCalendarContainer: getCalendarContainer
  }, function (_a) {
    var value = _a.value;
    return react_1["default"].createElement(Input_1["default"], {
      className: classes,
      readOnly: true,
      disabled: disabled,
      value: value && value.format(format) || '',
      placeholder: placeholder,
      icon: icon,
      iconRight: iconRight
    });
  });
};

exports["default"] = MonthPicker;