"use strict";
/*
 * @Author: SiMeiyu
 * @Date: 2017-07-04 09:59:54
 */

var __createBinding = void 0 && (void 0).__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = void 0 && (void 0).__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = void 0 && (void 0).__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames")); // import 'rc-calendar/assets/index.css';


var RangeCalendar_1 = __importDefault(require("rc-calendar/lib/RangeCalendar"));

var Picker_1 = __importDefault(require("rc-calendar/lib/Picker"));

var zh_CN_1 = __importDefault(require("rc-calendar/lib/locale/zh_CN"));

var en_GB_1 = __importDefault(require("rc-calendar/lib/locale/en_GB")); // import 'rc-time-picker/assets/index.css';


var Panel_1 = __importDefault(require("rc-time-picker/lib/Panel"));

require("./datePicker.less");

var moment_1 = __importDefault(require("moment"));

require("moment/locale/zh-cn");

require("moment/locale/en-gb");

var lodash_1 = __importDefault(require("lodash"));

var formatStr = 'YYYY-MM-DD HH:mm:ss'; // 国际化

var locale = window.LangCode || 'en';
var localeMap = {
  'en': 'en-gb',
  'zh_CN': 'zh-cn'
};
var localData = locale === 'zh_CN' ? zh_CN_1["default"] : en_GB_1["default"];

function getFormat(time) {
  return time ? formatStr : 'YYYY-MM-DD';
}

var now = moment_1["default"](); // now.locale('zh-cn').utcOffset(8)

now.locale(localeMap[locale]).utcOffset(8); // const defaultCalendarValue = now.clone()
// defaultCalendarValue.add(-1, 'month');

var timePickerElement = react_1["default"].createElement(Panel_1["default"], {
  defaultValue: [moment_1["default"]('00:00:00', 'HH:mm:ss'), moment_1["default"]('23:59:59', 'HH:mm:ss')]
});

function myDisabledDate(current) {
  if (!current) {
    // allow empty select
    return false;
  }

  var date = moment_1["default"]();
  date.hour(0);
  date.minute(0);
  date.second(0);
  return current.isBefore(date); // can not select days before today
}

function format(v, time) {
  return v ? v.format(getFormat(time)) : '';
}
/**
 * 校验range数据结构：满足以下任一条件：
 * 1、空数组
 * 2、包含两个元素且每个元素都是'yyyy-MM-dd'格式的字符串
 * 3、包含两个元素且每个元素都是moment日期对象
 *
 * @param {Array} value
 */


var isValidDate = function isValidDate(value) {
  if (lodash_1["default"].isArray(value)) {
    if (value.length === 0) {
      return true;
    }

    if (value.length === 2) {
      var pattern_1 = /^([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})$/ig;
      return value.every(function (val) {
        return val instanceof moment_1["default"] || typeof val === 'string' && pattern_1.test(val);
      });
    }
  }

  return false;
};
/**
 * 检验两个range中的每个字符串都相等
 * @param {Array} first
 * @param {Array} second
 */


var isRangeEqual = function isRangeEqual(first, second) {
  if (!(first instanceof Array) || !(second instanceof Array)) {
    return false;
  }

  if (first.length !== second.length) {
    return false;
  }

  return first.every(function (date, index) {
    return date === second[index];
  });
};

var renderInput = function renderInput(props, startValue, endValue) {
  var _a;

  var _b = props.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      _c = props.className,
      className = _c === void 0 ? '' : _c,
      _d = props.icon,
      icon = _d === void 0 ? '' : _d,
      _e = props.iconRight,
      iconRight = _e === void 0 ? false : _e,
      _f = props.disabled,
      disabled = _f === void 0 ? false : _f;
  var classes = classnames_1["default"](prefixCls + "-input " + prefixCls + "-rangePicker-input", (_a = {}, _a[prefixCls + "-rangePicker-input-disabled"] = disabled, _a[prefixCls + "-input-icon"] = !!icon, _a[prefixCls + "-input-icon-right"] = iconRight, _a), className);
  return function () {
    return react_1["default"].createElement("span", {
      className: classes
    }, icon ? react_1["default"].createElement("i", {
      className: "iconfont icon-" + icon
    }) : null, react_1["default"].createElement("input", {
      type: "text",
      className: prefixCls + "-rangePicker-input-start",
      placeholder: "\u5F00\u59CB\u65E5\u671F",
      disabled: disabled,
      readOnly: true,
      value: startValue
    }), react_1["default"].createElement("input", {
      type: "text",
      className: prefixCls + "-rangePicker-input-end",
      placeholder: "\u7ED3\u675F\u65E5\u671F",
      disabled: disabled,
      readOnly: true,
      value: endValue
    }));
  };
};

var renderCalendar = function renderCalendar(props) {
  var _a = props.prefixCls,
      prefixCls = _a === void 0 ? 'ult' : _a,
      _b = props.dateInputPlaceholder,
      dateInputPlaceholder = _b === void 0 ? ['选择开始日期', '选择结束日期'] : _b,
      _c = props.isDisabledBefore,
      isDisabledBefore = _c === void 0 ? false : _c,
      _d = props.showTime,
      showTime = _d === void 0 ? false : _d,
      _e = props.showClear,
      showClear = _e === void 0 ? true : _e,
      _f = props.showToday,
      showToday = _f === void 0 ? false : _f,
      _g = props.showOk,
      showOk = _g === void 0 ? false : _g,
      disabledDate = props.disabledDate;
  return react_1["default"].createElement(RangeCalendar_1["default"], {
    className: prefixCls + "-datePicker-calendar",
    dateInputPlaceholder: dateInputPlaceholder,
    locale: localData,
    formatter: getFormat(showTime),
    defaultValue: [now, now.clone().add(1, 'months')],
    showOk: showOk,
    showToday: showToday,
    showClear: showClear,
    disabledDate: isDisabledBefore ? myDisabledDate : disabledDate,
    // disabledTime={disabledTime}
    timePicker: showTime ? timePickerElement : null
  });
};

var RangePicker = function RangePicker(props) {
  var _a;

  var _b = props.defaultValue,
      defaultValue = _b === void 0 ? [] : _b,
      _c = props.showTime,
      showTime = _c === void 0 ? false : _c,
      _d = props.disabled,
      disabled = _d === void 0 ? false : _d,
      _e = props.onChange,
      onChange = _e === void 0 ? function () {} : _e,
      _f = props.getCalendarContainer,
      getCalendarContainer = _f === void 0 ? null : _f;
  var _startValue = '';
  var _endValue = '';

  if (defaultValue) {
    _a = defaultValue.map(function (date) {
      return format(date, showTime);
    }), _startValue = _a[0], _endValue = _a[1];
  }

  var _g = react_1.useState(defaultValue),
      value = _g[0],
      setValue = _g[1];

  var _h = react_1.useState(_startValue),
      startValue = _h[0],
      setStartValue = _h[1];

  var _j = react_1.useState(_endValue),
      endValue = _j[0],
      setEndValue = _j[1];

  var handleChanged = function handleChanged(value) {
    var startValue1 = isValidDate(value) && format(value[0], showTime) || '';
    var endValue1 = isValidDate(value) && format(value[1], showTime) || '';
    setValue(value);
    setStartValue(startValue1);
    setEndValue(endValue1);

    if ('onChange' in props) {
      onChange([startValue1, endValue1]);
    }
  };

  react_1.useEffect(function () {
    // 检查value参数变化，如果参数有变化，表示外部驱动日期改变
    var newValue = props.value || [];

    if (isValidDate(newValue) && !isRangeEqual(value, newValue)) {
      var _a = newValue.map(function (date) {
        return format(date, showTime);
      }),
          startValue_1 = _a[0],
          endValue_1 = _a[1];

      setValue(newValue);
      setStartValue(startValue_1 || '');
      setEndValue(endValue_1 || '');
    }
  }, [props.value]);
  react_1.useEffect(function () {
    setValue(defaultValue);
    setStartValue(_startValue);
    setEndValue(_endValue);
  }, []);
  return react_1["default"].createElement(Picker_1["default"], {
    value: value,
    disabled: disabled,
    onChange: handleChanged,
    animation: "slide-up",
    calendar: renderCalendar(props),
    getCalendarContainer: getCalendarContainer
  }, renderInput(props, startValue, endValue));
};

exports["default"] = RangePicker;