"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var Dialog_1 = __importDefault(require("./Dialog"));

var lodash_1 = __importDefault(require("lodash"));

var ConfirmDialog = function ConfirmDialog(props) {
  var _a;

  var _b = props.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      _c = props.tips,
      tips = _c === void 0 ? null : _c,
      type = props.type,
      label = props.label,
      content = props.content;
  return react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-ui-confirm", (_a = {}, _a[prefixCls + "-ui-confirm-noicon"] = !!tips, _a))
  }, tips ? react_1["default"].createElement("div", {
    className: prefixCls + "-ui-confirm-tips"
  }, react_1["default"].createElement("i", {
    className: 'iconfont icon-warning-s'
  }), react_1["default"].createElement("div", {
    dangerouslySetInnerHTML: {
      __html: tips
    }
  })) : react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-ui-confirm-icon " + type)
  }, react_1["default"].createElement("i", {
    className: 'iconfont icon-warning-o'
  })), label ? react_1["default"].createElement("p", {
    className: "m-b-sm m-t-md"
  }, label) : null, lodash_1["default"].isString(content) ? react_1["default"].createElement("p", {
    className: prefixCls + "-ui-confirm-one"
  }, content) : lodash_1["default"].isArray(content) ? react_1["default"].createElement("div", {
    className: prefixCls + "-ui-confirm-multi"
  }, content.map(function (item, index) {
    return react_1["default"].createElement("span", {
      key: item.id || index,
      title: item.map || item
    }, item.msg || item);
  })) : react_1["default"].createElement("div", null, content));
};

function createConfirmForm(_a) {
  var content = _a.content,
      type = _a.type,
      label = _a.label,
      tips = _a.tips,
      _b = _a.abortType,
      abortType = _b === void 0 ? 'default' : _b,
      _c = _a.confirmType,
      confirmType = _c === void 0 ? 'primary' : _c,
      otherProps = __rest(_a, ["content", "type", "label", "tips", "abortType", "confirmType"]);

  return Dialog_1["default"](react_1["default"].createElement(ConfirmDialog, {
    content: content,
    type: type,
    label: label,
    tips: tips
  }), __assign({
    style: {
      maxWidth: '600px',
      width: '500px'
    },
    abortType: abortType,
    confirmType: confirmType
  }, otherProps));
}

exports["default"] = createConfirmForm;