import React, { ReactNode } from 'react';
import { SubOption } from './dropdownMenuItem';
import { TooltipPlacement } from '../Tooltip/useTooltip';
import './dropdown.less';
export interface DropdownOption {
    id?: string;
    callback?: (e: React.MouseEvent, name: React.ReactNode) => void;
    name?: ReactNode;
    selected?: boolean;
    disabled?: boolean;
    tooltip?: {
        placement?: TooltipPlacement;
        tips: string;
    };
    href?: string;
    target?: 'blank' | 'parent' | 'self' | 'top';
    subOptions?: SubOption[] | null;
    slot?: () => ReactNode;
    style?: object;
}
export interface DropdownProps {
    className?: string;
    prefixCls?: string;
    options?: DropdownOption[];
    title?: string;
    style?: object;
    btnSize?: 'large' | 'medium' | 'small';
    btnType?: 'primary' | 'default' | 'dashed' | 'success' | 'warning' | 'danger' | 'text';
    placement?: 'topLeft' | 'topRight' | 'topCenter' | 'bottomLeft' | 'bottomRight' | 'bottomCenter';
    trigger?: 'click' | 'hover';
    text?: boolean;
    disabled?: boolean;
    selectable?: boolean;
    icon?: string | null;
}
declare const Dropdown: ({ className, prefixCls, options, title, style, btnSize, btnType, placement, trigger, text, disabled, selectable, icon }: DropdownProps) => JSX.Element;
export default Dropdown;
