"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var dropdownMenu_1 = __importDefault(require("./dropdownMenu"));

var dropdownMenuItem_1 = __importDefault(require("./dropdownMenuItem"));

var useDropdown_1 = require("./useDropdown");

require("./dropdown.less");

var locale = window.LangCode || 'en';
var i18nMap = {
  title: {
    'en': 'dropdown list',
    'zh_CN': '下拉列表'
  }
};

var Dropdown = function Dropdown(_a) {
  var _b = _a.className,
      className = _b === void 0 ? '' : _b,
      _c = _a.prefixCls,
      prefixCls = _c === void 0 ? 'ult' : _c,
      _d = _a.options,
      options = _d === void 0 ? [] : _d,
      _e = _a.title,
      title = _e === void 0 ? i18nMap.title[locale] : _e,
      _f = _a.style,
      style = _f === void 0 ? {} : _f,
      _g = _a.btnSize,
      btnSize = _g === void 0 ? 'medium' : _g,
      _h = _a.btnType,
      btnType = _h === void 0 ? 'default' : _h,
      _j = _a.placement,
      placement = _j === void 0 ? 'bottomLeft' : _j,
      _k = _a.trigger,
      trigger = _k === void 0 ? 'click' : _k,
      _l = _a.text,
      text = _l === void 0 ? false : _l,
      _m = _a.disabled,
      disabled = _m === void 0 ? false : _m,
      _o = _a.selectable,
      selectable = _o === void 0 ? false : _o,
      _p = _a.icon,
      icon = _p === void 0 ? null : _p;

  var _q = useDropdown_1.useDropdown({
    options: options,
    selectable: selectable
  }),
      uniqueID = _q.uniqueID,
      isExpanded = _q.isExpanded,
      handleToggle = _q.handleToggle,
      handleCollapse = _q.handleCollapse,
      optionsState = _q.optionsState,
      handleHover = _q.handleHover,
      handleClick = _q.handleClick;

  return react_1["default"].createElement(dropdownMenu_1["default"], {
    id: uniqueID.current,
    title: title,
    prefixCls: prefixCls,
    selectable: selectable,
    disabled: disabled,
    size: btnSize,
    text: text,
    type: btnType,
    className: className,
    style: style,
    placement: placement,
    trigger: trigger,
    isExpanded: isExpanded,
    icon: icon,
    onToggle: handleToggle,
    onHover: handleHover
  }, optionsState.map(function (item, index) {
    return react_1["default"].createElement(dropdownMenuItem_1["default"], {
      key: item.id || index,
      onClick: handleClick.bind(null, item.callback, item.id || item.name),
      collapse: handleCollapse,
      selected: item.selected,
      disabled: item.disabled,
      tooltip: item.tooltip,
      href: item.href,
      target: item.target,
      subOptions: item.subOptions,
      slot: item.slot,
      style: item.style
    }, item.name);
  }));
};

exports["default"] = Dropdown;