import React, { ReactNode } from 'react';
export interface DropdownMenuProps {
    id: string;
    trigger: 'hover' | 'click';
    title: string;
    prefixCls: string;
    className: string;
    style: object;
    isExpanded: boolean;
    disabled: boolean;
    selectable: boolean;
    text?: boolean;
    onHover: (e: React.MouseEvent, b: boolean) => void;
    onToggle: (e: React.MouseEvent) => void;
    size: 'small' | 'large' | 'medium' | undefined;
    type?: 'text' | 'default' | 'primary' | 'dashed' | 'success' | 'warning' | 'danger' | undefined;
    placement: 'topLeft' | 'topRight' | 'topCenter' | 'bottomLeft' | 'bottomRight' | 'bottomCenter';
    children?: ReactNode;
    icon?: string | null;
}
declare const DropdownMenu: (props: DropdownMenuProps) => JSX.Element;
export default DropdownMenu;
