"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var index_1 = require("../index");

var useDropdown_1 = require("./useDropdown");

var DropdownMenu = function DropdownMenu(props) {
  var _a, _b, _c, _d;

  var id = props.id,
      title = props.title,
      prefixCls = props.prefixCls,
      className = props.className,
      style = props.style,
      isExpanded = props.isExpanded,
      disabled = props.disabled,
      selectable = props.selectable,
      _e = props.text,
      text = _e === void 0 ? false : _e,
      size = props.size,
      _f = props.type,
      type = _f === void 0 ? 'default' : _f,
      _g = props.placement,
      placement = _g === void 0 ? 'bottomLeft' : _g,
      _h = props.children,
      children = _h === void 0 ? null : _h,
      _j = props.icon,
      icon = _j === void 0 ? null : _j;

  var _k = useDropdown_1.useDropdownMenu(props),
      titleIcon = _k.titleIcon,
      handleMouseEnter = _k.handleMouseEnter,
      handleMouseLeave = _k.handleMouseLeave,
      handleTitleClick = _k.handleTitleClick;

  return react_1["default"].createElement("div", {
    id: id,
    className: classnames_1["default"](prefixCls + "-dropdown", (_a = {}, _a[prefixCls + "-dropdown-text"] = text, _a[prefixCls + "-dropdown-selectable"] = selectable, _a), className),
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave
  }, text ? react_1["default"].createElement("a", {
    onClick: handleTitleClick
  }, !icon && title, react_1["default"].createElement(index_1.Icon, {
    type: titleIcon
  })) : react_1["default"].createElement(index_1.Button, {
    type: type,
    name: title,
    icon: titleIcon,
    disabled: disabled,
    size: size,
    onClick: handleTitleClick,
    iconRight: !icon
  }), isExpanded ? react_1["default"].createElement("ul", {
    className: classnames_1["default"](prefixCls + "-dropdown-Menu", (_b = {}, _b[prefixCls + "-dropdown-Menu-" + placement] = !!placement, _b), (_c = {}, _c[prefixCls + "-dropdown-Menu-slide-up"] = placement.includes('bottom'), _c), (_d = {}, _d[prefixCls + "-dropdown-Menu-slide-down"] = placement.includes('top'), _d)),
    style: style
  }, children) : null);
};

exports["default"] = DropdownMenu;