import React, { ReactNode } from 'react';
import { TooltipPlacement } from '../Tooltip/useTooltip';
export interface SubOption {
    selected?: boolean;
    disabled?: boolean;
    href?: string;
    target?: 'blank' | 'parent' | 'self' | 'top';
    callback?: (e: React.MouseEvent, n: ReactNode) => void;
    name: ReactNode;
}
export interface DropdownMenuItemProps {
    children?: ReactNode;
    href?: string;
    target?: 'blank' | 'parent' | 'self' | 'top';
    selected?: boolean;
    disabled?: boolean;
    onClick: (e: React.MouseEvent) => void;
    collapse: (e: React.MouseEvent) => void;
    subOptions?: SubOption[] | null;
    tooltip?: {
        placement?: TooltipPlacement;
        tips: string;
    } | null;
    slot?: () => ReactNode;
    style?: object;
}
declare const DropdownMenuItem: ({ children, href, target, selected, disabled, onClick, collapse, subOptions, tooltip, slot, style }: DropdownMenuItemProps) => JSX.Element;
export default DropdownMenuItem;
