"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var index_1 = require("../index");

var useDropdown_1 = require("./useDropdown");

var locale = window.LangCode || 'en';
var i18nMap = {
  items: {
    'en': 'List Items',
    'zh_CN': '列表项'
  }
};

var DropdownMenuItem = function DropdownMenuItem(_a) {
  var _b = _a.children,
      children = _b === void 0 ? i18nMap.items[locale] : _b,
      _c = _a.href,
      href = _c === void 0 ? '#!' : _c,
      _d = _a.target,
      target = _d === void 0 ? 'self' : _d,
      _e = _a.selected,
      selected = _e === void 0 ? false : _e,
      _f = _a.disabled,
      disabled = _f === void 0 ? false : _f,
      onClick = _a.onClick,
      collapse = _a.collapse,
      _g = _a.subOptions,
      subOptions = _g === void 0 ? null : _g,
      _h = _a.tooltip,
      tooltip = _h === void 0 ? null : _h,
      _j = _a.slot,
      slot = _j === void 0 ? function () {
    return null;
  } : _j,
      _k = _a.style,
      style = _k === void 0 ? {} : _k;

  var _l = useDropdown_1.useDropdownMenuItem({
    disabled: disabled,
    collapse: collapse,
    onClick: onClick,
    href: href,
    target: target
  }),
      handleClick = _l.handleClick,
      handleClickSubItem = _l.handleClickSubItem;

  var titleEle = react_1["default"].createElement("div", {
    className: "link-href",
    onClick: handleClick,
    style: style
  }, selected ? react_1["default"].createElement(index_1.Icon, {
    className: "icon-selected",
    type: "correct"
  }) : null, children, slot && slot(), subOptions ? react_1["default"].createElement("i", {
    className: "iconfont icon-right"
  }) : null);
  return react_1["default"].createElement("li", {
    className: classnames_1["default"]({
      selected: selected,
      disabled: disabled
    })
  }, tooltip ? react_1["default"].createElement(index_1.Tooltip, {
    placement: tooltip.placement || 'left',
    tips: tooltip.tips
  }, titleEle) : titleEle, subOptions && react_1["default"].createElement("ul", {
    className: "sub-menu"
  }, subOptions.map(function (option, index) {
    var _a = option.selected,
        selected = _a === void 0 ? false : _a,
        _b = option.disabled,
        disabled = _b === void 0 ? false : _b,
        href = option.href,
        _c = option.target,
        target = _c === void 0 ? 'self' : _c,
        callback = option.callback,
        name = option.name;
    return react_1["default"].createElement("li", {
      key: index,
      className: classnames_1["default"]({
        selected: selected,
        disabled: disabled
      })
    }, react_1["default"].createElement("div", {
      className: "link-href",
      onClick: handleClickSubItem.bind(null, disabled, callback, name, href, target)
    }, name));
  })));
};

exports["default"] = DropdownMenuItem;