"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _uuid = _interopRequireDefault(require("uuid"));

var _classnames3 = _interopRequireDefault(require("classnames"));

var _formsyReact = _interopRequireDefault(require("formsy-react"));

require("../CheckBox/checkBox.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var HOC = _formsyReact["default"].HOC;

var CheckboxForm = /*#__PURE__*/function (_React$Component) {
  _inherits(CheckboxForm, _React$Component);

  var _super = _createSuper(CheckboxForm);

  function CheckboxForm() {
    _classCallCheck(this, CheckboxForm);

    return _super.apply(this, arguments);
  }

  _createClass(CheckboxForm, [{
    key: "changeValue",
    value: function changeValue(e) {
      this.props.setValue(e.currentTarget.checked);
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames;

      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          title = _this$props.title,
          name = _this$props.name,
          disabled = _this$props.disabled,
          prefixCls = _this$props.prefixCls,
          inline = _this$props.inline,
          offset = _this$props.offset;
      var classes = (0, _classnames3["default"])("".concat(prefixCls, "-checkbox"), className, (_classnames = {}, _defineProperty(_classnames, "".concat(prefixCls, "-checkbox-inline"), inline), _defineProperty(_classnames, 'checked', this.props.getValue()), _defineProperty(_classnames, 'disabled', disabled), _classnames));

      var inputId = _uuid["default"].v4();

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames3["default"])("".concat(prefixCls, "-form-group"), _defineProperty({}, "".concat(prefixCls, "-form-group-offset-label"), offset)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement("label", {
        className: classes,
        htmlFor: inputId
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-checkbox-inner ").concat(prefixCls, "-checkbox-type")
      }), /*#__PURE__*/_react["default"].createElement("input", {
        id: inputId,
        type: "checkbox",
        checked: this.props.getValue() ? 'checked' : null,
        name: name,
        value: this.props.getValue(),
        onChange: this.changeValue.bind(this),
        disabled: disabled
      }), title), this.props.children);
    }
  }]);

  return CheckboxForm;
}(_react["default"].Component);

CheckboxForm.propTypes = {
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  name: _propTypes["default"].string.isRequired,
  disabled: _propTypes["default"].bool,
  inline: _propTypes["default"].bool,
  offset: _propTypes["default"].bool,
  title: _propTypes["default"].string,
  setValue: _propTypes["default"].func.isRequired,
  getValue: _propTypes["default"].func.isRequired,
  children: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].element, _propTypes["default"].node])
};
CheckboxForm.defaultProps = {
  inline: false,
  offset: false,
  disabled: false,
  prefixCls: 'ult',
  className: '',
  style: null,
  title: '',
  children: null
};

var _default = HOC(CheckboxForm);

exports["default"] = _default;