"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames4 = _interopRequireDefault(require("classnames"));

var _formsyReact = _interopRequireDefault(require("formsy-react"));

var _Label = _interopRequireDefault(require("../Label"));

var _Input = _interopRequireDefault(require("../Input"));

var _Button = _interopRequireDefault(require("../Button"));

require("./form.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var HOC = _formsyReact["default"].HOC; // Formsy.addValidationRule('gt', (values, value, num) => value > num);
// Formsy.addValidationRule('gte', (values, value, num) => value >= num);
// Formsy.addValidationRule('lt', (values, value, num) => value < num);
// Formsy.addValidationRule('lte', (values, value, num) => value <= num);
// Formsy.addValidationRule('isIn', (values, value, array) => array.indexOf(value) >= 0);

_formsyReact["default"].addValidationRule('isName', function (values, value, array) {
  var reg = /^[\u4E00-\u9FA5A-Za-z0-9_]+$/g;
  return reg.test(value);
});

_formsyReact["default"].addValidationRule('isPassword', function (values, value, array) {
  var reg = /^[\S]{6,16}$/g;
  return reg.test(value);
});

_formsyReact["default"].addValidationRule('isTel', function (values, value, array) {
  var reg = /^(?:(?:0\d{2,3}[- ]?[1-9]\d{6,7})|(?:[48]00[- ]?[1-9]\d{6}))$/g;
  return reg.test(value);
});

_formsyReact["default"].addValidationRule('isMobile', function (values, value, array) {
  var reg = /^1[3-9]\d{9}$/g;
  return reg.test(value);
});

var InputForm = /*#__PURE__*/function (_React$Component) {
  _inherits(InputForm, _React$Component);

  var _super = _createSuper(InputForm);

  function InputForm(props) {
    var _this;

    _classCallCheck(this, InputForm);

    _this = _super.call(this, props);
    _this.state = {
      validated: false,
      codeBtn: true,
      s: '30'
    };
    return _this;
  }

  _createClass(InputForm, [{
    key: "changeValue",
    value: function changeValue(event) {
      this.props.setValue(event.currentTarget.value);
      var _this$props = this.props,
          showRequired = _this$props.showRequired,
          showError = _this$props.showError,
          getValue = _this$props.getValue;
      var validated = showRequired() ? getValue() === '' : showError();
      this.setState({
        validated: validated
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.timer = null;
    }
  }, {
    key: "issueIdentifyCode",
    value: function issueIdentifyCode() {
      this.setState({
        codeBtn: false
      });
      var Num = '';

      for (var i = 0; i < 6; i++) {
        Num += Math.floor(Math.random() * 10);
      }

      console.log('验证码：', Num);
      this.props.handleIdentifyCode(Num);
      var space = 30;

      this.timer = function () {
        var _this2 = this;

        if (space > 0) {
          this.setState({
            s: space
          });
          space--;
          setTimeout(function () {
            _this2.timer();
          }, 1000);
        } else {
          this.setState({
            codeBtn: true
          });
        }
      };

      this.timer();
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames;

      var _this$props2 = this.props,
          prefixCls = _this$props2.prefixCls,
          className = _this$props2.className,
          style = _this$props2.style,
          name = _this$props2.name,
          type = _this$props2.type,
          label = _this$props2.label,
          isRequired = _this$props2.isRequired,
          readOnly = _this$props2.readOnly,
          disabled = _this$props2.disabled,
          placeholder = _this$props2.placeholder,
          icon = _this$props2.icon,
          autocomplete = _this$props2.autocomplete;
      var _this$state = this.state,
          s = _this$state.s,
          codeBtn = _this$state.codeBtn,
          validated = _this$state.validated;
      var identifyCode = name === 'identifyCode';
      var classes = (0, _classnames4["default"])("".concat(prefixCls, "-form-group"), (_classnames = {}, _defineProperty(_classnames, "".concat(prefixCls, "-form-group-validated"), validated), _defineProperty(_classnames, "required", this.props.showRequired()), _defineProperty(_classnames, "error", this.props.showError()), _classnames), className);
      var errorMessage = this.props.showRequired() ? this.props.getValue() === '' ? "".concat(this.props.label, "\u4E0D\u80FD\u4E3A\u7A7A\u3002") : this.props.getErrorMessage() : this.props.getErrorMessage();
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classes,
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_Label["default"], {
        name: label,
        require: isRequired()
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames4["default"])("".concat(prefixCls, "-form-group-input-wrapper"), _defineProperty({}, "".concat(prefixCls, "-form-group-input-wrapper-identifyCode"), identifyCode))
      }, /*#__PURE__*/_react["default"].createElement(_Input["default"], {
        type: type,
        name: name,
        onChange: this.changeValue.bind(this),
        value: this.props.getValue(),
        disabled: disabled || readOnly,
        placeholder: placeholder,
        icon: icon,
        autocomplete: autocomplete
      }), identifyCode ? /*#__PURE__*/_react["default"].createElement(_Button["default"], {
        className: "btn-identifyCode",
        type: "default",
        name: codeBtn ? '发送验证码' : "\u91CD\u65B0\u53D1\u9001(".concat(s, ")"),
        disabled: !codeBtn,
        onClick: this.issueIdentifyCode.bind(this)
      }) : null, /*#__PURE__*/_react["default"].createElement("span", {
        className: (0, _classnames4["default"])('validation-error', _defineProperty({}, "".concat(prefixCls, "-form-identifyCode-error"), identifyCode))
      }, errorMessage)));
    }
  }]);

  return InputForm;
}(_react["default"].Component);

InputForm.propTypes = {
  className: _propTypes["default"].string,
  prefixCls: _propTypes["default"].string,
  style: _propTypes["default"].object,
  setValue: _propTypes["default"].func.isRequired,
  getValue: _propTypes["default"].func.isRequired,
  showRequired: _propTypes["default"].func.isRequired,
  showError: _propTypes["default"].func.isRequired,
  handleIdentifyCode: _propTypes["default"].func,
  name: _propTypes["default"].string,
  type: _propTypes["default"].string,
  label: _propTypes["default"].string,
  isRequired: _propTypes["default"].func.isRequired,
  readOnly: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  placeholder: _propTypes["default"].string,
  icon: _propTypes["default"].string,
  getErrorMessage: _propTypes["default"].func.isRequired,
  autocomplete: _propTypes["default"].bool //是否保存输入记录

};
InputForm.defaultProps = {
  prefixCls: 'ult',
  className: '',
  style: null,
  name: '',
  type: 'text',
  label: '',
  readOnly: false,
  disabled: false,
  placeholder: '',
  icon: null,
  handleIdentifyCode: undefined
};

var _default = HOC(InputForm);

exports["default"] = _default;