"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CheckBox = _interopRequireDefault(require("../CheckBox"));

var _formsyReact = _interopRequireDefault(require("formsy-react"));

var _Label = _interopRequireDefault(require("../Label"));

require("./form.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var HOC = _formsyReact["default"].HOC;
var RadioGroup = _CheckBox["default"].RadioGroup;

var RadioGroupForm = /*#__PURE__*/function (_React$Component) {
  _inherits(RadioGroupForm, _React$Component);

  var _super = _createSuper(RadioGroupForm);

  function RadioGroupForm(props) {
    var _this;

    _classCallCheck(this, RadioGroupForm);

    _this = _super.call(this, props);
    _this.state = {
      value: _this.props.defaultValue || ''
    };
    return _this;
  }

  _createClass(RadioGroupForm, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.setValue(this.props.defaultValue || '');
    }
  }, {
    key: "changeValue",
    value: function changeValue(value) {
      this.setState({
        value: value
      });
      this.props.setValue(value);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          prefixCls = _this$props.prefixCls,
          style = _this$props.style,
          label = _this$props.label,
          name = _this$props.name,
          items = _this$props.items,
          inline = _this$props.inline,
          isRequired = _this$props.isRequired;
      var validCls = this.props.showRequired() ? 'required' : this.props.showError() ? 'error' : '';
      var classes = (0, _classnames["default"])("".concat(prefixCls, "-form-group"), className, validCls);
      var errorMessage = this.props.getErrorMessage();
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classes,
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_Label["default"], {
        name: label,
        require: isRequired()
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-form-group-input-wrapper")
      }, /*#__PURE__*/_react["default"].createElement(RadioGroup, {
        name: name,
        items: items,
        defaultValue: this.state.value,
        onChange: this.changeValue.bind(this),
        inline: inline
      }), /*#__PURE__*/_react["default"].createElement("span", {
        className: "validation-error"
      }, errorMessage)));
    }
  }]);

  return RadioGroupForm;
}(_react["default"].Component);

RadioGroupForm.propTypes = {
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  items: _propTypes["default"].array.isRequired,
  defaultValue: _propTypes["default"].string,
  name: _propTypes["default"].string,
  label: _propTypes["default"].string,
  inline: _propTypes["default"].bool,
  setValue: _propTypes["default"].func.isRequired,
  isRequired: _propTypes["default"].func.isRequired,
  showRequired: _propTypes["default"].func.isRequired,
  showError: _propTypes["default"].func.isRequired,
  getErrorMessage: _propTypes["default"].func.isRequired
};
RadioGroupForm.defaultProps = {
  prefixCls: 'ult',
  inline: false,
  className: '',
  style: null,
  defaultValue: '',
  name: '',
  label: ''
};

var _default = HOC(RadioGroupForm);

exports["default"] = _default;