"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _formsyReact = _interopRequireDefault(require("formsy-react"));

var _Label = _interopRequireDefault(require("../Label"));

var _Textarea = _interopRequireDefault(require("../Textarea"));

require("./form.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var HOC = _formsyReact["default"].HOC;

var TextareaForm = /*#__PURE__*/function (_React$Component) {
  _inherits(TextareaForm, _React$Component);

  var _super = _createSuper(TextareaForm);

  function TextareaForm(props) {
    var _this;

    _classCallCheck(this, TextareaForm);

    _this = _super.call(this, props);
    _this.state = {
      validated: false
    };
    return _this;
  }

  _createClass(TextareaForm, [{
    key: "changeValue",
    value: function changeValue(event) {
      this.props.setValue(event.currentTarget.value);
      var _this$props = this.props,
          showRequired = _this$props.showRequired,
          showError = _this$props.showError,
          getValue = _this$props.getValue;
      var validated = showRequired() ? getValue() === '' : showError();
      this.setState({
        validated: validated
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames;

      var _this$props2 = this.props,
          prefixCls = _this$props2.prefixCls,
          className = _this$props2.className,
          style = _this$props2.style,
          name = _this$props2.name,
          label = _this$props2.label,
          isRequired = _this$props2.isRequired,
          readOnly = _this$props2.readOnly,
          disabled = _this$props2.disabled,
          placeholder = _this$props2.placeholder,
          addon = _this$props2.addon;
      var validated = this.state.validated;
      var classes = (0, _classnames2["default"])("".concat(prefixCls, "-form-group"), (_classnames = {}, _defineProperty(_classnames, "".concat(prefixCls, "-form-group-validated"), validated), _defineProperty(_classnames, "required", this.props.showRequired()), _defineProperty(_classnames, "error", this.props.showError()), _classnames), className);
      var errorMessage = this.props.getErrorMessage();
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classes,
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_Label["default"], {
        name: label,
        require: isRequired()
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-form-group-input-wrapper")
      }, /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
        name: name,
        onChange: this.changeValue.bind(this),
        value: this.props.getValue(),
        disabled: disabled || readOnly,
        placeholder: placeholder,
        addon: addon
      }), /*#__PURE__*/_react["default"].createElement("span", {
        className: "validation-error"
      }, errorMessage)));
    }
  }]);

  return TextareaForm;
}(_react["default"].Component);

TextareaForm.propTypes = {
  className: _propTypes["default"].string,
  prefixCls: _propTypes["default"].string,
  style: _propTypes["default"].object,
  name: _propTypes["default"].string,
  label: _propTypes["default"].string,
  setValue: _propTypes["default"].func.isRequired,
  getValue: _propTypes["default"].func.isRequired,
  isRequired: _propTypes["default"].func.isRequired,
  showRequired: _propTypes["default"].func.isRequired,
  showError: _propTypes["default"].func.isRequired,
  getErrorMessage: _propTypes["default"].func.isRequired,
  readOnly: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  addon: _propTypes["default"].string,
  placeholder: _propTypes["default"].string
};
TextareaForm.defaultProps = {
  prefixCls: 'ult',
  className: '',
  style: null,
  name: '',
  label: '',
  readOnly: false,
  disabled: false,
  addon: null,
  placeholder: ''
};

var _default = HOC(TextareaForm);

exports["default"] = _default;