"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useRow = exports.useCol = void 0;

var classnames_1 = __importDefault(require("classnames"));

exports.useCol = function (_a) {
  var _b;

  var _c = _a.prefixCls,
      prefixCls = _c === void 0 ? 'ult-col' : _c,
      span = _a.span,
      order = _a.order,
      offset = _a.offset,
      push = _a.push,
      pull = _a.pull,
      _d = _a.className,
      className = _d === void 0 ? '' : _d,
      other = __rest(_a, ["prefixCls", "span", "order", "offset", "push", "pull", "className"]);

  var mediaClassObj = {};
  ['xs', 'sm', 'md', 'lg', 'xl'].forEach(function (media) {
    var _a;

    var propSize = other[media];
    var mediaProps = {};

    if (typeof propSize === 'number') {
      mediaProps.span = propSize;
    } else if (_typeof(propSize) === 'object') {
      mediaProps = propSize || {};
    }

    mediaClassObj = Object.assign({}, mediaClassObj, (_a = {}, _a[prefixCls + "-" + media + "-" + mediaProps.span] = mediaProps.span !== undefined, _a[prefixCls + "-" + media + "-order-" + mediaProps.order] = mediaProps.order || mediaProps.order === 0, _a[prefixCls + "-" + media + "-offset-" + mediaProps.offset] = mediaProps.offset || mediaProps.offset === 0, _a[prefixCls + "-" + media + "-push-" + mediaProps.push] = mediaProps.push || mediaProps.push === 0, _a[prefixCls + "-" + media + "-pull-" + mediaProps.pull] = mediaProps.pull || mediaProps.pull === 0, _a));
  });
  var classes = classnames_1["default"]((_b = {}, _b[prefixCls + "-" + span] = span !== undefined, _b[prefixCls + "-order-" + order] = order, _b[prefixCls + "-offset-" + offset] = offset, _b[prefixCls + "-push-" + push] = push, _b[prefixCls + "-pull-" + pull] = pull, _b), className, mediaClassObj);
  return {
    classes: classes
  };
};

exports.useRow = function (_a) {
  var _b;

  var _c = _a.prefixCls,
      prefixCls = _c === void 0 ? 'ult-row' : _c,
      _d = _a.type,
      type = _d === void 0 ? 'flex' : _d,
      _e = _a.align,
      align = _e === void 0 ? 'middle' : _e,
      _f = _a.justify,
      justify = _f === void 0 ? 'start' : _f,
      _g = _a.wrap,
      wrap = _g === void 0 ? 'wrap' : _g,
      _h = _a.className,
      className = _h === void 0 ? '' : _h,
      children = _a.children,
      others = __rest(_a, ["prefixCls", "type", "align", "justify", "wrap", "className", "children"]);

  var classes = classnames_1["default"]((_b = {}, _b[prefixCls] = !type, _b[prefixCls + "-" + type] = type, _b[prefixCls + "-" + type + "-" + justify] = type && justify, _b[prefixCls + "-" + type + "-" + wrap] = type && wrap, _b[prefixCls + "-" + type + "-" + align] = type && align, _b), className);
  return __assign({
    classes: classes,
    children: children
  }, others);
};