"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var Grid_1 = require("../Grid");

var Tooltip_1 = require("../Tooltip");

var Input_1 = __importDefault(require("../Input"));

var Loading_1 = __importDefault(require("../Loading"));

var Button_1 = __importDefault(require("../Button"));

var Icon_1 = __importDefault(require("../Icon"));

var useInlineInput_1 = __importDefault(require("./useInlineInput"));

require("./index.less");

var InlineInput = function InlineInput(props) {
  var _a = useInlineInput_1["default"](props),
      submitting = _a.submitting,
      newValue = _a.newValue,
      error = _a.error,
      noChange = _a.noChange,
      newEditing = _a.newEditing,
      handleEditClick = _a.handleEditClick,
      handleChange = _a.handleChange,
      handleInputFocus = _a.handleInputFocus,
      handleKeyUp = _a.handleKeyUp,
      handleSubmitClick = _a.handleSubmitClick,
      handleCancelClick = _a.handleCancelClick,
      others = __rest(_a, ["submitting", "newValue", "error", "noChange", "newEditing", "handleEditClick", "handleChange", "handleInputFocus", "handleKeyUp", "handleSubmitClick", "handleCancelClick"]);

  var value = props.value,
      _b = props.element,
      element = _b === void 0 ? null : _b,
      _c = props.disabled,
      disabled = _c === void 0 ? false : _c,
      _d = props.invalid,
      invalid = _d === void 0 ? '' : _d,
      _e = props.placement,
      placement = _e === void 0 ? 'top' : _e,
      _f = props.editing,
      editing = _f === void 0 ? false : _f,
      _g = props.className,
      className = _g === void 0 ? '' : _g,
      _h = props.style,
      style = _h === void 0 ? {} : _h;

  function renderEditor() {
    var classes = classnames_1["default"]('inline-edit-wrap', className);
    return react_1["default"].createElement(Grid_1.Row, {
      wrap: "nowrap",
      className: classes,
      style: style
    }, react_1["default"].createElement("div", {
      className: className
    }, react_1["default"].createElement(Tooltip_1.TooltipAlign, {
      tips: invalid,
      placement: placement,
      visible: !!error
    }, react_1["default"].createElement(Input_1["default"], __assign({
      value: newValue,
      onChange: handleChange
    }, others, {
      onClick: handleInputFocus,
      onKeyUp: handleKeyUp
    }))), submitting ? react_1["default"].createElement(Loading_1["default"], {
      size: 16,
      style: {
        width: '16px',
        height: '16px',
        position: 'absolute',
        right: '45px',
        top: '8px',
        zIndex: '1'
      }
    }) : null), !editing ? react_1["default"].createElement(Button_1["default"], {
      icon: "error",
      disabled: submitting,
      onClick: handleCancelClick
    }) : null, react_1["default"].createElement(Button_1["default"], {
      icon: "correct",
      disabled: error || submitting || noChange,
      onClick: handleSubmitClick
    }));
  }

  function renderNormal() {
    return react_1["default"].createElement(Grid_1.Row, {
      wrap: "nowrap",
      className: className,
      style: style
    }, element || react_1["default"].createElement("span", null, value), disabled ? null : react_1["default"].createElement(Icon_1["default"], {
      type: "edit",
      className: "m-l-sm",
      onClick: handleEditClick
    }));
  }

  return react_1["default"].createElement("div", null, newEditing ? renderEditor() : renderNormal());
};

exports["default"] = InlineInput;