"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = require("react");

var utils_1 = require("../../utils");

var useInlineInput = function useInlineInput(_a) {
  var value = _a.value,
      _b = _a.element,
      element = _b === void 0 ? null : _b,
      _c = _a.disabled,
      disabled = _c === void 0 ? false : _c,
      regex = _a.regex,
      invalid = _a.invalid,
      _d = _a.placement,
      placement = _d === void 0 ? 'top' : _d,
      _e = _a.editing,
      editing = _e === void 0 ? false : _e,
      _f = _a.submitting,
      submitting = _f === void 0 ? false : _f,
      _g = _a.autoTrim,
      autoTrim = _g === void 0 ? true : _g,
      onSubmit = _a.onSubmit,
      onKeyUp = _a.onKeyUp,
      _h = _a.className,
      className = _h === void 0 ? '' : _h,
      _j = _a.style,
      style = _j === void 0 ? {} : _j,
      others = __rest(_a, ["value", "element", "disabled", "regex", "invalid", "placement", "editing", "submitting", "autoTrim", "onSubmit", "onKeyUp", "className", "style"]);

  var _k = react_1.useState(value),
      newValue = _k[0],
      setNewValue = _k[1];

  var _l = react_1.useState(false),
      error = _l[0],
      setError = _l[1];

  var _m = react_1.useState(true),
      noChange = _m[0],
      setNoChange = _m[1];

  var _o = react_1.useState(editing),
      newEditing = _o[0],
      setEditing = _o[1];

  var handleEditClick = function handleEditClick() {
    setNewValue(value);
    setEditing(true);
  };

  var handleChange = function handleChange(e) {
    var newValue = e.target.value;

    if (regex && invalid) {
      regex.lastIndex = 0;
      autoTrim ? setNewValue(utils_1.tools.string.trim(newValue)) : setNewValue(newValue);
      setError(!regex.test(newValue));
      setNoChange(value === newValue);
    }
  };

  var handleInputFocus = function handleInputFocus(e) {
    e.stopPropagation();
  };

  var handleKeyUp = function handleKeyUp(e) {
    if (onKeyUp) {
      onKeyUp(e);
    }

    if (e.keyCode === 13 && !error && !submitting && !noChange) {
      handleSubmitClick(e);
    }
  };

  react_1.useEffect(function () {
    if (!submitting && !editing) {
      setNewValue(value);
      setError(false);
      setEditing(false);
    }
  }, [submitting]);

  var handleSubmitClick = function handleSubmitClick(e) {
    e.stopPropagation();

    if (newValue) {
      onSubmit(newValue, e);
    }
  };

  var handleCancelClick = function handleCancelClick(e) {
    e.stopPropagation();
    setNewValue(value);
    setError(false);
    setNoChange(true);
    setTimeout(function () {
      setEditing(false);
    });
  };

  return __assign({
    submitting: submitting,
    newValue: newValue,
    error: error,
    noChange: noChange,
    newEditing: newEditing,
    handleEditClick: handleEditClick,
    handleChange: handleChange,
    handleInputFocus: handleInputFocus,
    handleKeyUp: handleKeyUp,
    handleSubmitClick: handleSubmitClick,
    handleCancelClick: handleCancelClick
  }, others);
};

exports["default"] = useInlineInput;