"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var InputGroup_1 = __importDefault(require("./InputGroup"));

var useInput_1 = __importDefault(require("./useInput"));

require("./input.less");

var Input = function Input(props, ref) {
  var _a;

  var handleChange = useInput_1["default"](props).handleChange;

  var _b = props.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      _c = props.maxLength,
      maxLength = _c === void 0 ? 100 : _c,
      _d = props.icon,
      icon = _d === void 0 ? '' : _d,
      _e = props.iconRight,
      iconRight = _e === void 0 ? false : _e,
      _f = props.disabled,
      disabled = _f === void 0 ? false : _f,
      _g = props.unit,
      unit = _g === void 0 ? '' : _g,
      onChange = props.onChange,
      _h = props.autocomplete,
      autocomplete = _h === void 0 ? true : _h,
      _j = props.className,
      className = _j === void 0 ? '' : _j,
      _k = props.style,
      style = _k === void 0 ? {} : _k,
      other = __rest(props, ["prefixCls", "maxLength", "icon", "iconRight", "disabled", "unit", "onChange", "autocomplete", "className", "style"]);

  var classes = classnames_1["default"](prefixCls + "-input", className);

  if (other.type === 'password') {
    delete other.value;
  }

  if (icon || unit) {
    return react_1["default"].createElement("div", {
      className: classnames_1["default"]((_a = {}, _a[prefixCls + "-input-icon"] = !!icon, _a[prefixCls + "-input-icon-right"] = iconRight && !unit, _a[prefixCls + "-input-unit"] = !!unit, _a[prefixCls + "-input-disabled"] = disabled, _a), className)
    }, icon ? react_1["default"].createElement("i", {
      className: "iconfont icon-" + icon
    }) : null, react_1["default"].createElement("input", __assign({}, other, {
      ref: ref,
      className: prefixCls + "-input",
      style: style,
      maxLength: maxLength,
      disabled: disabled,
      autoComplete: autocomplete ? 'on' : 'off',
      onChange: handleChange
    })), unit ? react_1["default"].createElement("span", {
      className: 'unit'
    }, unit) : null);
  }

  return react_1["default"].createElement("input", __assign({}, other, {
    ref: ref,
    className: classes,
    style: style,
    maxLength: maxLength,
    disabled: disabled,
    autoComplete: autocomplete ? 'on' : 'off',
    onChange: handleChange
  }));
};

var RefInput = react_1["default"].forwardRef(Input);
RefInput.InputGroup = InputGroup_1["default"];
exports["default"] = RefInput;