"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var Input_1 = __importDefault(require("../Input"));

var Button_1 = __importDefault(require("../Button"));

var useInputNum_1 = require("./useInputNum");

require("./InputNum.less");

var InputNum = function InputNum(props) {
  var _a;

  var _b = props.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      _c = props.className,
      className = _c === void 0 ? '' : _c,
      _d = props.style,
      style = _d === void 0 ? {} : _d,
      _e = props.verticalbuttons,
      verticalbuttons = _e === void 0 ? false : _e,
      _f = props.disabled,
      disabled = _f === void 0 ? false : _f,
      postfix = props.postfix,
      _g = props.readOnly,
      readOnly = _g === void 0 ? false : _g,
      _h = props.placeholder,
      placeholder = _h === void 0 ? '' : _h;

  var _j = useInputNum_1.useInputNum(props),
      inputValue = _j.inputValue,
      isMinDisable = _j.isMinDisable,
      isMaxDisable = _j.isMaxDisable,
      handleStepBackClick = _j.handleStepBackClick,
      handleStepForwardClick = _j.handleStepForwardClick,
      error = _j.error,
      handleChange = _j.handleChange,
      handleBlur = _j.handleBlur,
      handleFocus = _j.handleFocus,
      handleKeyDown = _j.handleKeyDown;

  var classes = classnames_1["default"]((_a = {}, _a[prefixCls + "-input-num"] = true, _a[prefixCls + "-input-num-verticalbuttons"] = !!verticalbuttons, _a[prefixCls + "-input-num-disabled"] = !!disabled, _a), className);
  var iconDown = !verticalbuttons ? 'minus' : 'down';
  var iconUp = !verticalbuttons ? 'add' : 'up';
  var renderInvisiableRadio = react_1["default"].createElement("input", {
    style: {
      position: 'absolute',
      left: 0,
      opacity: 0
    },
    onChange: function onChange() {},
    name: "invisiable-radio",
    type: "radio",
    checked: false
  });
  return react_1["default"].createElement("div", {
    className: classes,
    style: style
  }, react_1["default"].createElement(Button_1["default"], {
    className: prefixCls + "-input-num-down " + prefixCls + "-icon-only",
    icon: iconDown,
    disabled: disabled || readOnly || isMinDisable || null,
    onClick: handleStepBackClick,
    type: "default"
  }, renderInvisiableRadio), react_1["default"].createElement(Input_1["default"], {
    className: classnames_1["default"](prefixCls + "-input-num-input", {
      error: error
    }),
    disabled: disabled || readOnly,
    value: inputValue,
    onChange: handleChange,
    onBlur: handleBlur,
    onFocus: handleFocus,
    onKeyDown: handleKeyDown,
    placeholder: placeholder
  }), postfix ? react_1["default"].createElement("span", {
    className: prefixCls + "-input-num-postfix"
  }, postfix) : null, react_1["default"].createElement(Button_1["default"], {
    className: prefixCls + "-input-num-up " + prefixCls + "-icon-only",
    icon: iconUp,
    disabled: disabled || readOnly || isMaxDisable || null,
    onClick: handleStepForwardClick,
    type: "default"
  }, renderInvisiableRadio));
};

exports["default"] = InputNum;