"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var Input_1 = __importDefault(require("../Input"));

var Button_1 = __importDefault(require("../Button"));

var useInputNumber_1 = require("./useInputNumber");

require("./inputNumber.less");

var InputNumber = function InputNumber(props) {
  var _a;

  var _b = props.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      _c = props.style,
      style = _c === void 0 ? {} : _c,
      _d = props.verticalbuttons,
      verticalbuttons = _d === void 0 ? false : _d,
      _e = props.disabled,
      disabled = _e === void 0 ? false : _e,
      _f = props.readOnly,
      readOnly = _f === void 0 ? false : _f,
      _g = props.readonly,
      readonly = _g === void 0 ? false : _g,
      postfix = props.postfix,
      className = props.className,
      placeholder = props.placeholder,
      slot = props.slot;

  var _h = useInputNumber_1.useInputNumber(props),
      isMinDisable = _h.isMinDisable,
      isMaxDisable = _h.isMaxDisable,
      handleStepBack = _h.handleStepBack,
      handleStepForward = _h.handleStepForward,
      inputValue = _h.inputValue,
      handleChange = _h.handleChange,
      handleBlur = _h.handleBlur,
      handleFocus = _h.handleFocus,
      inputRef = _h.inputRef,
      handleKeyDown = _h.handleKeyDown;

  var classes = classnames_1["default"]((_a = {}, _a[prefixCls + "-input-number"] = true, _a[prefixCls + "-input-number-verticalbuttons"] = !!verticalbuttons, _a[prefixCls + "-input-number-disabled"] = !!disabled, _a), className);
  var iconDown = !verticalbuttons ? 'minus' : 'down';
  var iconUp = !verticalbuttons ? 'add' : 'up';
  var renderInvisiableRadio = react_1["default"].createElement("input", {
    style: {
      position: 'absolute',
      left: 0,
      opacity: 0,
      cursor: 'pointer'
    },
    onChange: function onChange() {},
    name: "invisiable-radio",
    type: "radio",
    checked: false,
    readOnly: true
  });
  var isReadonly = readOnly || readonly;
  return react_1["default"].createElement("div", {
    className: classes,
    style: style
  }, react_1["default"].createElement(Button_1["default"], {
    className: prefixCls + "-input-number-down " + prefixCls + "-icon-only",
    icon: iconDown,
    disabled: disabled || isReadonly || isMinDisable,
    onClick: handleStepBack,
    type: "default"
  }, renderInvisiableRadio), react_1["default"].createElement(Input_1["default"], {
    className: prefixCls + "-input-number-input " + (slot ? "slot-" + slot.position : ''),
    disabled: disabled || isReadonly,
    value: inputValue,
    onChange: handleChange,
    onBlur: handleBlur,
    onFocus: handleFocus,
    ref: inputRef,
    onKeyDown: handleKeyDown,
    placeholder: placeholder
  }), postfix ? react_1["default"].createElement("span", {
    className: prefixCls + "-input-number-postfix"
  }, postfix) : null, !postfix && slot ? react_1["default"].createElement("span", {
    className: "slot " + slot.position
  }, slot.format()) : null, react_1["default"].createElement(Button_1["default"], {
    className: prefixCls + "-input-number-up " + prefixCls + "-icon-only",
    icon: iconUp,
    disabled: disabled || isReadonly || isMaxDisable,
    onClick: handleStepForward,
    type: "default"
  }, renderInvisiableRadio));
};

exports["default"] = InputNumber;