"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var Input_1 = __importDefault(require("../Input"));

var Button_1 = __importDefault(require("../Button"));

var useInputNumbers_1 = require("./useInputNumbers");

require("./inputNumbers.less");

var InputNumbers = function InputNumbers(props) {
  var _a;

  var _b = props.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      className = props.className,
      style = props.style,
      _c = props.verticalbuttons,
      verticalbuttons = _c === void 0 ? false : _c,
      _d = props.disabled,
      disabled = _d === void 0 ? false : _d,
      _e = props.readonly,
      readonly = _e === void 0 ? false : _e,
      slot = props.slot,
      // decimalSeparator,
  _f = props.placeholder,
      // decimalSeparator,
  placeholder = _f === void 0 ? '' : _f;

  var _g = useInputNumbers_1.useInputNumbers(props),
      inputValue = _g.inputValue,
      upDisable = _g.upDisable,
      downDisable = _g.downDisable,
      sameDisable = _g.sameDisable,
      handleStepBack = _g.handleStepBack,
      handleStepForward = _g.handleStepForward,
      handleChange = _g.handleChange,
      handleBlur = _g.handleBlur;

  var classes = classnames_1["default"]((_a = {}, _a[prefixCls + "-input-num-container"] = true, _a[prefixCls + "-input-num-verticalbuttons"] = !!verticalbuttons, _a), className);
  var iconDown = !verticalbuttons ? 'minus' : 'down';
  var iconUp = !verticalbuttons ? 'add' : 'up';
  var renderInvisiableRadio = react_1["default"].createElement("input", {
    style: {
      position: 'absolute',
      left: 0,
      opacity: 0
    },
    onChange: function onChange() {},
    name: "invisiable-radio",
    type: "radio",
    checked: false
  });
  return react_1["default"].createElement("div", {
    className: classes,
    style: style
  }, react_1["default"].createElement(Button_1["default"], {
    className: "btn-down " + prefixCls + "-icon-only",
    icon: iconDown,
    onClick: handleStepBack,
    type: "default",
    disabled: downDisable || sameDisable || disabled || readonly
  }, renderInvisiableRadio), react_1["default"].createElement("div", {
    className: "input-box"
  }, react_1["default"].createElement(Input_1["default"], {
    className: "input-num " + (slot ? "slot-" + slot.position : ''),
    onChange: handleChange,
    onBlur: handleBlur,
    placeholder: placeholder,
    value: inputValue,
    disabled: disabled || readonly
  }), slot ? react_1["default"].createElement("span", {
    className: "slot " + slot.position
  }, slot.format()) : null), react_1["default"].createElement(Button_1["default"], {
    className: "btn-up " + prefixCls + "-icon-only",
    icon: iconUp,
    onClick: handleStepForward,
    type: "default",
    disabled: upDisable || sameDisable || disabled || readonly
  }, renderInvisiableRadio));
};

exports["default"] = InputNumbers;