"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var Tooltip_1 = require("../Tooltip");

require("./label.less");

var Label = function Label(props) {
  var _a = props.prefixCls,
      prefixCls = _a === void 0 ? 'ult' : _a,
      _b = props.name,
      name = _b === void 0 ? '' : _b,
      _c = props.tips,
      tips = _c === void 0 ? null : _c,
      _d = props.placement,
      placement = _d === void 0 ? 'top' : _d,
      _e = props.require,
      require = _e === void 0 ? false : _e,
      _f = props.className,
      className = _f === void 0 ? '' : _f,
      _g = props.style,
      style = _g === void 0 ? {} : _g,
      _h = props.children,
      children = _h === void 0 ? '' : _h;

  return react_1["default"].createElement("label", {
    className: classnames_1["default"]([prefixCls + "-label"], className),
    style: style
  }, require ? react_1["default"].createElement("i", {
    className: "iconfont icon-required"
  }) : null, name || children, tips ? react_1["default"].createElement("div", {
    className: prefixCls + "-label-tips"
  }, react_1["default"].createElement(Tooltip_1.TooltipAlign, {
    className: "ult-tooltip-align-label",
    placement: placement,
    tips: tips
  }, react_1["default"].createElement("i", {
    className: 'iconfont icon-info-s'
  }))) : null);
};

exports["default"] = Label;