"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _menuList = _interopRequireDefault(require("./menuList"));

var _menuItem = _interopRequireDefault(require("./menuItem"));

require("./menu.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Menu = /*#__PURE__*/function (_React$Component) {
  _inherits(Menu, _React$Component);

  var _super = _createSuper(Menu);

  function Menu(props) {
    var _this;

    _classCallCheck(this, Menu);

    _this = _super.call(this, props);
    _this.state = {
      items: _this.getItems(props),
      activeKey: [],
      openKey: []
    };
    _this.handleToggle = _this.handleToggle.bind(_assertThisInitialized(_this));
    _this.handleSelect = _this.handleSelect.bind(_assertThisInitialized(_this));
    _this.handleCollapse = _this.handleCollapse.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Menu, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.addEventListener('click', this.handleCollapse);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.handleCollapse);
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var items = this.state.items;
      var defaultActiveKey = this.props.defaultActiveKey;
      var activeKey;

      var loop = function loop(data) {
        data.forEach(function (d) {
          if (d.id === defaultActiveKey) {
            activeKey = d.enkey;
          } else if (d.subMenu) {
            loop(d.subMenu);
          }
        });
      };

      loop(items);
      this.getOpenActiveKeys(activeKey);
    } // fix by zhaojinhui@huayun.com

  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      /* eslint-disable */
      this.state.items = this.getItems(nextProps);
      var defaultActiveKey = nextProps.defaultActiveKey;
      var activeKey;

      var loop = function loop(data) {
        data.forEach(function (d) {
          if (d.id === defaultActiveKey) {
            activeKey = d.enkey;
          } else if (d.subMenu) {
            loop(d.subMenu);
          }
        });
      };

      loop(this.state.items);
      this.getOpenActiveKeys(activeKey);
    }
  }, {
    key: "handleCollapse",
    value: function handleCollapse() {
      if (this.props.mode === 'horizontal') {
        this.setState({
          openKey: []
        });
      }
    }
  }, {
    key: "getItems",
    value: function getItems(props) {
      var items = props.items,
          tips = props.tips;

      var loop = function loop(data, parentKey) {
        var newData = data.map(function (item, index) {
          var enkey = "".concat(parentKey, "-").concat(index);

          if (!item.subMenu) {
            return _objectSpread(_objectSpread({}, item), {}, {
              enkey: enkey
            });
          }

          return _objectSpread(_objectSpread({}, item), {}, {
            enkey: enkey,
            subMenu: loop(item.subMenu, enkey)
          });
        });
        return newData;
      };

      var newItems = loop(items, '0');

      if (tips) {
        newItems = this.addTips(newItems, tips);
      }

      return newItems;
    }
  }, {
    key: "addTips",
    value: function addTips(items, tips) {
      var loop = function loop(data) {
        var newData = data.map(function (d) {
          var dis = tips.find(function (t) {
            return t.id === d.id;
          });

          if (dis) {
            if (!d.subMenu) {
              return _objectSpread(_objectSpread({}, d), {}, {
                tip: dis
              });
            }

            return _objectSpread(_objectSpread({}, d), {}, {
              tip: dis,
              subMenu: loop(d.subMenu)
            });
          } else {
            if (!d.subMenu) {
              return d;
            } else {
              return _objectSpread(_objectSpread({}, d), {}, {
                subMenu: loop(d.subMenu)
              });
            }
          }
        });
        return newData;
      };

      return loop(items);
    }
  }, {
    key: "getOpenActiveKeys",
    value: function getOpenActiveKeys(ak) {
      if (!ak) {
        this.setState({
          activeKey: [],
          openKey: []
        });
        return;
      }

      var _this$state = this.state,
          items = _this$state.items,
          openKey = _this$state.openKey,
          activeKey = _this$state.activeKey;
      var newOpenKey = [];
      var arr = ak.split('-');
      var openItem = "".concat(arr[0]);

      for (var i = 0; i < arr.length; i++) {
        if (i > 0) {
          openItem += "-".concat(arr[i]);
          newOpenKey.push(openItem);
        }
      }

      var newActiveKey = [].concat(ak);
      items.forEach(function (item) {
        if (item.subMenu) {
          item.subMenu.forEach(function (sm) {
            if (sm.enkey === ak) {
              newOpenKey = newOpenKey.concat(item.enkey);
              newActiveKey = newActiveKey.concat(item.enkey);
            } else if (sm.subMenu) {
              sm.subMenu.forEach(function (ssm) {
                if (ssm.enkey === ak) {
                  newOpenKey = newOpenKey.concat(item.enkey, sm.enkey);
                  newActiveKey = newActiveKey.concat(item.enkey, sm.enkey);
                }
              });
            }
          });
        }
      });

      if (this.props.mode === 'horizontal') {
        this.setState({
          openKey: [],
          activeKey: newActiveKey
        });
      } else {
        this.setState({
          openKey: newOpenKey,
          activeKey: newActiveKey
        });
      }
    }
  }, {
    key: "handleToggle",
    value: function handleToggle(eKey) {
      var openKey = this.state.openKey;
      var dicide = openKey.find(function (k) {
        return k === eKey;
      });
      var newOpenKey = [];

      if (dicide) {
        newOpenKey = openKey.filter(function (k) {
          return k !== eKey;
        });
      } else {
        var arr = eKey.split('-');
        var openItem = "".concat(arr[0]);

        for (var i = 0; i < arr.length; i++) {
          if (i > 0) {
            openItem += "-".concat(arr[i]);
            newOpenKey.push(openItem);
          }
        }
      }

      this.setState({
        openKey: newOpenKey
      });
    }
  }, {
    key: "handleSelect",
    value: function handleSelect(key, target, id) {
      // 如果是新弹窗按钮，就不改变active
      if (target !== undefined) {
        return;
      }

      if (this.props.onSelect) {
        this.props.onSelect(id);
      }

      this.getOpenActiveKeys(key);
    }
  }, {
    key: "getItemOpen",
    value: function getItemOpen(key) {
      var openKey = this.state.openKey;

      if (openKey) {
        return !!openKey.find(function (k) {
          return k === key;
        });
      }

      return false;
    }
  }, {
    key: "getSViewportOffset",
    value: function getSViewportOffset() {
      if (window.innerWidth) {
        return {
          w: window.innerWidth,
          h: window.innerHeight
        };
      } else {
        if (document.compatMode === "BackCompat") {
          return {
            w: document.body.clienWidth,
            h: document.body.clientHeight
          };
        } else {
          return {
            w: document.documentElement.clientWidth,
            h: document.documrntElement.clientHeight
          };
        }
      }
    }
  }, {
    key: "onMouseEnter",
    value: function onMouseEnter(e) {
      var isTitle = e.target.className.indexOf("".concat(this.props.prefixCls, "-menu-item-title"));

      if (isTitle === -1) {
        return;
      }

      if (this.props.type === 'leftNavBar') {
        var eventSize = e.target.getBoundingClientRect();
        var parentNode = e.target.parentNode;
        var list = parentNode.lastElementChild;
        var listSize = list.getBoundingClientRect();
        var viewPort = this.getSViewportOffset();
        parentNode.style.position = 'static';
        list.style.left = "".concat(eventSize.left + eventSize.width, "px");

        if (listSize.height + eventSize.top > viewPort.h) {
          list.style.top = 'auto';
          list.style.right = 'auto';
          list.style.bottom = 0;
        } else {
          list.style.top = "".concat(eventSize.top, "px");
          list.style.right = 'auto';
          list.style.bottom = 'auto';
        }
      }
    }
  }, {
    key: "onMouseLeave",
    value: function onMouseLeave(e) {
      // do something
      var isTitle = e.target.className.indexOf("".concat(this.props.prefixCls, "-menu-item-title"));

      if (isTitle === -1) {
        return;
      }

      if (this.props.type === 'leftNavBar') {
        var parentNode = e.target.parentNode;
        var list = parentNode.lastElementChild;
        parentNode.style.position = 'static';
        list.style.top = 'auto';
        list.style.right = 'auto';
        list.style.bottom = 'auto';
      }
    }
  }, {
    key: "renderItems",
    value: function renderItems() {
      var _this2 = this;

      var _this$props = this.props,
          prefixCls = _this$props.prefixCls,
          switchIcons = _this$props.switchIcons;
      var _this$state2 = this.state,
          items = _this$state2.items,
          activeKey = _this$state2.activeKey,
          openKey = _this$state2.openKey;

      if (items) {
        return items.map(function (item) {
          if (item.hidden) {
            return null;
          }

          if (item.subMenu) {
            return /*#__PURE__*/_react["default"].createElement(_menuItem["default"], _extends({
              onMouseEnter: _this2.onMouseEnter.bind(_this2),
              onMouseLeave: _this2.onMouseLeave.bind(_this2),
              key: item.id
            }, item, {
              prefixCls: prefixCls,
              switchIcons: switchIcons,
              onToggle: _this2.handleToggle,
              open: _this2.getItemOpen(item.enkey),
              active: !!activeKey.find(function (k) {
                return k === item.enkey;
              })
            }), /*#__PURE__*/_react["default"].createElement(_menuList["default"], {
              prefixCls: prefixCls
            }, item.subMenu.map(function (sm) {
              if (sm.subMenu) {
                return /*#__PURE__*/_react["default"].createElement(_menuItem["default"], _extends({
                  key: sm.id
                }, sm, {
                  prefixCls: prefixCls,
                  switchIcons: switchIcons,
                  onToggle: _this2.handleToggle,
                  open: _this2.getItemOpen(sm.enkey),
                  active: !!activeKey.find(function (k) {
                    return k === sm.enkey;
                  })
                }), /*#__PURE__*/_react["default"].createElement(_menuList["default"], {
                  prefixCls: prefixCls
                }, sm.subMenu.map(function (ssm) {
                  return /*#__PURE__*/_react["default"].createElement(_menuItem["default"], _extends({
                    key: ssm.id
                  }, ssm, {
                    prefixCls: prefixCls,
                    switchIcons: switchIcons,
                    onSelect: _this2.handleSelect,
                    active: !!activeKey.find(function (k) {
                      return k === ssm.enkey;
                    })
                  }));
                })));
              }

              return /*#__PURE__*/_react["default"].createElement(_menuItem["default"], _extends({
                key: sm.id
              }, sm, {
                prefixCls: prefixCls,
                switchIcons: switchIcons,
                onSelect: _this2.handleSelect,
                active: !!activeKey.find(function (k) {
                  return k === sm.enkey;
                })
              }));
            })));
          }

          return /*#__PURE__*/_react["default"].createElement(_menuItem["default"], _extends({
            key: item.id
          }, item, {
            prefixCls: prefixCls,
            switchIcons: switchIcons,
            onSelect: _this2.handleSelect,
            active: item.target === undefined && !!activeKey.find(function (k) {
              return k === item.enkey;
            })
          }));
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames;

      var _this$props2 = this.props,
          prefixCls = _this$props2.prefixCls,
          className = _this$props2.className,
          style = _this$props2.style,
          mode = _this$props2.mode,
          theme = _this$props2.theme;
      var classes = (0, _classnames2["default"])((_classnames = {}, _defineProperty(_classnames, "".concat(prefixCls, "-menu-").concat(mode), !!mode), _defineProperty(_classnames, "".concat(prefixCls, "-menu-").concat(theme), !!theme), _classnames), className);
      return /*#__PURE__*/_react["default"].createElement(_menuList["default"], {
        className: classes,
        style: style,
        prefixCls: prefixCls
      }, this.renderItems());
    }
  }]);

  return Menu;
}(_react["default"].Component);

Menu.propTypes = {
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  mode: _propTypes["default"].oneOf(['horizontal', 'vertical']),
  theme: _propTypes["default"].oneOf(['light', 'dark']),
  type: _propTypes["default"].oneOf(['leftNavBar', '']),
  items: _propTypes["default"].array.isRequired,
  tips: _propTypes["default"].array,
  switchIcons: _propTypes["default"].array,
  defaultActiveKey: _propTypes["default"].string.isRequired,
  onSelect: _propTypes["default"].func
};
Menu.defaultProps = {
  prefixCls: 'ult',
  className: '',
  style: null,
  type: '',
  mode: 'horizontal',
  theme: 'light',
  switchIcons: [{
    open: 'up',
    close: 'down'
  }, {
    open: 'minus',
    close: 'add'
  }],
  tips: [],
  onSelect: undefined
};
var _default = Menu;
exports["default"] = _default;