"use strict";

var __createBinding = void 0 && (void 0).__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = void 0 && (void 0).__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = void 0 && (void 0).__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
/* eslint react/jsx-handler-names: 0 */

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

require("./notification.less");

var Notice = function Notice(props) {
  var _a;

  var _b = props.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      _c = props.ClassName,
      ClassName = _c === void 0 ? '' : _c,
      _d = props.iconNode,
      iconNode = _d === void 0 ? 'icon-error-o' : _d,
      _e = props.duration,
      duration = _e === void 0 ? 4 : _e,
      _f = props.closable,
      closable = _f === void 0 ? true : _f,
      _g = props.title,
      title = _g === void 0 ? '' : _g,
      _h = props.content,
      content = _h === void 0 ? '' : _h,
      _j = props.desc,
      desc = _j === void 0 ? '' : _j,
      _k = props.onClose,
      onClose = _k === void 0 ? function () {} : _k;
  var type = duration > 0 ? 'progress' : 'noprogress';
  var isProgress = duration > 0;
  var closeTimer = null;

  var close = function close() {
    clearCloseTimer();
    onClose();
  };

  var clearCloseTimer = function clearCloseTimer() {
    if (closeTimer) {
      clearTimeout(closeTimer);
      closeTimer = null;
    }
  };

  react_1.useEffect(function () {
    if (duration > 0) {
      closeTimer = setTimeout(function () {
        close();
      }, duration * 1000);
    }

    return function () {
      return clearCloseTimer();
    };
  }, []);
  return react_1["default"].createElement("dd", null, react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-ui-notification", (_a = {}, _a["" + ClassName] = true, _a))
  }, react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-notification-form")
  }, react_1["default"].createElement("i", {
    className: classnames_1["default"]("iconfont default-icon " + iconNode)
  }), react_1["default"].createElement("h3", {
    className: classnames_1["default"](prefixCls + "-notification-title")
  }, title), react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-notification-content")
  }, content), desc && react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-notification-desc")
  }, desc), isProgress && react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-notification-" + type),
    style: {
      animationDuration: duration + "s"
    }
  })), closable ? react_1["default"].createElement("a", {
    role: "link",
    tabIndex: 0,
    onClick: close,
    className: prefixCls + "-notification-close"
  }, react_1["default"].createElement("span", {
    className: prefixCls + "-close-x"
  }, react_1["default"].createElement("i", {
    className: 'iconfont icon-error'
  }))) : null));
};

exports["default"] = Notice;