"use strict";

var __extends = void 0 && (void 0).__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var react_dom_1 = __importDefault(require("react-dom"));

var classnames_1 = __importDefault(require("classnames"));

var Notice_1 = __importDefault(require("./Notice"));

require("./notification.less");

var Notification =
/** @class */
function (_super) {
  __extends(Notification, _super);

  function Notification(props) {
    var _this = _super.call(this, props) || this;

    _this.addNotice = function (newNotice) {
      var keyId = newNotice.id;
      var notices = _this.state.notices;

      _this.setState(function (previousState) {
        var isNotice;

        if (previousState.notices.length) {
          isNotice = previousState.notices.find(function (p) {
            return p.id === keyId;
          });
        } else {
          isNotice = false;
        }

        if (isNotice) {
          return null;
        } else {
          return {
            notices: notices.concat(newNotice)
          };
        }
      });
    };

    _this.remove = function (keyid) {
      _this.setState(function (previousState) {
        return {
          notices: previousState.notices.filter(function (notice) {
            return notice.id !== keyid;
          })
        };
      });
    };

    _this.state = {
      notices: []
    };
    _this.noticeInfor = _this.noticeInfor.bind(_this);
    _this.addNotice = _this.addNotice.bind(_this);
    return _this;
  }

  Notification.prototype.removeAll = function () {
    this.setState({
      notices: []
    });
  };

  Notification.prototype.noticeInfor = function (notices) {
    var _this = this;

    var prefixCls = this.props.prefixCls;
    return notices.map(function (notice) {
      return react_1["default"].createElement(Notice_1["default"], __assign({
        prefixCls: prefixCls,
        ClassName: notice.type,
        key: notice.id
      }, notice, {
        onClose: _this.remove.bind(_this, notice.id)
      }), notice.content);
    });
  };

  Notification.prototype.render = function () {
    var prefixCls = this.props.prefixCls;
    var notices = this.state.notices;
    return react_1["default"].createElement("div", {
      className: classnames_1["default"](prefixCls + "-ui-notice")
    }, react_1["default"].createElement("dl", null, notices.length ? this.noticeInfor(notices) : null));
  };

  Notification.defaultProps = {
    prefixCls: 'ult'
  };
  Notification.notify = null;

  Notification.newInstance = function (noticeData) {
    var props = noticeData || {};
    var _a = props.prefixCls,
        prefixCls = _a === void 0 ? 'ult' : _a;

    var getWrapper = function getWrapper() {
      var wrapper = document.querySelector("." + prefixCls + "-ui-notice-wrap");

      if (!wrapper) {
        wrapper = document.createElement('div');
        wrapper.className = prefixCls + "-ui-notice-wrap";
        wrapper = document.body.appendChild(wrapper);
      }

      return wrapper;
    };

    var wrapper = getWrapper();
    return {
      notice: function notice(noticeProps) {
        if (!Notification.notify) {
          react_dom_1["default"].render(react_1["default"].createElement(Notification, __assign({
            ref: function ref(node) {
              Notification.notify = node;
              Notification.notify.addNotice(noticeProps);
            },
            isFlag: true
          }, props)), wrapper);
        } else {
          Notification.notify.addNotice(noticeProps);
        }
      },
      clear: function clear() {
        if (!Notification.notify) {
          react_dom_1["default"].render(react_1["default"].createElement(Notification, __assign({
            ref: function ref(node) {
              Notification.notify = node;
              Notification.notify.removeAll();
            },
            isFlag: true
          }, props)), wrapper);
        } else {
          Notification.notify.removeAll();
        }
      }
    };
  };

  return Notification;
}(react_1["default"].Component);

exports["default"] = Notification;