"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var Grid_1 = require("../Grid");

var Button_1 = __importDefault(require("../Button"));

var language_1 = __importDefault(require("./language"));

var utils_1 = require("../../utils");

var usePagination_1 = require("./usePagination");

var ButtonGroup = Button_1["default"].Group;

function MarkerPagination(props) {
  var _a = props.langCode,
      langCode = _a === void 0 ? window.LangCode || 'en' : _a,
      _b = props.hasPrev,
      hasPrev = _b === void 0 ? false : _b,
      _c = props.hasMore,
      hasMore = _c === void 0 ? false : _c,
      _d = props.count,
      count = _d === void 0 ? 0 : _d,
      _e = props.pageSize,
      pageSize = _e === void 0 ? window.PageSize || 20 : _e,
      _f = props.totalCount,
      totalCount = _f === void 0 ? 0 : _f,
      _g = props.justify,
      justify = _g === void 0 ? 'space-between' : _g,
      _h = props.rich,
      rich = _h === void 0 ? false : _h;

  var _j = usePagination_1.useMarkerPagination(props),
      handlePrevClick = _j.handlePrevClick,
      handleMoreClick = _j.handleMoreClick;

  if (totalCount <= 0) {
    return null;
  }

  return react_1["default"].createElement(Grid_1.Row, {
    align: "bottom",
    className: "m-t-md p-l-sm p-r-sm",
    justify: justify,
    type: "flex"
  }, rich ? react_1["default"].createElement("span", {
    style: {
      lineHeight: '35px'
    },
    className: "m-r-sm"
  }, utils_1.tools.string.format(language_1["default"][langCode]['Html4'], totalCount, pageSize)) : react_1["default"].createElement("span", {
    style: {
      lineHeight: '35px'
    },
    className: "m-r-sm"
  }, utils_1.tools.string.format(language_1["default"][langCode]['Html3'], count)), react_1["default"].createElement(ButtonGroup, null, react_1["default"].createElement(Button_1["default"], {
    type: "default",
    icon: "left",
    disabled: !hasPrev,
    onClick: handlePrevClick
  }), react_1["default"].createElement(Button_1["default"], {
    type: "default",
    icon: "right",
    disabled: !hasMore,
    onClick: handleMoreClick,
    iconRight: true
  })));
}

exports["default"] = MarkerPagination;