"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

require("rc-pagination/assets/index.css");

var zh_CN_js_1 = __importDefault(require("rc-pagination/lib/locale/zh_CN.js"));

var en_GB_js_1 = __importDefault(require("rc-pagination/lib/locale/en_GB.js"));

require("./pagination.less");

var rc_pagination_1 = __importDefault(require("rc-pagination"));

var Jumper_1 = __importDefault(require("./Jumper"));

var Grid_1 = require("../Grid");

var classnames_1 = __importDefault(require("classnames"));

var languageData = {
  'en': en_GB_js_1["default"],
  'zh_CN': zh_CN_js_1["default"]
};

function JumperPagination(props) {
  var total = props.total,
      _a = props.className,
      className = _a === void 0 ? '' : _a,
      _b = props.langCode,
      langCode = _b === void 0 ? window.LangCode || 'en' : _b,
      _c = props.pageIndex,
      pageIndex = _c === void 0 ? 1 : _c,
      onPageChange = props.onPageChange,
      onPageSizeChange = props.onPageSizeChange,
      _d = props.style,
      style = _d === void 0 ? null : _d,
      _e = props.pageSize,
      pageSize = _e === void 0 ? 20 : _e,
      _f = props.rich,
      rich = _f === void 0 ? true : _f,
      _g = props.sizeOptions,
      sizeOptions = _g === void 0 ? [10, 20, 30, 50] : _g,
      _h = props.changeAble,
      changeAble = _h === void 0 ? true : _h,
      _j = props.getJumperPopupContainer,
      getJumperPopupContainer = _j === void 0 ? function () {
    return document.body;
  } : _j,
      otherProps = __rest(props, ["total", "className", "langCode", "pageIndex", "onPageChange", "onPageSizeChange", "style", "pageSize", "rich", "sizeOptions", "changeAble", "getJumperPopupContainer"]);

  if (total <= 0) {
    return null;
  }

  var pagination = react_1["default"].createElement(rc_pagination_1["default"], __assign({
    locale: languageData[langCode],
    current: pageIndex,
    onChange: onPageChange,
    pageSize: pageSize,
    style: __assign(__assign({}, style), {
      padding: 0
    }),
    total: total
  }, otherProps));
  return react_1["default"].createElement(react_1["default"].Fragment, null, rich ? react_1["default"].createElement(Grid_1.Row, {
    align: "bottom",
    className: classnames_1["default"]('m-t-md p-l-sm p-r-sm', className),
    justify: "space-between",
    type: "flex"
  }, react_1["default"].createElement(Jumper_1["default"], {
    langCode: langCode,
    pageIndex: pageIndex,
    pageSize: pageSize,
    total: total,
    options: sizeOptions,
    onPageSizeChange: onPageSizeChange,
    changeAble: changeAble,
    getPopupContainer: getJumperPopupContainer
  }), pagination) : react_1["default"].createElement(Grid_1.Row, {
    justify: "end",
    className: classnames_1["default"]('m-t-md p-r-sm', className)
  }, pagination));
}

exports["default"] = JumperPagination;