"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useMarkerPagination = exports.useJumper = void 0;

var utils_1 = require("../../utils");

var language_1 = __importDefault(require("./language"));

exports.useJumper = function (_a) {
  var _b = _a.pageIndex,
      pageIndex = _b === void 0 ? 1 : _b,
      _c = _a.pageSize,
      pageSize = _c === void 0 ? 10 : _c,
      _d = _a.langCode,
      langCode = _d === void 0 ? window.LangCode || 'en' : _d,
      _e = _a.onPageSizeChange,
      onPageSizeChange = _e === void 0 ? null : _e,
      total = _a.total;
  var endCount = pageIndex * pageSize;
  var html1 = utils_1.tools.string.format(language_1["default"][langCode]['Html1'], endCount - pageSize + 1, endCount > total ? total : endCount, total);
  var html20 = language_1["default"][langCode]['Html2_0'];
  var html21 = language_1["default"][langCode]['Html2_1'];

  var handleChange = function handleChange(pageSize) {
    if (typeof onPageSizeChange === 'function') {
      onPageSizeChange(+pageSize);
    }
  };

  return {
    html1: html1,
    html20: html20,
    html21: html21,
    handleChange: handleChange
  };
};

exports.useMarkerPagination = function (_a) {
  var _b = _a.hasPrev,
      hasPrev = _b === void 0 ? false : _b,
      _c = _a.hasMore,
      hasMore = _c === void 0 ? false : _c,
      onChange = _a.onChange;

  var handlePrevClick = function handlePrevClick() {
    hasPrev && onChange(true);
  };

  var handleMoreClick = function handleMoreClick() {
    hasMore && onChange(false);
  };

  return {
    handlePrevClick: handlePrevClick,
    handleMoreClick: handleMoreClick
  };
};