import React, { ReactElement, ReactNode } from 'react';
import './panel.less';
export interface PanelProps {
    prefixCls?: string;
    className?: string;
    style?: object;
    panelStyle?: object;
    type?: 'default' | 'primary' | 'success' | 'warning' | 'danger';
    children: string | ReactElement;
    title?: string | ReactElement | ReactNode;
    titleRight?: string | ReactElement | ReactNode;
    leftBar?: ReactNode;
    rightBar?: ReactNode;
    footer?: string | ReactElement;
    collapse?: boolean;
    isFlag?: boolean;
    movable?: boolean;
    onCollapse?(value: boolean): void;
    onMouseMove?(value: React.MouseEvent): void;
    onMouseDown?(value: React.MouseEvent): void;
    onMouseUp?(value: React.MouseEvent): void;
}
declare const Panel: {
    (props: PanelProps): JSX.Element;
    PanelTitle: (props: import("./PanelTitle").PanelTitleProps) => JSX.Element;
    PanelRight: (props: import("./PanelRight").PanelRightProps) => JSX.Element;
};
export default Panel;
