"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
/*
 * @Author: SiMeiyu
 * @Date: 2017-07-04 10:05:42
 */

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var PanelTitle_1 = __importDefault(require("./PanelTitle"));

var PanelRight_1 = __importDefault(require("./PanelRight"));

var useCollapse_1 = __importDefault(require("./useCollapse"));

var Button_1 = __importDefault(require("../Button"));

var Tooltip_1 = require("../Tooltip");

require("./panel.less");

var Panel = function Panel(props) {
  var _a;

  var _b = props.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      className = props.className,
      _c = props.style,
      style = _c === void 0 ? {} : _c,
      panelStyle = props.panelStyle,
      _d = props.type,
      type = _d === void 0 ? 'default' : _d,
      title = props.title,
      titleRight = props.titleRight,
      collapse = props.collapse,
      movable = props.movable,
      rightBar = props.rightBar,
      leftBar = props.leftBar,
      _e = props.footer,
      footer = _e === void 0 ? '' : _e,
      children = props.children,
      onMouseDown = props.onMouseDown;

  var _f = useCollapse_1["default"](props),
      isNewFlag = _f.isNewFlag,
      handleCollapse = _f.handleCollapse;

  var classes = classnames_1["default"](prefixCls + "-panel", (_a = {}, _a[prefixCls + "-panel-" + type] = type, _a), className);

  var renderCollapse = function renderCollapse() {
    var clazzIcon = isNewFlag ? 'add' : 'minus';
    var open = window.LangCode === 'zh_CN' ? '展开' : 'Expand';
    var close = window.LangCode === 'zh_CN' ? '收起' : 'Collapse';
    return react_1["default"].createElement(Tooltip_1.Tooltip, {
      tips: isNewFlag ? open : close
    }, react_1["default"].createElement(Button_1["default"], {
      type: "default",
      size: "small",
      icon: clazzIcon,
      className: classnames_1["default"](prefixCls + "-panel-collapse"),
      onClick: handleCollapse
    }));
  };

  var renderTitle = function renderTitle() {
    var _a;

    var move = window.LangCode === 'zh_CN' ? '拖动' : 'Drag';
    return react_1["default"].createElement("div", {
      className: classnames_1["default"](prefixCls + "-panel-heading", (_a = {}, _a[prefixCls + "-border-collapse"] = isNewFlag, _a))
    }, typeof title === 'string' ? react_1["default"].createElement("h4", {
      className: classnames_1["default"](prefixCls + "-panel-title")
    }, title) : title, titleRight || collapse || movable ? react_1["default"].createElement("div", {
      className: prefixCls + "-panel-heading-right"
    }, titleRight, collapse ? renderCollapse() : null, movable ? react_1["default"].createElement(Tooltip_1.Tooltip, {
      tips: move
    }, react_1["default"].createElement(Button_1["default"], {
      className: classnames_1["default"](prefixCls + "-panel-move"),
      icon: "move",
      size: "small",
      type: "default",
      onMouseDown: onMouseDown
    })) : null) : null);
  };

  var renderContent = function renderContent() {
    if (isNewFlag) return null;
    return react_1["default"].createElement("div", {
      className: classnames_1["default"](prefixCls + "-panel-content"),
      style: style
    }, children);
  };

  var renderFooter = function renderFooter() {
    return footer ? react_1["default"].createElement("div", {
      className: classnames_1["default"](prefixCls + "-panel-footer")
    }, footer) : null;
  };

  return react_1["default"].createElement("div", {
    className: classes,
    style: panelStyle
  }, leftBar || rightBar ? react_1["default"].createElement("div", {
    className: prefixCls + "-panel-flex"
  }, leftBar, react_1["default"].createElement("div", {
    style: {
      width: '75%'
    }
  }, title ? renderTitle() : null, renderContent(), renderFooter()), rightBar) : react_1["default"].createElement("div", null, title ? renderTitle() : null, renderContent(), renderFooter()));
};

Panel.PanelTitle = PanelTitle_1["default"];
Panel.PanelRight = PanelRight_1["default"];
exports["default"] = Panel;