"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _outy = _interopRequireDefault(require("outy"));

var _reactPopper = require("react-popper");

require("./index.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var NeoPopper = /*#__PURE__*/function (_React$Component) {
  _inherits(NeoPopper, _React$Component);

  var _super = _createSuper(NeoPopper);

  function NeoPopper(props) {
    var _this;

    _classCallCheck(this, NeoPopper);

    _this = _super.call(this, props);
    _this.state = {
      isOpen: false
    };
    return _this;
  }

  _createClass(NeoPopper, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._setOutsideTap();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(lastProps, lastState) {
      var _this2 = this;

      if (lastState.isOpen !== this.state.isOpen) {
        setTimeout(function () {
          return _this2._setOutsideTap();
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.outsideTap) {
        this.outsideTap.remove();
      }
    }
  }, {
    key: "_setOutsideTap",
    value: function _setOutsideTap() {
      if (this.target) {
        var elms = [this.target];

        if (this.popper) {
          elms.push(this.popper);
        }

        if (this.outsideTap) {
          this.outsideTap.remove();
        }

        this.outsideTap = (0, _outy["default"])(elms, ['click'], this._handleOutsideTap.bind(this));
      }
    }
  }, {
    key: "_handleOutsideTap",
    value: function _handleOutsideTap(ev) {
      var $popper = document.getElementById('popper-list');

      if ($popper && !this.isClickInPopper(ev.target, $popper)) {
        this.setState({
          isOpen: false
        });
      }
    }
  }, {
    key: "_handleTargetClick",
    value: function _handleTargetClick() {
      this.setState({
        isOpen: true
      });
    }
  }, {
    key: "isClickInPopper",
    value: function isClickInPopper(child, parent) {
      if (!child) {
        return false;
      }

      var node = child.parentNode;

      while (node != null) {
        if (node === parent) {
          return true;
        }

        node = node.parentNode;
      }

      return false;
    }
  }, {
    key: "renderTarget",
    value: function renderTarget() {
      var _this3 = this;

      var _this$props = this.props,
          trigger = _this$props.trigger,
          target = _this$props.target;

      if (trigger === 'click') {
        return /*#__PURE__*/_react["default"].createElement(_reactPopper.Target, {
          className: "popper-target"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          ref: function ref(node) {
            _this3.target = node;
          },
          onClick: this._handleTargetClick.bind(this)
        }, target));
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props2 = this.props,
          content = _this$props2.content,
          placement = _this$props2.placement;
      var isOpen = this.state.isOpen;
      return /*#__PURE__*/_react["default"].createElement(_reactPopper.Manager, {
        className: "popper-manager"
      }, this.renderTarget(), isOpen ? /*#__PURE__*/_react["default"].createElement(_reactPopper.Popper, {
        className: "popper-pop",
        placement: placement
      }, function (_ref) {
        var popperProps = _ref.popperProps;
        return /*#__PURE__*/_react["default"].createElement("div", _extends({
          id: "popper-list",
          ref: function ref(node) {
            _this4.popper = node;
          }
        }, popperProps, {
          className: "popper-list"
        }), content, /*#__PURE__*/_react["default"].createElement(_reactPopper.Arrow, null, function (_ref2) {
          var arrowProps = _ref2.arrowProps;
          return /*#__PURE__*/_react["default"].createElement("span", _extends({}, arrowProps, {
            className: "popper-arrow"
          }));
        }));
      }) : null);
    }
  }]);

  return NeoPopper;
}(_react["default"].Component);

NeoPopper.propTypes = {
  target: _propTypes["default"].element.isRequired,
  // 触发目标
  content: _propTypes["default"].element.isRequired,
  // 气泡内容
  trigger: _propTypes["default"].oneOf(['click']),
  // 触发事件，暂时只支持click
  placement: _propTypes["default"].oneOf(['right', 'right-start', 'right-end', 'left', 'left-start', 'left-end', 'top', 'top-start', 'top-end', 'bottom', 'bottom-start', 'bottom-end', 'auto'])
};
NeoPopper.defaultProps = {
  trigger: 'click',
  placement: 'rigth-start'
};
var _default = NeoPopper;
exports["default"] = _default;