"use strict";

var __createBinding = void 0 && (void 0).__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = void 0 && (void 0).__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = void 0 && (void 0).__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
/*
 * @Author: SiMeiyu
 * @Date: 2017-07-04 10:06:09
 */

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

require("./progress.less");

var getType = function getType(perc, room, props) {
  var _a = props.type,
      type = _a === void 0 ? 'primary' : _a,
      _b = props.dangerValue,
      dangerValue = _b === void 0 ? 95 : _b,
      _c = props.warningValue,
      warningValue = _c === void 0 ? 70 : _c,
      _d = props.isPrimary,
      isPrimary = _d === void 0 ? false : _d;

  if (isPrimary) {
    type = 'primary';
  } else {
    if (props.dynamic) {
      var used = 100 - room;

      switch (true) {
        case perc + used >= dangerValue:
          type = 'danger';
          break;

        case perc + used >= warningValue:
          type = 'warning';
          break;

        default:
          type = 'primary';
      }
    }
  }

  return type;
};

var ProgressBar = function ProgressBar(props) {
  var _a;

  var _b = props.percent,
      percent = _b === void 0 ? 30 : _b,
      _c = props.prefixCls,
      prefixCls = _c === void 0 ? 'ult' : _c,
      _d = props.room,
      room = _d === void 0 ? 100 : _d;

  var _e = react_1.useState(getType(percent, room, props)),
      type = _e[0],
      setType = _e[1];

  var status = '';

  switch (type) {
    case 'info':
      status = '（信息）';
      break;

    case 'warning':
      status = '（警告）';
      break;

    case 'success':
      status = '（成功）';
      break;

    case 'danger':
      status = '（危险）';
      break;

    default:
      status = '';
  }

  react_1.useEffect(function () {
    setType(getType(percent, room, props));
  }, [percent, room]);
  return react_1["default"].createElement("div", {
    className: classnames_1["default"]((_a = {}, _a[prefixCls + "-progress-bar"] = true, _a[prefixCls + "-progress-bar-" + type] = true, _a)),
    style: {
      width: percent + "%"
    }
  }, react_1["default"].createElement("span", {
    className: "sr-only"
  }, percent, "% \u5B8C\u6210", status));
};

exports["default"] = ProgressBar;