"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames2 = _interopRequireDefault(require("classnames"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Dialog = require("../Dialog");

var _language = _interopRequireDefault(require("./language"));

var _ = _interopRequireWildcard(require("lodash"));

require("./index.less");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Form = /*#__PURE__*/function (_React$Component) {
  _inherits(Form, _React$Component);

  var _super = _createSuper(Form);

  function Form(props) {
    var _this;

    _classCallCheck(this, Form);

    _this = _super.call(this, props);

    _this.clearFormState = function () {
      window.dirtyFormPopState = false;
      window.hasDirtyForm = false;
      window.onpopstate = null;
      window.onbeforeunload = null;
    };

    _this.handleBeforeUnload = function (e) {
      e = e || window.event;
      var isTouched = false;

      if (_this.props.form.isFieldsTouched) {
        isTouched = _this.props.form.isFieldsTouched();
      }

      if (!(window.hasDirtyForm || isTouched)) {
        return null;
      } // 兼容IE8和Firefox 4之前的版本


      if (e) {
        e.returnValue = _language["default"][window.LangCode]['DirtyFormWarning'];
      } // Chrome, Safari, Firefox 4+, Opera 12+ , IE 9+


      return _language["default"][window.LangCode]['DirtyFormWarning'];
    };

    _this.handlePopState = function () {
      var isTouched = false;

      if (_this.props.form.isFieldsTouched) {
        isTouched = _this.props.form.isFieldsTouched();
      }

      var clearFormState = _this.clearFormState;

      if ((window.hasDirtyForm || isTouched) && !window.dirtyFormPopState) {
        window.dirtyFormPopState = true;
        (0, _Dialog.confirmForm)({
          title: _language["default"][window.LangCode]['WillLeave'],
          content: _language["default"][window.LangCode]['DirtyFormWarning'],
          type: 'warning',
          abortTitle: window.LanguageData[window.LangCode]['Cancel'],
          abort: function abort() {
            history.pushState({
              key: 'dirtyForm'
            }, null, _this.currentUrl);
            window.dirtyFormPopState = false;
          },
          confirm: function confirm() {
            clearFormState();
            history.go(-1);
          }
        });
      } else {
        clearFormState();
        history.go(-1);
      }
    };

    _this.state = {
      isValidated: false
    };
    _this.currentUrl = document.URL;
    _this.submiting = false;
    _this.timer = null;
    return _this;
  }

  _createClass(Form, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.onpopstate = this.handlePopState;
      window.onbeforeunload = this.handleBeforeUnload;

      if (_.get(history, 'state.key', '') === 'dirtyForm') {
        return;
      }

      history.pushState({
        key: 'dirtyForm'
      }, null, this.currentUrl);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.timer);
      this.timer = null;
      this.clearFormState();
    }
  }, {
    key: "handleChange",
    value: function handleChange(e) {
      window.hasDirtyForm = true;
    }
  }, {
    key: "handleSubmit",

    /**
     * 提交处理，提交后1秒内禁止重复提交
     * @param  {[type]} e [description]
     * @return {[type]}   [description]
     */
    value: function handleSubmit(e) {
      var _this2 = this;

      e.preventDefault();
      var me = this;

      if (me.submiting) {
        return;
      }

      var _this$props = this.props,
          form = _this$props.form,
          onSubmit = _this$props.onSubmit,
          autoValidateOnSubmit = _this$props.autoValidateOnSubmit;

      if (autoValidateOnSubmit) {
        form.validateFields(function (error, values) {
          if (!error) {
            if (onSubmit) {
              _this2.submiting = true;
              onSubmit(e);
              me.timer = setTimeout(function () {
                me.submiting = false;
              }, 1000);
            }

            form.valid = true;
          } else {
            form.valid = false;
            var errorE = Object.keys(error)[0];

            if (document.getElementsByName(errorE)) {
              document.getElementsByName(errorE)[0].scrollIntoView();
            }
          }

          _this2.setState({
            isValidated: true
          });
        });
      } else {
        if (onSubmit) {
          onSubmit(e);
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames;

      var _this$props2 = this.props,
          prefixCls = _this$props2.prefixCls,
          className = _this$props2.className,
          style = _this$props2.style,
          inline = _this$props2.inline,
          noLabel = _this$props2.noLabel,
          subMessage = _this$props2.subMessage,
          formRef = _this$props2.formRef,
          autoValidateOnSubmit = _this$props2.autoValidateOnSubmit,
          other = _objectWithoutProperties(_this$props2, ["prefixCls", "className", "style", "inline", "noLabel", "subMessage", "formRef", "autoValidateOnSubmit"]);

      var classes = (0, _classnames2["default"])((_classnames = {}, _defineProperty(_classnames, "".concat(prefixCls, "-rcform"), !inline), _defineProperty(_classnames, "".concat(prefixCls, "-rcform-inline"), inline), _defineProperty(_classnames, "".concat(prefixCls, "-rcform-noLabel"), noLabel), _defineProperty(_classnames, "".concat(prefixCls, "-rcform-subMessage"), subMessage), _defineProperty(_classnames, "validated", this.state.isValidated), _classnames), className);
      return /*#__PURE__*/_react["default"].createElement("form", _extends({
        className: classes,
        style: style
      }, other, {
        ref: formRef,
        onSubmit: this.handleSubmit.bind(this),
        onChange: this.handleChange.bind(this)
      }), this.props.children);
    }
  }]);

  return Form;
}(_react["default"].Component);

Form.propTypes = {
  form: _propTypes["default"].object.isRequired,
  // rc-form
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  noLabel: _propTypes["default"].bool,
  // 是否有Label
  subMessage: _propTypes["default"].bool,
  inline: _propTypes["default"].bool,
  // 是否一行显示
  onSubmit: _propTypes["default"].func,
  // 提交回调函数
  children: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].element, _propTypes["default"].node]),
  autoValidateOnSubmit: _propTypes["default"].bool,
  formRef: _propTypes["default"].func
};
Form.defaultProps = {
  prefixCls: 'ult',
  className: '',
  style: null,
  noLabel: false,
  subMessage: false,
  inline: false,
  onSubmit: undefined,
  children: null,
  formRef: undefined,
  autoValidateOnSubmit: true
};
var _default = Form;
exports["default"] = _default;