"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames3 = _interopRequireDefault(require("classnames"));

var _uuid = _interopRequireDefault(require("uuid"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _language = _interopRequireDefault(require("./language"));

var _Label = _interopRequireDefault(require("../Label"));

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ = window._;

var WrapFormItem = function WrapFormItem(ComposedComponent) {
  var _class, _temp;

  return _temp = _class = /*#__PURE__*/function (_React$Component) {
    _inherits(_class, _React$Component);

    var _super = _createSuper(_class);

    function _class(_props) {
      var _this;

      _classCallCheck(this, _class);

      _this = _super.call(this, _props);

      _this.getValueOrDefaultValueInProps = function () {
        var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props;

        if ('value' in props) {
          return props.value;
        } else if ('defaultValue' in props) {
          return props.defaultValue;
        }

        return '';
      };

      _this.genRequiredRules = function (rules) {
        var _this$props = _this.props,
            isRequired = _this$props.isRequired,
            requiredMsg = _this$props.requiredMsg,
            langCode = _this$props.langCode,
            label = _this$props.label;

        if (isRequired) {
          rules.splice(0, 0, {
            required: isRequired,
            message: requiredMsg || _utils.tools.string.format(_language["default"][langCode]['Required'], label)
          });
        }
      };

      _this.genRegexRules = function (rules) {
        var _this$props2 = _this.props,
            validRegex = _this$props2.validRegex,
            invalidMessage = _this$props2.invalidMessage;

        if (validRegex && invalidMessage) {
          rules.push(function (rule, value, callback) {
            if (value) {
              validRegex.lastIndex = 0;

              if (validRegex.test(value)) {
                callback();
              } else {
                callback(invalidMessage);
              }
            } else {
              callback();
            }
          });
        }
      };

      _this.genAsyncValidate = function () {
        var validate = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        var asyncValidate = _this.props.asyncValidate;

        if (asyncValidate) {
          validate.push({
            trigger: 'onBlur',
            rules: [function (rule, value, callback) {
              if (_this._errors.length > 0) {
                callback(_this._errors[0]);
              }

              if (_this.validateValue !== value) {
                _this.validateValue = value;

                if (value) {
                  asyncValidate(value, callback);
                } else {
                  callback();
                }
              } else {
                callback();
              }
            }]
          });
        }

        return validate;
      };

      _this.updateFormValueByProps = function (_ref) {
        var _ref$value = _ref.value,
            value = _ref$value === void 0 ? null : _ref$value;

        if (value !== null) {
          var _this$props3 = _this.props,
              form = _this$props3.form,
              name = _this$props3.name;
          var oldValue = form.getFieldValue(name);

          if (!_.isEqual(value, oldValue)) {
            _this.setState({
              value: value
            }, function () {
              form.setFieldsValue(_defineProperty({}, "".concat(name), value));
            });
          }
        }
      };

      _this.key = _uuid["default"].v4(); // 规则池

      window.RcFormRulesPool = window.RcFormRulesPool || {};
      window.RcFormRulesPool[_this.key] = _this.genRules();
      _this.validateValue = null;
      _this._errors = null;
      _this.state = {
        value: _this.getValueOrDefaultValueInProps(_props)
      };
      return _this;
    }

    _createClass(_class, [{
      key: "componentWillReceiveProps",
      value: function componentWillReceiveProps(nextProps) {
        this.updateFormValueByProps(nextProps);
      }
      /**
       * 使用props中的defaultValue或value其一作为当前的值
       */

    }, {
      key: "genRules",

      /**
       * 生成最终校验规则
       */
      value: function genRules() {
        var rules = this.props.rules.slice(0);
        this.genRequiredRules(rules);
        this.genRegexRules(rules);
        return {
          rules: rules,
          validate: this.genAsyncValidate(this.props.validate.slice(0))
        };
      }
      /**
       * 判断是否显示必填样式
       * @param  {string} value
       * @param  {array} errors
       * @return {boolean}
       */

    }, {
      key: "showRequired",
      value: function showRequired(value, errors) {
        if (_.isEmpty(value) && errors.length > 0) {
          return true;
        }

        return false;
      }
      /**
       * 解决页面使用RcForm时，state中的表单项value改变，但是form field值不变的问题
       */

    }, {
      key: "render",
      value: function render() {
        var _classnames;

        var _this$props4 = this.props,
            prefixCls = _this$props4.prefixCls,
            className = _this$props4.className,
            style = _this$props4.style,
            isRequired = _this$props4.isRequired,
            form = _this$props4.form,
            validRegex = _this$props4.validRegex,
            invalidMessage = _this$props4.invalidMessage,
            asyncValidate = _this$props4.asyncValidate,
            langCode = _this$props4.langCode,
            name = _this$props4.name,
            label = _this$props4.label,
            hideLabel = _this$props4.hideLabel,
            errorMsg = _this$props4.errorMsg,
            tips = _this$props4.tips,
            placement = _this$props4.placement,
            others = _objectWithoutProperties(_this$props4, ["prefixCls", "className", "style", "isRequired", "form", "validRegex", "invalidMessage", "asyncValidate", "langCode", "name", "label", "hideLabel", "errorMsg", "tips", "placement"]);

        var getFieldError = form.getFieldError,
            getFieldValue = form.getFieldValue;
        var errors = getFieldError(name) || []; // 错误

        this._errors = errors.slice(0);
        var curValue = getFieldValue(name) || ''; // 当前Input的值

        var required = isRequired && this.showRequired(curValue, errors);
        var classes = (0, _classnames3["default"])("".concat(prefixCls, "-rcform-group"), (_classnames = {}, _defineProperty(_classnames, "".concat(prefixCls, "-rcform-group-validated"), errors.length > 0), _defineProperty(_classnames, "required", required), _defineProperty(_classnames, "error", !required && errors.length > 0), _classnames), className);
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: classes,
          style: style
        }, /*#__PURE__*/_react["default"].createElement(_Label["default"], {
          name: label,
          tips: tips,
          placement: placement,
          require: isRequired,
          className: (0, _classnames3["default"])(_defineProperty({}, "".concat(prefixCls, "-rcform-label-hide"), hideLabel))
        }), /*#__PURE__*/_react["default"].createElement(ComposedComponent, _extends({
          id: this.key,
          form: form,
          prefixCls: prefixCls,
          name: name,
          label: label,
          langCode: langCode,
          isRequired: isRequired,
          hasAsyncValidate: !!this.props.asyncValidate
        }, others)), /*#__PURE__*/_react["default"].createElement("span", {
          className: "validation-error"
        }, errors ? errors[0] : null), errorMsg ? /*#__PURE__*/_react["default"].createElement("span", {
          className: "custom-error"
        }, errorMsg) : null);
      }
    }]);

    return _class;
  }(_react["default"].Component), _class.propTypes = {
    prefixCls: _propTypes["default"].string,
    className: _propTypes["default"].string,
    // 样式类
    style: _propTypes["default"].object,
    // 行内样式
    form: _propTypes["default"].object.isRequired,
    // rc-form
    langCode: _propTypes["default"].string,
    // 语言码(zh_CN || en)
    name: _propTypes["default"].string.isRequired,
    // 名称
    label: _propTypes["default"].string,
    // 标签
    hideLabel: _propTypes["default"].bool,
    // 隐藏标签
    rules: _propTypes["default"].array,
    // 校验规则
    validate: _propTypes["default"].array,
    // 校验时机及校验规则
    isRequired: _propTypes["default"].bool,
    // 是否必填
    requiredMsg: _propTypes["default"].string,
    // 未填提示
    errorMsg: _propTypes["default"].string,
    // 自定义错误信息，不为空的时候直接会显示出来
    // tooltip
    placement: _propTypes["default"].oneOf(['bottom', 'top', 'left', 'right']),
    tips: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].element, _propTypes["default"].node])
  }, _class.defaultProps = {
    prefixCls: 'ult',
    className: '',
    style: null,
    langCode: window.LangCode || 'en',
    label: '',
    hideLabel: false,
    rules: [],
    validate: [],
    isRequired: false,
    requiredMsg: null,
    errorMsg: '',
    tips: '',
    placement: 'top'
  }, _temp;
};

var _default = WrapFormItem;
exports["default"] = _default;