"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Row = _interopRequireDefault(require("../Grid/Row"));

var _Col = _interopRequireDefault(require("../Grid/Col"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var FormRow = /*#__PURE__*/function (_React$Component) {
  _inherits(FormRow, _React$Component);

  var _super = _createSuper(FormRow);

  function FormRow() {
    _classCallCheck(this, FormRow);

    return _super.apply(this, arguments);
  }

  _createClass(FormRow, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          prefixCls = _this$props.prefixCls,
          className = _this$props.className,
          style = _this$props.style,
          mainStyle = _this$props.mainStyle,
          children = _this$props.children,
          separate = _this$props.separate;
      var classes = (0, _classnames["default"])("".concat(prefixCls, "-rcform-row"), className);
      var oneElm = children[0] || null;
      var towElm = children[1] || null;
      var threeElm = children[2] || null;
      var oneCol = towElm ? 3 : 12;
      var towCol = threeElm ? 6 : 9;

      var main = /*#__PURE__*/_react["default"].createElement(_Row["default"], {
        className: classes,
        style: style,
        align: "stretch"
      }, oneElm ? /*#__PURE__*/_react["default"].createElement(_Col["default"], {
        span: oneCol,
        className: "".concat(prefixCls, "-rcform-row-oneCol")
      }, oneElm) : null, towElm ? /*#__PURE__*/_react["default"].createElement(_Col["default"], {
        span: towCol,
        className: "".concat(prefixCls, "-rcform-row-towCol"),
        style: mainStyle
      }, towElm) : null, threeElm ? /*#__PURE__*/_react["default"].createElement(_Col["default"], {
        span: threeElm,
        className: "".concat(prefixCls, "-rcform-row-threeCol")
      }, threeElm) : null);

      if (separate) {
        return /*#__PURE__*/_react["default"].createElement("div", null, main, /*#__PURE__*/_react["default"].createElement(_Row["default"], {
          className: "".concat(prefixCls, "-rcform-row-separate")
        }, oneElm ? /*#__PURE__*/_react["default"].createElement(_Col["default"], {
          span: oneCol,
          className: "".concat(prefixCls, "-rcform-row-separate-oneCol")
        }, /*#__PURE__*/_react["default"].createElement("hr", null), /*#__PURE__*/_react["default"].createElement("hr", null)) : null, towElm ? /*#__PURE__*/_react["default"].createElement(_Col["default"], {
          span: towCol,
          className: "".concat(prefixCls, "-rcform-row-separate-towCol")
        }, /*#__PURE__*/_react["default"].createElement("hr", null), /*#__PURE__*/_react["default"].createElement("hr", null)) : null, threeElm ? /*#__PURE__*/_react["default"].createElement(_Col["default"], {
          span: threeElm,
          className: "".concat(prefixCls, "-rcform-row-separate-threeCol")
        }, /*#__PURE__*/_react["default"].createElement("hr", null), /*#__PURE__*/_react["default"].createElement("hr", null)) : null));
      }

      return main;
    }
  }]);

  return FormRow;
}(_react["default"].Component);

FormRow.propTypes = {
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  mainStyle: _propTypes["default"].object,
  // 主内容行内样式
  children: _propTypes["default"].arrayOf(_propTypes["default"].node),
  // 子元素(1~3个)
  separate: _propTypes["default"].bool // 底部是否有分隔线

};
FormRow.defaultProps = {
  prefixCls: 'ult',
  className: '',
  style: null,
  mainStyle: null,
  children: null,
  separate: false
};
var _default = FormRow;
exports["default"] = _default;