"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames2 = _interopRequireDefault(require("classnames"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Input = _interopRequireDefault(require("../../Input"));

var _Button = _interopRequireDefault(require("../../Button"));

var _Loading = _interopRequireDefault(require("../../Loading"));

var _language = _interopRequireDefault(require("../language"));

var _utils = require("../../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var noop = function noop() {};

var FormInput = /*#__PURE__*/function (_React$Component) {
  _inherits(FormInput, _React$Component);

  var _super = _createSuper(FormInput);

  function FormInput(props) {
    var _this;

    _classCallCheck(this, FormInput);

    _this = _super.call(this, props);
    _this.state = {
      codeBtn: true,
      s: '30'
    };
    _this.timer = null;
    return _this;
  }

  _createClass(FormInput, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      delete window.RcFormRulesPool[this._key];
      this.timer = null;
    }
  }, {
    key: "issueIdentifyCode",
    value: function issueIdentifyCode() {
      var handleIdentifyCode = this.props.handleIdentifyCode;
      this.setState({
        codeBtn: false
      });
      var Num = '';

      for (var i = 0; i < 6; i++) {
        Num += Math.floor(Math.random() * 10);
      }

      handleIdentifyCode(Num);
      var space = 30;

      this.timer = function () {
        var _this2 = this;

        if (space > 0) {
          this.setState({
            s: space
          });
          space--;
          setTimeout(function () {
            _this2.timer();
          }, 1000);
        } else {
          this.setState({
            codeBtn: true
          });
        }
      };

      this.timer();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          langCode = _this$props.langCode,
          id = _this$props.id,
          form = _this$props.form,
          prefixCls = _this$props.prefixCls,
          name = _this$props.name,
          type = _this$props.type,
          value = _this$props.value,
          identify = _this$props.identify,
          readOnly = _this$props.readOnly,
          disabled = _this$props.disabled,
          trigger = _this$props.trigger,
          validateTrigger = _this$props.validateTrigger,
          validateFirst = _this$props.validateFirst,
          placeholder = _this$props.placeholder,
          icon = _this$props.icon,
          unit = _this$props.unit,
          hasAsyncValidate = _this$props.hasAsyncValidate,
          handleIdentifyCode = _this$props.handleIdentifyCode,
          maxLength = _this$props.maxLength,
          isRequired = _this$props.isRequired,
          autocomplete = _this$props.autocomplete;
      var _this$props2 = this.props,
          onChange = _this$props2.onChange,
          onClick = _this$props2.onClick,
          onBlur = _this$props2.onBlur;
      var _this$state = this.state,
          s = _this$state.s,
          codeBtn = _this$state.codeBtn;
      var getFieldProps = form.getFieldProps,
          isFieldValidating = form.isFieldValidating;
      var isValidating = isFieldValidating(name); // 校验中

      var _window$RcFormRulesPo = window.RcFormRulesPool[id],
          rules = _window$RcFormRulesPo.rules,
          validate = _window$RcFormRulesPo.validate;
      var inputProps = {
        type: type,
        name: name,
        maxLength: maxLength,
        readOnly: readOnly,
        placeholder: placeholder,
        icon: icon,
        unit: unit,
        autocomplete: autocomplete,
        onClick: onClick,
        disabled: disabled || !!isValidating
      };

      if (onBlur) {
        inputProps.onBlur = onBlur;
      }

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames2["default"])("".concat(prefixCls, "-rcform-group-input-wrapper"), _defineProperty({}, "".concat(prefixCls, "-rcform-group-input-wrapper-identifyCode"), identify))
      }, /*#__PURE__*/_react["default"].createElement(_Input["default"], _extends({}, getFieldProps(name, {
        valuePropName: 'value',
        initialValue: value,
        validateFirst: validateFirst,
        rules: rules,
        validate: validate,
        trigger: trigger,
        validateTrigger: validateTrigger,
        onChange: onChange
      }), inputProps)), hasAsyncValidate && isValidating ? /*#__PURE__*/_react["default"].createElement(_Loading["default"], {
        size: 16,
        style: {
          width: '16px',
          height: '16px',
          position: 'absolute',
          right: '8px',
          top: '8px'
        }
      }) : null, identify && handleIdentifyCode ? /*#__PURE__*/_react["default"].createElement(_Button["default"], {
        className: "btn-identifyCode",
        type: "default",
        name: codeBtn ? _language["default"][langCode]['SendIdentifyCode'] : _utils.tools.string.format(_language["default"][langCode]['Resend'], s),
        disabled: !codeBtn,
        onClick: this.issueIdentifyCode.bind(this)
      }) : null);
    }
  }]);

  return FormInput;
}(_react["default"].Component);

FormInput.propTypes = {
  id: _propTypes["default"].string.isRequired,
  form: _propTypes["default"].object.isRequired,
  // rc-form
  prefixCls: _propTypes["default"].string,
  langCode: _propTypes["default"].string.isRequired,
  // 语言码(zh_CN || en)
  name: _propTypes["default"].string.isRequired,
  // 名称
  maxLength: _propTypes["default"].number,
  // 最大长度
  type: _propTypes["default"].string,
  // input类型
  placeholder: _propTypes["default"].string,
  // 提示
  value: _propTypes["default"].string,
  // 初始值
  label: _propTypes["default"].string,
  // 标签
  icon: _propTypes["default"].string,
  // 图标
  unit: _propTypes["default"].string,
  // 单位
  onChange: _propTypes["default"].func,
  // 值改变时回调函数
  onClick: _propTypes["default"].func,
  onBlur: _propTypes["default"].func,
  isRequired: _propTypes["default"].bool,
  // 是否必填
  identify: _propTypes["default"].bool,
  // 需要验证码
  readOnly: _propTypes["default"].bool,
  // 只读
  disabled: _propTypes["default"].bool,
  // 禁用
  autocomplete: _propTypes["default"].bool,
  // 是否保存输入记录
  trigger: _propTypes["default"].oneOf(['onChange', 'onBlur']),
  // 收集待校验节点的值的时机，默认"onChange"
  validateTrigger: _propTypes["default"].oneOf(['onChange', 'onBlur']),
  // 校验待校验节点的值的时机，默认"onChange"
  validateFirst: _propTypes["default"].bool,
  // 初始化时是否验证值
  validRegex: _propTypes["default"].object,
  // 校验的正则表达式
  invalidMessage: _propTypes["default"].string,
  // 校验无效的信息
  hasAsyncValidate: _propTypes["default"].bool.isRequired,
  // 是否有异步校验
  handleIdentifyCode: _propTypes["default"].func // 验证码处理回调函数

};
FormInput.defaultProps = {
  prefixCls: 'ult',
  type: 'text',
  value: '',
  label: '',
  maxLength: 100,
  isRequired: false,
  identify: false,
  readOnly: false,
  disabled: false,
  trigger: 'onChange',
  validateTrigger: 'onChange',
  validateFirst: false,
  placeholder: '',
  icon: null,
  unit: null,
  onChange: undefined,
  validRegex: null,
  invalidMessage: '',
  handleIdentifyCode: undefined,
  autocomplete: true,
  onClick: noop,
  onBlur: undefined
};
var _default = FormInput;
exports["default"] = _default;