"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _RadioGroup = _interopRequireDefault(require("../../CheckBox/RadioGroup"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var FormRadioGroup = /*#__PURE__*/function (_React$Component) {
  _inherits(FormRadioGroup, _React$Component);

  var _super = _createSuper(FormRadioGroup);

  function FormRadioGroup() {
    _classCallCheck(this, FormRadioGroup);

    return _super.apply(this, arguments);
  }

  _createClass(FormRadioGroup, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          form = _this$props.form,
          name = _this$props.name,
          prefixCls = _this$props.prefixCls,
          items = _this$props.items,
          inline = _this$props.inline,
          defaultValue = _this$props.defaultValue,
          trigger = _this$props.trigger,
          validateTrigger = _this$props.validateTrigger,
          onChange = _this$props.onChange,
          btnStyle = _this$props.btnStyle;
      var getFieldProps = form.getFieldProps;
      var _window$RcFormRulesPo = window.RcFormRulesPool[id],
          rules = _window$RcFormRulesPo.rules,
          validate = _window$RcFormRulesPo.validate;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-form-group-input-wrapper"),
        name: name
      }, /*#__PURE__*/_react["default"].createElement(_RadioGroup["default"], _extends({}, getFieldProps(name, {
        valuePropName: 'defaultValue',
        initialValue: defaultValue,
        rules: rules,
        validate: validate,
        trigger: trigger,
        validateTrigger: validateTrigger,
        onChange: onChange
      }), {
        name: name,
        items: items,
        inline: inline,
        btnStyle: btnStyle
      })));
    }
  }]);

  return FormRadioGroup;
}(_react["default"].Component);

FormRadioGroup.propTypes = {
  id: _propTypes["default"].string.isRequired,
  form: _propTypes["default"].object.isRequired,
  // rc-form
  prefixCls: _propTypes["default"].string,
  name: _propTypes["default"].string.isRequired,
  // 名称
  inline: _propTypes["default"].bool,
  // 是否一行显示
  btnStyle: _propTypes["default"].bool,
  // 是否按钮样式
  items: _propTypes["default"].array.isRequired,
  // 选项
  defaultValue: _propTypes["default"].string,
  // 默认值
  trigger: _propTypes["default"].oneOf(['onChange', 'onBlur']),
  // 收集待校验节点的值的时机，默认"onChange"
  validateTrigger: _propTypes["default"].oneOf(['onChange', 'onBlur']),
  // 校验待校验节点的值的时机，默认"onChange"
  onChange: _propTypes["default"].func // 值改变时回调函数

};
FormRadioGroup.defaultProps = {
  prefixCls: 'ult',
  inline: false,
  btnStyle: false,
  defaultValue: '',
  trigger: 'onChange',
  validateTrigger: 'onChange',
  onChange: undefined
};
var _default = FormRadioGroup;
exports["default"] = _default;