"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Select = _interopRequireDefault(require("../../Select"));

var _language = _interopRequireDefault(require("../language"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var FormSelect = /*#__PURE__*/function (_React$Component) {
  _inherits(FormSelect, _React$Component);

  var _super = _createSuper(FormSelect);

  function FormSelect() {
    _classCallCheck(this, FormSelect);

    return _super.apply(this, arguments);
  }

  _createClass(FormSelect, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          name = _this$props.name,
          form = _this$props.form,
          id = _this$props.id,
          langCode = _this$props.langCode,
          prefixCls = _this$props.prefixCls,
          options = _this$props.options,
          onChange = _this$props.onChange,
          placeholder = _this$props.placeholder,
          notFoundContent = _this$props.notFoundContent,
          defaultValue = _this$props.defaultValue,
          other = _objectWithoutProperties(_this$props, ["name", "form", "id", "langCode", "prefixCls", "options", "onChange", "placeholder", "notFoundContent", "defaultValue"]);

      var getFieldProps = form.getFieldProps;
      var _window$RcFormRulesPo = window.RcFormRulesPool[id],
          rules = _window$RcFormRulesPo.rules,
          validate = _window$RcFormRulesPo.validate;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-rcform-group-input-wrapper rcform-group-select"),
        name: name
      }, /*#__PURE__*/_react["default"].createElement(_Select["default"], _extends({}, getFieldProps(name, {
        valuePropName: 'value',
        initialValue: defaultValue,
        rules: rules,
        validate: validate,
        onChange: onChange
      }), {
        name: name,
        value: defaultValue,
        placeholder: placeholder,
        notFoundContent: notFoundContent // defaultValue={defaultValue}
        ,
        showSearch: options.length > 8
      }, other), options.map(function (option, index) {
        var value = '';
        var text = '';
        var key = index;

        if (typeof option === 'string') {
          value = text = option;
        } else {
          value = option.value || option.name;
          text = option.text || option.name;
          key = option.key || option.id || index;
        }

        return /*#__PURE__*/_react["default"].createElement(_Select["default"].Option, _extends({}, option, {
          key: key,
          value: value
        }), text);
      })));
    }
  }]);

  return FormSelect;
}(_react["default"].Component);

FormSelect.propTypes = {
  id: _propTypes["default"].string.isRequired,
  form: _propTypes["default"].object.isRequired,
  // rc-form
  prefixCls: _propTypes["default"].string,
  langCode: _propTypes["default"].string.isRequired,
  // 语言码(zh_CN || en)
  name: _propTypes["default"].string.isRequired,
  // 名称
  options: _propTypes["default"].array,
  // 选择项
  placeholder: _propTypes["default"].string,
  // 占位提示
  notFoundContent: _propTypes["default"].string,
  // 未找到选项提示
  tags: _propTypes["default"].bool,
  // 标签模式
  showArrow: _propTypes["default"].bool,
  // 是否显示箭头
  disabled: _propTypes["default"].bool,
  // 是否禁用
  allowClear: _propTypes["default"].bool,
  // 是否可清除
  defaultValue: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].array, _propTypes["default"].object, _propTypes["default"].number]),
  // 默认值
  multiple: _propTypes["default"].bool,
  // 是否多选
  maxTagTextLength: _propTypes["default"].number,
  // 多选最多个数
  onChange: _propTypes["default"].func
};
FormSelect.defaultProps = {
  prefixCls: 'ult',
  options: [],
  placeholder: _language["default"][window.LangCode || 'en']['PleaseSelect'],
  notFoundContent: _language["default"][window.LangCode || 'en']['NotFount'],
  tags: false,
  showArrow: true,
  disabled: false,
  allowClear: false,
  defaultValue: '',
  multiple: false,
  maxTagTextLength: 10,
  onChange: undefined
};
var _default = FormSelect;
exports["default"] = _default;