"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Textarea = _interopRequireDefault(require("../../Textarea"));

var _language = _interopRequireDefault(require("../language"));

var _utils = require("../../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var FormTextarea = /*#__PURE__*/function (_React$Component) {
  _inherits(FormTextarea, _React$Component);

  var _super = _createSuper(FormTextarea);

  function FormTextarea() {
    _classCallCheck(this, FormTextarea);

    return _super.apply(this, arguments);
  }

  _createClass(FormTextarea, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          form = _this$props.form,
          langCode = _this$props.langCode,
          prefixCls = _this$props.prefixCls,
          name = _this$props.name,
          value = _this$props.value,
          readOnly = _this$props.readOnly,
          disabled = _this$props.disabled,
          placeholder = _this$props.placeholder,
          addon = _this$props.addon,
          trigger = _this$props.trigger,
          validateTrigger = _this$props.validateTrigger,
          validateFirst = _this$props.validateFirst,
          onChange = _this$props.onChange,
          minLength = _this$props.minLength,
          maxLength = _this$props.maxLength;
      var getFieldProps = form.getFieldProps;
      var _window$RcFormRulesPo = window.RcFormRulesPool[id],
          rules = _window$RcFormRulesPo.rules,
          validate = _window$RcFormRulesPo.validate;
      var newRules = rules.slice(0);

      if ((minLength > 0 || maxLength > 0) && maxLength > minLength) {
        newRules.push(function (rule, value, callback) {
          if (value) {
            var len = value.length;

            if (len >= minLength && len <= maxLength) {
              callback();
            } else {
              callback(_utils.tools.string.format(_language["default"][langCode]['RangeInput'], minLength, maxLength));
            }
          } else {
            callback();
          }
        });
      }

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-rcform-group-input-wrapper")
      }, /*#__PURE__*/_react["default"].createElement(_Textarea["default"], _extends({}, getFieldProps(name, {
        valuePropName: 'value',
        initialValue: value,
        validateFirst: validateFirst,
        rules: newRules,
        validate: validate,
        trigger: trigger,
        validateTrigger: validateTrigger,
        onChange: onChange
      }), {
        name: name,
        disabled: disabled || readOnly,
        placeholder: placeholder,
        addon: addon,
        maxLength: maxLength
      })));
    }
  }]);

  return FormTextarea;
}(_react["default"].Component);

FormTextarea.propTypes = {
  id: _propTypes["default"].string.isRequired,
  form: _propTypes["default"].object.isRequired,
  // rc-form
  langCode: _propTypes["default"].string.isRequired,
  // 语言码(zh_CN || en)
  prefixCls: _propTypes["default"].string,
  name: _propTypes["default"].string,
  label: _propTypes["default"].string,
  value: _propTypes["default"].string,
  // 初始值
  readOnly: _propTypes["default"].bool,
  // 只读
  disabled: _propTypes["default"].bool,
  // 禁用
  placeholder: _propTypes["default"].string,
  // 提示
  addon: _propTypes["default"].string,
  // 底部提示
  onChange: _propTypes["default"].func,
  // 值改变时回调函数
  minLength: _propTypes["default"].number,
  // 最小长度
  maxLength: _propTypes["default"].number,
  // 最大长度
  trigger: _propTypes["default"].oneOf(['onChange', 'onBlur']),
  // 收集待校验节点的值的时机，默认"onChange"
  validateTrigger: _propTypes["default"].oneOf(['onChange', 'onBlur']),
  // 校验待校验节点的值的时机，默认"onChange"
  validateFirst: _propTypes["default"].bool // 初始化时是否验证值

};
FormTextarea.defaultProps = {
  prefixCls: 'ult',
  name: '',
  label: '',
  value: '',
  readOnly: false,
  disabled: false,
  placeholder: '',
  addon: null,
  onChange: undefined,
  minLength: 0,
  maxLength: 200,
  trigger: 'onChange',
  validateTrigger: 'onChange',
  validateFirst: false
};
var _default = FormTextarea;
exports["default"] = _default;