"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _rcForm = require("rc-form");

var _FormItemWrap = _interopRequireDefault(require("./FormItemWrap"));

var _Form = _interopRequireDefault(require("./Form"));

var _FormGroup = _interopRequireDefault(require("./FormGroup"));

var _FormRow = _interopRequireDefault(require("./FormRow"));

var _Input = _interopRequireDefault(require("./com/Input"));

var _Button = _interopRequireDefault(require("./com/Button"));

var _Textarea = _interopRequireDefault(require("./com/Textarea"));

var _InputGroup = _interopRequireDefault(require("./com/InputGroup"));

var _Select = _interopRequireDefault(require("./com/Select"));

var _Panel = _interopRequireDefault(require("./com/Panel"));

var _RadioGroup = _interopRequireDefault(require("./com/RadioGroup"));

var _CheckboxGroup = _interopRequireDefault(require("./com/CheckboxGroup"));

var _language = _interopRequireDefault(require("./language"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * 基于rc-form的封装
 *
 * @author: GlenZhao
 * @created: /2017/11/30
 */
var langCode = window.LangCode || 'en';
var RcForm = {
  create: _rcForm.createForm,
  // 创建表单的方法
  Regex: {
    isName: /^[\u4E00-\u9FA5A-Za-z0-9_-]{2,20}$/g,
    // 2~20字符，支持英文大小写、数字、中文以及下划线
    isPassword: /^(?=.*[0-9].*)(?=.*[A-Z].*)(?=.*[a-z].*).{6,20}$/,
    // 6-20字符，支持键盘符号的输入，且必须同时包含英文大、小写和数字
    isTel: /^(?:(?:0\d{2,3}[- ]?[1-9]\d{6,7})|(?:[48]00[- ]?[1-9]\d{6}))$/g,
    isMobile: /^1[3-9]\d{9}$/g,
    isEmail: /^[A-Za-z0-9\u4e00-\u9fa5]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$/g,
    isIdentifyCode: /^\d{6}$/
  },
  Errors: {
    isName: _language["default"][langCode]['IsName'],
    isPassword: _language["default"][langCode]['IsPassword'],
    isTel: _language["default"][langCode]['IsTel'],
    isMobile: _language["default"][langCode]['IsMobile'],
    isEmail: _language["default"][langCode]['IsEmail'],
    isIdentifyCode: _language["default"][langCode]['IsIdentifyCode']
  },
  Form: _Form["default"],
  // 表单
  FormGroup: _FormGroup["default"],
  // 表单控件组
  FormRow: _FormRow["default"],
  // 表单Row
  Input: (0, _FormItemWrap["default"])(_Input["default"]),
  // 表单Input组件
  InputGroup: (0, _FormItemWrap["default"])(_InputGroup["default"]),
  // 表单InputGroup组件
  Button: _Button["default"],
  // 表单Button组件
  Textarea: (0, _FormItemWrap["default"])(_Textarea["default"]),
  // 表单Textarea组件
  Select: (0, _FormItemWrap["default"])(_Select["default"]),
  // 表单Select组件
  Panel: (0, _FormItemWrap["default"])(_Panel["default"]),
  // 表单Panel容器组件
  RadioGroup: (0, _FormItemWrap["default"])(_RadioGroup["default"]),
  // 表单RadioGroup组件
  CheckboxGroup: (0, _FormItemWrap["default"])(_CheckboxGroup["default"]) // 表单CheckboxGroup组件

};
var _default = RcForm;
exports["default"] = _default;