"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var useSearch_1 = __importDefault(require("./useSearch"));

var Select_1 = __importDefault(require("../Select"));

var Input_1 = __importDefault(require("../Input"));

var Button_1 = __importDefault(require("../Button"));

var language_1 = __importDefault(require("./language"));

require("./search.less");

var Option = Select_1["default"].Option;
var InputGroup = Input_1["default"].InputGroup;
/**
 * Search 展示组件
 * @param props
 */

var Search = function Search(props) {
  var _a = useSearch_1["default"](props),
      currentLangCode = _a.currentLangCode,
      value = _a.value,
      handleSelect = _a.handleSelect,
      handleChange = _a.handleChange,
      handleKeyUp = _a.handleKeyUp,
      handleSearch = _a.handleSearch;

  var _b = props.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      _c = props.className,
      className = _c === void 0 ? '' : _c,
      _d = props.option,
      option = _d === void 0 ? [] : _d,
      _e = props.disabled,
      disabled = _e === void 0 ? false : _e,
      _f = props.selectWidth,
      selectWidth = _f === void 0 ? 120 : _f,
      _g = props.isAdvance,
      isAdvance = _g === void 0 ? false : _g,
      _h = props.collapsed,
      collapsed = _h === void 0 ? true : _h,
      _j = props.onCollapsed,
      onCollapsed = _j === void 0 ? undefined : _j,
      _k = props.placeholder,
      placeholder = _k === void 0 ? '' : _k,
      _l = props.buttonType,
      buttonType = _l === void 0 ? 'default' : _l,
      _m = props.btnName,
      btnName = _m === void 0 ? undefined : _m;

  var renderSelectOption = function renderSelectOption() {
    var defaultValue = option[0];
    return react_1["default"].createElement(Select_1["default"], {
      defaultValue: defaultValue,
      disabled: disabled,
      onChange: handleSelect,
      style: {
        minWidth: selectWidth,
        width: selectWidth
      },
      dropdownMatchSelectWidth: false,
      showSearch: false,
      getPopupContainer: function getPopupContainer(node) {
        return node.parentNode;
      }
    }, option.map(function (item) {
      return react_1["default"].createElement(Option, {
        key: item,
        value: item,
        text: item
      }, item);
    }));
  };

  var advName = language_1["default"][currentLangCode]['AdvanceSearch'];
  return react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-search", className)
  }, react_1["default"].createElement(InputGroup, null, option.length > 1 && !isAdvance ? renderSelectOption() : null, isAdvance && option.length === 1 ? react_1["default"].createElement(Button_1["default"], {
    className: prefixCls + "-search-advanced",
    type: "default",
    name: advName,
    icon: collapsed ? 'down' : 'up',
    iconRight: true,
    onClick: onCollapsed
  }) : null, react_1["default"].createElement(Input_1["default"], {
    placeholder: placeholder,
    value: value,
    disabled: disabled || false,
    onChange: handleChange,
    onKeyUp: handleKeyUp,
    onKeyDown: function onKeyDown(e) {
      e.keyCode === 13 && e.preventDefault();
    }
  }), react_1["default"].createElement(Button_1["default"], {
    icon: btnName ? undefined : 'search',
    type: buttonType,
    name: btnName,
    disabled: disabled || false,
    onClick: handleSearch
  })));
};

exports["default"] = Search;