"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = require("react");
/**
 * Search Hook
 * @param param0
 */


var useSearch = function useSearch(_a) {
  var _b = _a.langCode,
      langCode = _b === void 0 ? window.LangCode || 'en' : _b,
      _c = _a.defaultValue,
      defaultValue = _c === void 0 ? '' : _c,
      _d = _a.option,
      option = _d === void 0 ? [] : _d,
      _e = _a.onChange,
      onChange = _e === void 0 ? undefined : _e,
      _f = _a.onSearch,
      onSearch = _f === void 0 ? undefined : _f,
      _g = _a.onEmptySearch,
      onEmptySearch = _g === void 0 ? undefined : _g;

  var _h = react_1.useState(defaultValue),
      value = _h[0],
      setValue = _h[1];

  var _j = react_1.useState(option[0] || ''),
      key = _j[0],
      setKey = _j[1];

  var currentLangCode = langCode || window.LangCode || 'en';

  var handleSelect = function handleSelect(key) {
    setKey(key);

    if (onChange) {
      onChange(value, key);
    }
  };

  var handleChange = function handleChange(e) {
    var value = e.target.value;
    setValue(value);
    setTimeout(function () {
      if (onChange) {
        onChange(value, key);
      }
    }, 0);
  };

  var handleKeyUp = function handleKeyUp(e) {
    if (e.keyCode === 13) {
      handleSearch();
    }
  };

  var handleSearch = function handleSearch() {
    var searchKeywords = option.length > 0 ? {
      key: key,
      value: value
    } : value;

    if (searchKeywords && onSearch) {
      onSearch(searchKeywords);
    }

    if (!searchKeywords && onEmptySearch) {
      onEmptySearch(searchKeywords);
    }
  };

  return {
    currentLangCode: currentLangCode,
    value: value,
    key: key,
    handleSelect: handleSelect,
    handleChange: handleChange,
    handleKeyUp: handleKeyUp,
    handleSearch: handleSearch
  };
};

exports["default"] = useSearch;