"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __createBinding = void 0 && (void 0).__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = void 0 && (void 0).__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = void 0 && (void 0).__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
/*
 * @Author: SiMeiyu
 * @Date: 2017-07-04 10:06:36
 */

var react_1 = __importStar(require("react"));

var rc_select_1 = __importStar(require("rc-select"));

var Icon_1 = __importDefault(require("../Icon"));

var useSelect_1 = __importDefault(require("./useSelect"));

require("rc-select/assets/index.less");

require("./select.less");

var Select = react_1.forwardRef(function (props, ref) {
  var _a = useSelect_1["default"](),
      selectRef = _a.selectRef,
      focus = _a.focus,
      blur = _a.blur;

  var menuItemSelectedIcon = props.menuItemSelectedIcon,
      mode = props.mode,
      multiple = props.multiple,
      tags = props.tags,
      otherProps = __rest(props, ["menuItemSelectedIcon", "mode", "multiple", "tags"]);

  var tmpMenuItemSelectedIcon;
  var tmpMode = mode;

  if (multiple) {
    tmpMode = 'multiple';
  } else if (tags) {
    tmpMode = 'tags';
  }

  if (menuItemSelectedIcon !== undefined) {
    tmpMenuItemSelectedIcon = menuItemSelectedIcon;
  } else if (tmpMode === 'multiple' || tmpMode === 'tags') {
    tmpMenuItemSelectedIcon = react_1["default"].createElement(Icon_1["default"], {
      type: "correct"
    });
  } else {
    tmpMenuItemSelectedIcon = '';
  }

  react_1.useImperativeHandle(ref, function () {
    return {
      focus: focus,
      blur: blur
    };
  });
  return react_1["default"].createElement(rc_select_1["default"], __assign({
    ref: selectRef
  }, otherProps, {
    mode: tmpMode,
    animation: "slide-up",
    menuItemSelectedIcon: tmpMenuItemSelectedIcon
  }));
});
Select.Option = rc_select_1.Option;
Select.OptGroup = rc_select_1.OptGroup;
exports["default"] = Select;