"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var useSelect = function useSelect() {
  var selectRef = react_1["default"].useRef(null);

  function focus() {
    if (selectRef.current) {
      selectRef.current.focus();
    }
  }

  function blur() {
    if (selectRef.current) {
      selectRef.current.blur();
    }
  }

  return {
    selectRef: selectRef,
    focus: focus,
    blur: blur
  };
};

exports["default"] = useSelect;