"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _rcSlider = _interopRequireDefault(require("rc-slider"));

var _Input = _interopRequireDefault(require("../Input"));

require("rc-slider/assets/index.css");

require("./slider.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

// const Range = RcSlider.Range
var Slider = /*#__PURE__*/function (_React$Component) {
  _inherits(Slider, _React$Component);

  var _super = _createSuper(Slider);

  function Slider(props) {
    var _this;

    _classCallCheck(this, Slider);

    _this = _super.call(this, props);
    _this.state = {
      inputValue: _this.props.value,
      sliderValue: _this.props.value
    };
    return _this;
  }

  _createClass(Slider, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(_ref) {
      var value = _ref.value;

      if (value !== this.props.value) {
        this.setState({
          inputValue: value,
          sliderValue: value
        });
      }
    }
    /**
     * 滑动条滑动事件
     */

  }, {
    key: "handleChange",
    value: function handleChange(value) {
      this.setState({
        inputValue: value,
        sliderValue: value
      });

      if (this.props.onChange) {
        this.props.onChange(value);
      }
    }
    /**
     * 文本框事件
     */

  }, {
    key: "handleInputChange",
    value: function handleInputChange(e) {
      var value = e.target.value.trim();

      if (isNaN(value)) {
        value = '';
      }

      this.setState({
        inputValue: value
      });
    }
    /**
     * 文本框失去焦点，判断只能为数字，控制滑动条滑动
     */

  }, {
    key: "handleInputBlur",
    value: function handleInputBlur(e) {
      // console.log(e)
      var inputValue = this.state.inputValue;
      var _this$props = this.props,
          max = _this$props.max,
          min = _this$props.min,
          step = _this$props.step,
          marks = _this$props.marks,
          stickToMarks = _this$props.stickToMarks;
      var marksKey = marks ? Object.keys(marks) : [];

      if (!isNaN(inputValue) && inputValue !== '') {
        inputValue = parseInt(inputValue);

        if (inputValue < min) {
          inputValue = min;
        } else if (inputValue > max) {
          inputValue = max;
        } else if (stickToMarks) {
          if (marksKey.findIndex(function (n) {
            return Number(n) === inputValue;
          }) === -1) {
            if (step) {
              var over = inputValue % step;
              inputValue = inputValue - over;
            } else {
              var _index = marksKey.findIndex(function (n) {
                return Number(n) > inputValue;
              });

              if (_index > -1) {
                inputValue = Number(marksKey[_index - 1]);
              }
            }
          }
        } else if (!stickToMarks && !step) {
          if (marksKey.findIndex(function (n) {
            return Number(n) === inputValue;
          }) === -1) {
            var _index2 = marksKey.findIndex(function (n) {
              return Number(n) > inputValue;
            });

            if (_index2 > 0) {
              var _max = Number(marksKey[_index2]);

              var _min = Number(marksKey[_index2 - 1]);

              if (_max - inputValue < inputValue - _min) {
                inputValue = _max;
              } else {
                inputValue = _min;
              }
            }
          }
        }

        this.handleChange(isNaN(inputValue) ? 0 : inputValue);
      }

      if (inputValue === '') {
        inputValue = min;
        this.handleChange(isNaN(inputValue) ? 0 : inputValue);
      }
    }
    /**
     * 文本框回车事件
     */

  }, {
    key: "handleKeyUp",
    value: function handleKeyUp(e) {
      if (e.keyCode === 13) {
        this.handleInputBlur(e);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var me = this;

      var _this$props2 = this.props,
          onChange = _this$props2.onChange,
          unit = _this$props2.unit,
          prefixCls = _this$props2.prefixCls,
          disabled = _this$props2.disabled,
          value = _this$props2.value,
          textLength = _this$props2.textLength,
          props = _objectWithoutProperties(_this$props2, ["onChange", "unit", "prefixCls", "disabled", "value", "textLength"]);

      var _this$state = this.state,
          sliderValue = _this$state.sliderValue,
          inputValue = _this$state.inputValue;
      var inputS = !!disabled;
      var newStyle = textLength ? {
        width: 'calc(100% - ' + "".concat(textLength + 16) + 'px)'
      } : {
        width: 'calc(~"100% - 68px")'
      };
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("".concat(prefixCls, "-contain"))
      }, /*#__PURE__*/_react["default"].createElement(_rcSlider["default"], _extends({
        onChange: me.handleChange.bind(me),
        style: newStyle,
        prefixCls: prefixCls,
        disabled: disabled,
        value: sliderValue
      }, props)), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("".concat(prefixCls, "-input")),
        style: {
          width: "".concat(textLength) + 'px'
        }
      }, /*#__PURE__*/_react["default"].createElement(_Input["default"], {
        className: (0, _classnames["default"])("".concat(prefixCls, "-in-input")),
        onChange: me.handleInputChange.bind(me),
        value: inputValue,
        disabled: inputS,
        type: "text",
        onBlur: me.handleInputBlur.bind(me),
        onKeyUp: me.handleKeyUp.bind(me)
      }), /*#__PURE__*/_react["default"].createElement("span", {
        className: (0, _classnames["default"])("".concat(prefixCls, "-unit"))
      }, unit)));
    }
  }]);

  return Slider;
}(_react["default"].Component); // class CustomizedRange extends React.Component {
//     constructor(props) {
//         super(props)
//         this.state = {
//             lowerBound: 20,
//             upperBound: 40,
//             value: [20, 40]
//         }
//     }
//     onLowerBoundChange = (e) => {
//         this.setState({
//             lowerBound: +e.target.value
//         })
//     }
//     onUpperBoundChange = (e) => {
//         this.setState({
//             upperBound: +e.target.value
//         })
//     }
//     onSliderChange = (value) => {
//         log(value)
//         this.setState({
//             value
//         })
//     }
//     handleApply = () => {
//         const {
//             lowerBound, upperBound
//         } = this.state
//         this.setState({
//             value: [lowerBound, upperBound]
//         })
//     }
//     render() {
//         return (
//             <div>
//                 <label>LowerBound: </label>
//                 <input type="number" value={this.state.lowerBound} onChange={this.onLowerBoundChange} />
//                 <br />
//                 <label>UpperBound: </label>
//                 <input type="number" value={this.state.upperBound} onChange={this.onUpperBoundChange} />
//                 <br />
//                 <button onClick={this.handleApply}>Apply</button>
//                 <br /><br />
//                 <Range allowCross={false} value={this.state.value} onChange={this.onSliderChange} />
//             </div>
//         )
//     }
// }


Slider.propTypes = {
  value: _propTypes["default"].number,
  onChange: _propTypes["default"].func,
  max: _propTypes["default"].number,
  min: _propTypes["default"].number,
  step: _propTypes["default"].number,
  id: _propTypes["default"].string,
  prefixCls: _propTypes["default"].string,
  unit: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  textLength: _propTypes["default"].number,
  marks: _propTypes["default"].object,
  stickToMarks: _propTypes["default"].bool
};
Slider.defaultProps = {
  prefixCls: 'ult-slider',
  stickToMarks: false
};
var _default = Slider;
exports["default"] = _default;