"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _sliderBg = _interopRequireDefault(require("./sliderBg"));

var _slidermarks = _interopRequireDefault(require("./slidermarks"));

var utils = _interopRequireWildcard(require("./until"));

require("./slider.less");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var SliderCon = /*#__PURE__*/function (_React$Component) {
  _inherits(SliderCon, _React$Component);

  var _super = _createSuper(SliderCon);

  function SliderCon(props) {
    var _this;

    _classCallCheck(this, SliderCon);

    _this = _super.call(this, props);

    _this.onMouseDown = function (e) {
      var me = _assertThisInitialized(_this);

      if (e.button !== 0) {
        return;
      }

      var isVertical = _this.props.vertical;
      var position = utils.getMousePosition(isVertical, e);

      if (!utils.isEventFromHandle(e, _this.handlesRefs)) {
        _this.dragOffset = 0;
      } else {
        var handlePosition = utils.getHandleCenterPosition(isVertical, e.target);
        _this.dragOffset = position - handlePosition;
        position = handlePosition;
      }

      _this.onStart.bind(me, position);

      _this.onMouseMove.bind(me);

      utils.pauseEvent(e);
    };

    _this.onTouchStart = function (e) {
      // if (utils.isNotTouchEvent(e)) return;
      var isVertical = _this.props.vertical;
      var position = utils.getTouchPosition(isVertical, e);

      if (!utils.isEventFromHandle(e, _this.handlesRefs)) {
        _this.dragOffset = 0;
      } else {
        var handlePosition = utils.getHandleCenterPosition(isVertical, e.target);
        _this.dragOffset = position - handlePosition;
        position = handlePosition;
      }

      _this.onStart(position);

      _this.addDocumentTouchEvents();

      utils.pauseEvent(e);
    };

    _this.onMouseMove = function (e) {
      if (!_this.sliderRef) {
        _this.onEnd();

        return;
      }

      var position = utils.getMousePosition(_this.props.vertical, e);

      _this.onMove(e, position - _this.dragOffset);
    };

    _this.onTouchMove = function (e) {
      if (utils.isNotTouchEvent(e) || !_this.sliderRef) {
        _this.onEnd();

        return;
      }

      var position = utils.getTouchPosition(_this.props.vertical, e);

      _this.onMove(e, position - _this.dragOffset);
    };

    _this.saveSlider = function (slider) {
      _this.sliderRef = slider;
    };

    _this.handlesRefs = {};
    return _this;
  }

  _createClass(SliderCon, [{
    key: "addDocumentTouchEvents",
    value: function addDocumentTouchEvents() {
      // just work for Chrome iOS Safari and Android Browser
      this.onTouchMoveListener = addEventListener(document, 'touchmove', this.onTouchMove);
      this.onTouchUpListener = addEventListener(document, 'touchend', this.onEnd);
    }
  }, {
    key: "addDocumentMouseEvents",
    value: function addDocumentMouseEvents() {
      this.onMouseMoveListener = addEventListener(document, 'mousemove', this.onMouseMove);
      this.onMouseUpListener = addEventListener(document, 'mouseup', this.onEnd);
    }
  }, {
    key: "removeDocumentEvents",
    value: function removeDocumentEvents() {
      /* eslint-disable no-unused-expressions */
      this.onTouchMoveListener && this.onTouchMoveListener.remove();
      this.onTouchUpListener && this.onTouchUpListener.remove();
      this.onMouseMoveListener && this.onMouseMoveListener.remove();
      this.onMouseUpListener && this.onMouseUpListener.remove();
      /* eslint-enable no-unused-expressions */
    }
  }, {
    key: "getSliderStart",
    value: function getSliderStart() {
      var slider = this.sliderRef;
      var rect = slider.getBoundingClientRect();
      return this.props.vertical ? rect.top : rect.left;
    }
  }, {
    key: "getSliderLength",
    value: function getSliderLength() {
      var slider = this.sliderRef;

      if (!slider) {
        return 0;
      }

      return this.props.vertical ? slider.clientHeight : slider.clientWidth;
    }
  }, {
    key: "calcValue",
    value: function calcValue(offset) {
      var _this$props = this.props,
          vertical = _this$props.vertical,
          min = _this$props.min,
          max = _this$props.max;
      var ratio = Math.abs(Math.max(offset, 0) / this.getSliderLength());
      var value = vertical ? (1 - ratio) * (max - min) + min : ratio * (max - min) + min;
      return value;
    }
  }, {
    key: "calcValueByPos",
    value: function calcValueByPos(position) {
      var pixelOffset = position - this.getSliderStart();
      var nextValue = this.trimAlignValue(this.calcValue(pixelOffset));
      return nextValue;
    }
  }, {
    key: "calcOffset",
    value: function calcOffset(value) {
      var _this$props2 = this.props,
          min = _this$props2.min,
          max = _this$props2.max;
      var ratio = (value - min) / (max - min);
      return ratio * 100;
    }
  }, {
    key: "saveHandle",
    value: function saveHandle(index, handle) {
      this.handlesRefs[index] = handle;
    }
  }, {
    key: "trimAlignValue",
    value: function trimAlignValue(v) {
      var nextProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var mergedProps = _objectSpread(_objectSpread({}, this.props), nextProps);

      var val = utils.ensureValueInRange(v, mergedProps);
      return utils.ensureValuePrecision(val, mergedProps);
    }
  }, {
    key: "render",
    value: function render() {
      var me = this;
      var _this$props3 = this.props,
          vertical = _this$props3.vertical,
          maximumTrackStyle = _this$props3.maximumTrackStyle,
          min = _this$props3.min,
          max = _this$props3.max,
          step = _this$props3.step,
          marks = _this$props3.marks,
          included = _this$props3.included,
          children = _this$props3.children,
          prefixCls = _this$props3.prefixCls,
          railStyle = _this$props3.railStyle;

      var _get$call = _get(_getPrototypeOf(SliderCon.prototype), "render", this).call(this),
          tracks = _get$call.tracks,
          handles = _get$call.handles;

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames2["default"])("".concat(prefixCls, "-container"), _defineProperty({}, "".concat(prefixCls, "-vertical"), vertical)),
        onTouchStart: me.onTouchStart.bind(me),
        onMouseDown: me.onMouseDown.bind(me)
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-rail"),
        style: _objectSpread(_objectSpread({}, maximumTrackStyle), railStyle)
      }), tracks, /*#__PURE__*/_react["default"].createElement(_sliderBg["default"], {
        prefixCls: prefixCls,
        vertical: vertical,
        marks: marks,
        step: step,
        included: included,
        lowerBound: this.getLowerBound(),
        upperBound: this.getUpperBound(),
        max: max,
        min: min
      }), handles, /*#__PURE__*/_react["default"].createElement(_slidermarks["default"], {
        className: "".concat(prefixCls, "-mark"),
        vertical: vertical,
        marks: marks,
        included: included,
        lowerBound: this.getLowerBound(),
        upperBound: this.getUpperBound(),
        max: max,
        min: min
      }), children);
    }
  }]);

  return SliderCon;
}(_react["default"].Component);

SliderCon.propTypes = {
  prefixCls: _propTypes["default"].string,
  vertical: _propTypes["default"].bool,
  railStyle: _propTypes["default"].object,
  min: _propTypes["default"].number,
  max: _propTypes["default"].number,
  step: _propTypes["default"].number,
  marks: _propTypes["default"].object,
  included: _propTypes["default"].bool,
  maximumTrackStyle: _propTypes["default"].object,
  children: _propTypes["default"].any
};
SliderCon.defaultProps = {
  prefixCls: 'ult-slider',
  min: 0,
  max: 100,
  step: 1,
  marks: {},
  // handle: ({index, ...restProps}) => {
  //     delete restProps.dragging
  //     return <Handle {...restProps} key={index} />
  // },
  //   onBeforeChange: noop,
  //   onChange: noop,
  //   onAfterChange: noop,
  included: true,
  vertical: false,
  railStyle: {},
  maximumTrackStyle: null,
  children: undefined
};
var _default = SliderCon;
exports["default"] = _default;