"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames2 = _interopRequireDefault(require("classnames"));

require("./slider.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SliderMark = function SliderMark(props) {
  var className = props.className,
      vertical = props.vertical,
      marks = props.marks,
      included = props.included,
      upperBound = props.upperBound,
      lowerBound = props.lowerBound,
      max = props.max,
      min = props.min;
  var marksKeys = Object.keys(marks);
  var marksCount = marksKeys.length;
  var unit = 100 / (marksCount - 1);
  var markWidth = unit * 0.9;
  var range = max - min;
  var elements = marksKeys.map(parseFloat).sort(function (a, b) {
    return a - b;
  }).map(function (point) {
    var _classnames;

    var isActive = !included && point === upperBound || included && point <= upperBound && point >= lowerBound;
    var markClassName = (0, _classnames2["default"])((_classnames = {}, _defineProperty(_classnames, "".concat(className, "-text"), true), _defineProperty(_classnames, "".concat(className, "-text-active"), isActive), _classnames));
    var bottomStyle = {
      marginBottom: '-50%',
      bottom: "".concat((point - min) / range * 100, "%")
    };
    var leftStyle = {
      width: "".concat(markWidth, "%"),
      marginLeft: "".concat(-markWidth / 2, "%"),
      left: "".concat((point - min) / range * 100, "%")
    };
    var style = vertical ? bottomStyle : leftStyle;
    var markPoint = marks[point];
    var markPointIsObject = _typeof(markPoint) === 'object' && !_react["default"].isValidElement(markPoint);
    var markLabel = markPointIsObject ? markPoint.label : markPoint;
    var markStyle = markPointIsObject ? _objectSpread(_objectSpread({}, style), markPoint.style) : style;
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: markClassName,
      style: markStyle,
      key: point
    }, markLabel);
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: className
  }, elements);
};

SliderMark.propTypes = {
  className: _propTypes["default"].string,
  included: _propTypes["default"].bool,
  vertical: _propTypes["default"].bool,
  marks: _propTypes["default"].object.isRequired,
  upperBound: _propTypes["default"].any.isRequired,
  lowerBound: _propTypes["default"].any.isRequired,
  max: _propTypes["default"].number.isRequired,
  min: _propTypes["default"].number.isRequired
};
SliderMark.defaultProps = {
  className: '',
  included: true,
  vertical: true
};
var _default = SliderMark;
exports["default"] = _default;