"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

require("./step.less");

var StepBody = function StepBody(_a) {
  var _b = _a.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      _c = _a.style,
      style = _c === void 0 ? {} : _c,
      panels = _a.panels,
      activeIndex = _a.activeIndex;

  function getStepPanes() {
    return react_1["default"].Children.map(panels, function (child) {
      if (!child) {
        return;
      }

      var order = parseInt(child.props.order, 10);
      var isActive = activeIndex === order;
      return react_1["default"].cloneElement(child, {
        prefixCls: prefixCls,
        isActive: isActive,
        children: child.props.children,
        key: "stepPane-" + order
      });
    });
  }

  var classes = classnames_1["default"](prefixCls + "-step-body");
  return react_1["default"].createElement("div", {
    className: classes,
    style: style
  }, getStepPanes());
};

exports["default"] = StepBody;