"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

require("./step.less");

var StepHead = function StepHead(_a) {
  var _b;

  var prefixCls = _a.prefixCls,
      panels = _a.panels,
      activeIndex = _a.activeIndex,
      showProgress = _a.showProgress,
      tabMode = _a.tabMode,
      onActive = _a.onActive;

  function getNavs() {
    return react_1["default"].Children.map(panels, function (child) {
      var _a;

      if (!child) {
        return;
      }

      var order = parseInt(child.props.order, 10);
      var classes = classnames_1["default"]((_a = {}, _a[prefixCls + "-step-nav-item"] = true, _a[prefixCls + "-step-nav-item-active"] = activeIndex === order, _a[prefixCls + "-step-nav-item-disabled"] = child.props.disabled, _a[prefixCls + "-step-nav-item-tabMode"] = tabMode, _a));
      return react_1["default"].createElement("li", {
        className: classes,
        key: order,
        onClick: function onClick() {
          onActive(order);
        }
      }, child.props.icon ? react_1["default"].createElement("i", {
        className: "iconfont icon-" + child.props.icon
      }) : null, react_1["default"].createElement("div", {
        className: prefixCls + "-step-nav-item-title"
      }, child.props.title));
    });
  }

  function renderProgress() {
    var total = react_1["default"].Children.count(panels);
    var barW = parseFloat((100 / total).toString());
    var barLeft = activeIndex * barW;

    if (!showProgress) {
      return null;
    }

    return react_1["default"].createElement("div", {
      className: prefixCls + "-step-progress"
    }, react_1["default"].createElement("div", {
      className: prefixCls + "-step-progress-bar",
      style: {
        width: barW + "%",
        left: barLeft + "%"
      }
    }));
  }

  return react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-step-head", (_b = {}, _b[prefixCls + "-step-head-progress"] = showProgress, _b))
  }, react_1["default"].createElement("ul", {
    className: prefixCls + "-step-nav"
  }, getNavs()), renderProgress());
};

exports["default"] = StepHead;