"use strict";

var __createBinding = void 0 && (void 0).__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = void 0 && (void 0).__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = void 0 && (void 0).__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));
/**
 * Step Hook
 * @param param0
 */


var useStep = function useStep(_a) {
  var _b = _a.startIndex,
      startIndex = _b === void 0 ? 0 : _b,
      _c = _a.activeIndex,
      activeIndex = _c === void 0 ? 0 : _c,
      children = _a.children,
      _d = _a.tabMode,
      tabMode = _d === void 0 ? false : _d,
      _e = _a.onActive,
      onActive = _e === void 0 ? undefined : _e,
      _f = _a.onFinished,
      onFinished = _f === void 0 ? undefined : _f,
      _g = _a.onPrevStep,
      onPrevStep = _g === void 0 ? undefined : _g,
      _h = _a.onNextStep,
      onNextStep = _h === void 0 ? undefined : _h;

  var _j = react_1.useState(startIndex),
      currentActiveIndex = _j[0],
      setCurrentActiveIndex = _j[1];

  var _k = react_1.useState(react_1["default"].Children.count(children)),
      total = _k[0],
      setTotal = _k[1];

  function handleFinish() {
    if (onFinished) {
      onFinished();
    }
  }

  function handlePrevStep() {
    if (currentActiveIndex > 0) {
      setCurrentActiveIndex(function (index) {
        return index - 1;
      });
    }

    if (onPrevStep) {
      onPrevStep();
    }
  }

  function handleNextStep() {
    if (currentActiveIndex < total - 1) {
      setCurrentActiveIndex(function (index) {
        return index + 1;
      });
    }

    if (onNextStep) {
      onNextStep();
    }
  }

  function handleOnActive(order) {
    if (tabMode) {
      setCurrentActiveIndex(order);
    }

    if (onActive) {
      onActive(order);
    }
  }

  react_1.useEffect(function () {
    setCurrentActiveIndex(activeIndex);
  }, [activeIndex]);
  react_1.useEffect(function () {
    setTotal(react_1["default"].Children.count(children));
  }, [children]);
  return {
    currentActiveIndex: currentActiveIndex,
    total: total,
    handleFinish: handleFinish,
    handlePrevStep: handlePrevStep,
    handleNextStep: handleNextStep,
    handleOnActive: handleOnActive
  };
};

exports["default"] = useStep;