"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var useSwitch_1 = __importDefault(require("./useSwitch"));

require("./switch.less");

var Switch = function Switch(props) {
  var _a;

  var _b = useSwitch_1["default"](props),
      currentChecked = _b.currentChecked,
      toggle = _b.toggle;

  var _c = props.prefixCls,
      prefixCls = _c === void 0 ? 'ult' : _c,
      _d = props.style,
      style = _d === void 0 ? {} : _d,
      _e = props.size,
      size = _e === void 0 ? '' : _e,
      _f = props.square,
      square = _f === void 0 ? false : _f,
      _g = props.disabled,
      disabled = _g === void 0 ? false : _g,
      _h = props.className,
      className = _h === void 0 ? '' : _h,
      _j = props.checkedTitle,
      checkedTitle = _j === void 0 ? '' : _j,
      _k = props.unCheckedTitle,
      unCheckedTitle = _k === void 0 ? '' : _k;
  var classes = classnames_1["default"]((_a = {}, _a[prefixCls + "-switch"] = true, _a[prefixCls + "-switch-" + size] = !!size, _a[prefixCls + "-switch-square"] = !!square, _a[prefixCls + "-switch-checked"] = currentChecked, _a[prefixCls + "-switch-disabled"] = disabled, _a), className);
  return react_1["default"].createElement("span", {
    className: classes,
    style: style,
    onClick: toggle
  }, react_1["default"].createElement("span", {
    className: prefixCls + "-switch-inner"
  }, currentChecked ? checkedTitle : unCheckedTitle));
};

exports["default"] = Switch;