"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = require("react");

var useSwitch = function useSwitch(props) {
  var _a = props.defaultChecked,
      defaultChecked = _a === void 0 ? false : _a,
      _b = props.disabled,
      disabled = _b === void 0 ? false : _b,
      _c = props.onChange,
      onChange = _c === void 0 ? undefined : _c,
      _d = props.onClick,
      onClick = _d === void 0 ? undefined : _d;

  var _e = react_1.useState('checked' in props ? !!props.checked : !!defaultChecked),
      currentChecked = _e[0],
      setCurrentChecked = _e[1];

  function setChecked(value) {
    if (!('checked' in props)) {
      setCurrentChecked(value);
    }

    if (onChange) {
      onChange(value);
    }
  }

  function toggle() {
    var tmpChecked = !currentChecked;

    if (!disabled) {
      setChecked(tmpChecked);
    }

    if (onClick) {
      onClick(tmpChecked);
    }
  }

  react_1.useEffect(function () {
    if ('checked' in props) {
      setCurrentChecked(!!props.checked);
    }
  }, [props.checked]);
  return {
    currentChecked: currentChecked,
    toggle: toggle
  };
};

exports["default"] = useSwitch;