import React from 'react';
import { TabPanelProps } from './Panel';
import './tab.less';
export interface TabProps {
    active?: string;
    defaultKey?: string;
    children: React.ReactNode;
    prefixCls?: string;
    direction?: 'default' | 'right' | 'vertical' | 'inner' | 'inner2' | undefined;
    shadow?: boolean;
    padNone?: boolean;
    handleSwitchTab?: (key: string) => void;
    onBeforeSwitchTab?: (key: string) => boolean;
    tabTitle?: React.ReactNode;
    itemWidth?: number;
}
export interface TabForwardRef extends React.ForwardRefExoticComponent<TabProps & React.RefAttributes<any>> {
    TabPanel: React.FC<TabPanelProps>;
}
/**
 * Tab 组件展示
 * @param props
 */
declare const Tab: TabForwardRef;
export default Tab;
