"use strict";

var __createBinding = void 0 && (void 0).__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = void 0 && (void 0).__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = void 0 && (void 0).__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var useTab_1 = __importStar(require("./useTab"));

var Panel_1 = __importDefault(require("./Panel"));

require("./tab.less");
/**
 * Tab 组件展示
 * @param props
 */


var Tab = react_1.forwardRef(function (props, ref) {
  var _a;

  var _b = useTab_1["default"](props),
      currentPage = _b.currentPage,
      pageSize = _b.pageSize,
      totalPages = _b.totalPages,
      activeKey = _b.activeKey,
      tabPanelRef = _b.tabPanelRef,
      tabBarStyle = _b.tabBarStyle,
      getActivePanel = _b.getActivePanel,
      switchPanel = _b.switchPanel,
      handleRight = _b.handleRight,
      handleLeft = _b.handleLeft,
      goToPanel = _b.goToPanel;

  var _c = props.prefixCls,
      prefixCls = _c === void 0 ? 'ult' : _c,
      _d = props.padNone,
      padNone = _d === void 0 ? false : _d,
      _e = props.children,
      children = _e === void 0 ? null : _e,
      _f = props.itemWidth,
      itemWidth = _f === void 0 ? useTab_1.DEFALUT_ITEM_WIDTH : _f,
      _g = props.tabTitle,
      tabTitle = _g === void 0 ? '' : _g,
      _h = props.direction,
      direction = _h === void 0 ? 'default' : _h,
      _j = props.shadow,
      shadow = _j === void 0 ? false : _j;

  function renderActivePanel() {
    return react_1["default"].createElement("div", {
      className: classnames_1["default"](prefixCls + "-tabs-panel", {
        'pad-md': !padNone
      })
    }, getActivePanel());
  }

  function renderHeaderTabTitle() {
    if (children instanceof Array) {
      return react_1["default"].Children.map(children, function (_a) {
        var key = _a.key,
            props = _a.props;
        var title = props.title,
            isValid = props.isValid;

        if (isValid === false) {
          return null;
        }

        var tooltiptitle = typeof title === 'string' || typeof title === 'number' ? title : '';
        return react_1["default"].createElement("span", {
          key: key,
          className: classnames_1["default"]('title', {
            active: key === activeKey
          }),
          style: {
            width: itemWidth
          },
          onClick: function onClick() {
            switchPanel(key);
          },
          title: "" + tooltiptitle
        }, react_1["default"].createElement("div", {
          className: "head"
        }, title));
      });
    } else {
      return react_1["default"].createElement("span", {
        className: classnames_1["default"]('title', {
          active: children.key
        })
      }, children.props.title);
    }
  }

  function renderHeaderTabs() {
    var _a, _b;

    var styleLeft = tabTitle ? 'auto' : -pageSize * itemWidth * (currentPage - 1);
    var styleDirect = direction === 'right' ? 'right' : 'left';
    var headerStyle = direction === 'vertical' ? undefined : (_a = {}, _a[styleDirect] = styleLeft + "px", _a);
    var hasScrollBar = direction === 'vertical' || direction === 'inner' || direction === 'inner2';
    return react_1["default"].createElement("div", {
      className: classnames_1["default"](prefixCls + "-tabs-title", (_b = {}, _b[prefixCls + "-tab-after"] = currentPage !== totalPages, _b[prefixCls + "-tab-before"] = currentPage !== 1, _b))
    }, tabTitle ? react_1["default"].createElement("h2", {
      className: classnames_1["default"](prefixCls + "-tabs-h2")
    }, tabTitle) : null, react_1["default"].createElement("div", {
      className: prefixCls + "-tabs-btn",
      style: headerStyle
    }, renderHeaderTabTitle(), hasScrollBar && react_1["default"].createElement("div", {
      className: prefixCls + "-tabs-bar",
      style: tabBarStyle
    })));
  }

  function renderHeader() {
    var hasMultipleTabs = react_1["default"].Children.count(children) > 1;
    var isVertical = direction === 'vertical';
    var isHideBtnMore = totalPages <= 1 || !hasMultipleTabs;
    return react_1["default"].createElement("div", {
      className: classnames_1["default"](prefixCls + "-tabs-content " + direction, {
        'btn-more-hidden': isHideBtnMore
      })
    }, renderHeaderTabs(), !isVertical && react_1["default"].createElement("button", {
      className: classnames_1["default"]('btn-more', {
        'tab-hidden': isHideBtnMore,
        'tab-disable': currentPage !== 1 && currentPage === totalPages
      }),
      onClick: handleRight
    }, react_1["default"].createElement("i", {
      className: "iconfont icon-right"
    })), !isVertical && react_1["default"].createElement("button", {
      className: classnames_1["default"]('btn-more', {
        'tab-hidden': isHideBtnMore,
        'tab-disable': currentPage === 1 && currentPage !== totalPages
      }),
      onClick: handleLeft
    }, react_1["default"].createElement("i", {
      className: "iconfont icon-left"
    })));
  }
  /**
   * @description 向外暴露的方法(可方便父组件调用子组件方法)
   */


  react_1.useImperativeHandle(ref, function () {
    return {
      goToPanel: goToPanel
    };
  });
  return react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-tabs", (_a = {}, _a[prefixCls + "-tabs-shadow"] = shadow, _a['vertical'] = direction === 'vertical', _a)),
    ref: tabPanelRef
  }, renderHeader(), renderActivePanel());
});
Tab.TabPanel = Panel_1["default"];
exports["default"] = Tab;