"use strict";

var __createBinding = void 0 && (void 0).__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = void 0 && (void 0).__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = void 0 && (void 0).__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SWITCH_BUTTON_WIDTH = exports.DEFALUT_ITEM_WIDTH = exports.MAX_SHOWN_TAB_NUM = void 0;

var react_1 = __importStar(require("react"));

var react_dom_1 = __importDefault(require("react-dom"));

exports.MAX_SHOWN_TAB_NUM = 6;
exports.DEFALUT_ITEM_WIDTH = 120;
exports.SWITCH_BUTTON_WIDTH = 25;
/**
 * Tab Hook
 * @param param0
 */

var useTab = function useTab(_a) {
  var _b = _a.active,
      active = _b === void 0 ? '' : _b,
      _c = _a.defaultKey,
      defaultKey = _c === void 0 ? '' : _c,
      _d = _a.children,
      children = _d === void 0 ? null : _d,
      _e = _a.itemWidth,
      itemWidth = _e === void 0 ? exports.DEFALUT_ITEM_WIDTH : _e,
      _f = _a.direction,
      direction = _f === void 0 ? 'default' : _f,
      _g = _a.handleSwitchTab,
      handleSwitchTab = _g === void 0 ? undefined : _g,
      _h = _a.onBeforeSwitchTab,
      onBeforeSwitchTab = _h === void 0 ? undefined : _h;

  var _j = react_1.useState(active || defaultKey),
      activeKey = _j[0],
      setActiveKey = _j[1];

  var _k = react_1.useState(true),
      btnLeft = _k[0],
      setBtnLeft = _k[1];

  var _l = react_1.useState(1),
      currentPage = _l[0],
      setCurrentPage = _l[1];

  var _m = react_1.useState(1),
      pageSize = _m[0],
      setPageSize = _m[1];

  var _o = react_1.useState(react_1["default"].Children.count(children)),
      childrenNum = _o[0],
      setChildrenNum = _o[1];

  var _p = react_1.useState(react_1["default"].Children.count(children) > 1),
      hasMultipleTabs = _p[0],
      setHasMultipleTabs = _p[1];

  var _q = react_1.useState(0),
      totalPages = _q[0],
      setTotalPages = _q[1];

  var _r = react_1.useState({}),
      tabBarStyle = _r[0],
      setTabBarStyle = _r[1];

  var tabPanelRef = react_1.useRef();

  function computePageSize() {
    var panelWidth = react_dom_1["default"].findDOMNode(tabPanelRef.current).offsetWidth - exports.SWITCH_BUTTON_WIDTH * 2; // eslint-disable-line

    var pageSize = Math.floor(panelWidth / itemWidth);
    var totalPages = Math.ceil(parseFloat(react_1["default"].Children.count(children).toString()) / parseFloat(pageSize.toString()));
    setPageSize(pageSize);
    setTotalPages(totalPages);
  }

  function reset() {
    setActiveKey(active || defaultKey);
    setBtnLeft(true);
    setCurrentPage(1);
    setPageSize(1);
    setChildrenNum(react_1["default"].Children.count(children));
    setHasMultipleTabs(react_1["default"].Children.count(children) > 1);
  }

  function handleRight() {
    setCurrentPage(Math.min(currentPage + 1, totalPages));
  }

  function handleLeft() {
    setCurrentPage(Math.max(currentPage - 1, 1));
  }

  function getActivePanel() {
    return react_1["default"].Children.count(children) > 1 ? children.find(function (_a) {
      var key = _a.key;
      return "" + key === "" + activeKey;
    }) : children;
  }

  function goToPanel(key) {
    setActiveKey(key || '');

    if (handleSwitchTab) {
      handleSwitchTab(key);
    }
  }

  function handleBeforeSwitchTab(key) {
    if (onBeforeSwitchTab) {
      return onBeforeSwitchTab(key);
    }

    return true;
  }

  function switchPanel(key) {
    if (key === activeKey) {
      return;
    }

    if (handleBeforeSwitchTab(key)) {
      goToPanel(key);
    }
  }

  function computeBarPosit(key) {
    if (key === void 0) {
      key = '';
    }

    var tabKeys = react_1["default"].Children.map(children, function (props) {
      return props.key;
    }) || [];
    var itemIndex = tabKeys.findIndex(function (current) {
      return current === key;
    });

    if (itemIndex < 0) {
      return null;
    }

    var isVertical = direction === 'vertical';

    if (!isVertical) {
      return {
        width: itemWidth + "px",
        left: itemIndex * itemWidth + "px"
      };
    } else {
      return {
        height: '40px',
        top: itemIndex * 40 + "px"
      };
    }
  }

  react_1.useEffect(function () {
    computePageSize();
  }, []);
  react_1.useEffect(function () {
    setActiveKey(active || defaultKey);
  }, [active, defaultKey]);
  react_1.useEffect(function () {
    computePageSize();
  }, [children]);
  react_1.useEffect(function () {
    setTabBarStyle(computeBarPosit(activeKey));
  }, [activeKey]);
  return {
    tabPanelRef: tabPanelRef,
    currentPage: currentPage,
    totalPages: totalPages,
    activeKey: activeKey,
    btnLeft: btnLeft,
    pageSize: pageSize,
    childrenNum: childrenNum,
    hasMultipleTabs: hasMultipleTabs,
    tabBarStyle: tabBarStyle,
    reset: reset,
    handleRight: handleRight,
    handleLeft: handleLeft,
    getActivePanel: getActivePanel,
    switchPanel: switchPanel,
    goToPanel: goToPanel
  };
};

exports["default"] = useTab;