"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var rc_table_1 = __importDefault(require("rc-table"));

var classnames_1 = __importDefault(require("classnames"));

var checkall_1 = __importDefault(require("./checkall"));

var NoData_1 = __importDefault(require("../NoData"));

var Loading_1 = __importDefault(require("../Loading"));

var useTable_1 = require("./useTable");

require("./table.less");

var NeoTable = function NeoTable(props, ref) {
  var _a = props.prefixCls,
      prefixCls = _a === void 0 ? 'ult' : _a,
      _b = props.emptyText,
      emptyText = _b === void 0 ? '' : _b,
      _c = props.isLoading,
      isLoading = _c === void 0 ? false : _c,
      _d = props.className,
      className = _d === void 0 ? '' : _d,
      _e = props.checkAllAble,
      checkAllAble = _e === void 0 ? false : _e,
      _f = props.expandable,
      expandable = _f === void 0 ? false : _f;
  var tableRef = useTable_1.useTable(props, ref).tableRef;
  var emptyElm;

  if (isLoading) {
    emptyElm = react_1["default"].createElement(Loading_1["default"], null);
  } else {
    emptyElm = emptyText || react_1["default"].createElement(NoData_1["default"], null);
  }

  if (expandable) {
    return react_1["default"].createElement(rc_table_1["default"], __assign({}, props, {
      prefixCls: prefixCls,
      isLoading: isLoading,
      ref: tableRef,
      className: classnames_1["default"](prefixCls + "-expand-table", className),
      emptyText: emptyElm
    }));
  }

  if (checkAllAble) {
    return react_1["default"].createElement(checkall_1["default"], __assign({}, props, {
      prefixCls: prefixCls,
      isLoading: isLoading,
      ref: tableRef,
      className: classnames_1["default"](prefixCls + "-table", className),
      emptyText: emptyElm
    }));
  }

  return react_1["default"].createElement(rc_table_1["default"], __assign({}, props, {
    prefixCls: prefixCls,
    isLoading: isLoading,
    ref: tableRef,
    className: classnames_1["default"](prefixCls + "-table", className),
    emptyText: emptyElm
  }));
};

var RefTable = react_1["default"].forwardRef(NeoTable);
exports["default"] = RefTable;