"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * 表格全选功能
 *
 * @author: GlenZhao
 * @created: 2017/11/24
 */

var classnames_1 = __importDefault(require("classnames"));

var react_1 = __importDefault(require("react"));

var rc_table_1 = __importDefault(require("rc-table"));

var CheckBox_1 = __importDefault(require("../../CheckBox"));

var useCheckAllTable_1 = require("./useCheckAllTable");

var RowCheckbox_1 = __importDefault(require("./RowCheckbox"));

var CheckAllTable = function CheckAllTable(props, ref) {
  var _a = props.prefixCls,
      prefixCls = _a === void 0 ? 'ult' : _a,
      _b = props.emptyText,
      emptyText = _b === void 0 ? '' : _b,
      _c = props.isLoading,
      isLoading = _c === void 0 ? false : _c,
      _d = props.className,
      className = _d === void 0 ? '' : _d;

  var _e = useCheckAllTable_1.useCheckAllTable(props, ref),
      isAllChecked = _e.isAllChecked,
      handleCheckAll = _e.handleCheckAll,
      genRowClass = _e.genRowClass,
      rowState = _e.rowState,
      handleCheckOne = _e.handleCheckOne;

  var renderCheckbox = function renderCheckbox(_, row, index) {
    return react_1["default"].createElement(RowCheckbox_1["default"], {
      row: index,
      data: row,
      checked: rowState[index],
      checkClick: handleCheckOne,
      disabled: row.checkDisabled ? row.checkDisabled : false
    });
  };

  var columnsWithCheckbox = [{
    title: '',
    dataIndex: '',
    render: renderCheckbox,
    key: 'all',
    width: 30
  }].concat(props.columns);
  return react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-multitable", className)
  }, react_1["default"].createElement(CheckBox_1["default"].CheckBox, {
    name: '',
    className: prefixCls + "-multitable-all",
    prefixCls: prefixCls,
    checked: isAllChecked,
    onChange: handleCheckAll,
    disabled: isLoading
  }), react_1["default"].createElement(rc_table_1["default"], __assign({}, props, {
    prefixCls: prefixCls,
    isLoading: isLoading,
    columns: columnsWithCheckbox,
    className: prefixCls + "-table",
    emptyText: emptyText,
    rowClassName: genRowClass
  })));
};

exports["default"] = react_1["default"].forwardRef(CheckAllTable);