"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * 表格全选功能 checkbox
 *
 * @author: Glen.Zhao
 * @created: 2017/11/24
 */

var classnames_1 = __importDefault(require("classnames"));

var react_1 = __importDefault(require("react"));

require("./style.less");

function RowCheckbox(_a) {
  var row = _a.row,
      data = _a.data,
      _b = _a.checked,
      checked = _b === void 0 ? false : _b,
      checkClick = _a.checkClick,
      _c = _a.disabled,
      disabled = _c === void 0 ? false : _c,
      _d = _a.className,
      className = _d === void 0 ? '' : _d,
      _e = _a.prefixCls,
      prefixCls = _e === void 0 ? 'ult' : _e;
  var classes = classnames_1["default"](prefixCls + "-checkbox row-checkbox-wrapper", className, {
    'checked': checked,
    'disabled': disabled
  });

  var handleChange = function handleChange() {
    checkClick(row, data, !checked);
  };

  return react_1["default"].createElement("label", {
    className: classes
  }, react_1["default"].createElement("span", {
    className: prefixCls + "-checkbox-inner " + prefixCls + "-checkbox-type"
  }), react_1["default"].createElement("input", {
    type: "checkbox",
    checked: checked,
    value: row,
    onChange: handleChange,
    disabled: disabled
  }));
}

exports["default"] = RowCheckbox;