/**
 * 排序状态
 */
export interface ISortState {
    _name: string;
    _iconClass: string;
    _nextState?: ISortState;
    name: string;
    iconClass: string;
    nextState?: ISortState;
}
declare class SortState implements ISortState {
    _name: string;
    _iconClass: string;
    _nextState?: ISortState;
    static getState: (sourceKey: string, sourceOrder: string, key: string) => ISortState;
    constructor(name: string, iconClass: string);
    get name(): string;
    set name(value: string);
    set iconClass(value: string);
    get iconClass(): string;
    /**
     * 设置下一个排序状态
     * @param sortState
     */
    set nextState(sortState: ISortState | undefined);
    get nextState(): ISortState | undefined;
}
declare const ASC: SortState;
declare const DESC: SortState;
declare const NONE: SortState;
export { SortState, ASC, DESC, NONE };
