"use strict";
/**
 * 排序状态
 */

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NONE = exports.DESC = exports.ASC = exports.SortState = void 0;

var SortState =
/** @class */
function () {
  function SortState(name, iconClass) {
    this._name = name;
    this._iconClass = iconClass;
  }

  Object.defineProperty(SortState.prototype, "name", {
    get: function get() {
      return this._name;
    },
    set: function set(value) {
      this._name = value;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(SortState.prototype, "iconClass", {
    get: function get() {
      return this._iconClass;
    },
    set: function set(value) {
      this._iconClass = value;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(SortState.prototype, "nextState", {
    get: function get() {
      return this._nextState;
    },

    /**
     * 设置下一个排序状态
     * @param sortState
     */
    set: function set(sortState) {
      this._nextState = sortState;
    },
    enumerable: false,
    configurable: true
  });
  return SortState;
}();

exports.SortState = SortState;
var ASC = new SortState('Asc', 'icon-asc');
exports.ASC = ASC;
var DESC = new SortState('Desc', 'icon-desc');
exports.DESC = DESC;
var NONE = new SortState('None', 'icon-sort');
exports.NONE = NONE;
NONE.nextState = DESC;
DESC.nextState = ASC;
ASC.nextState = NONE;
/**
 * 取当前排序状态
 * @param  {string} sourceKey   [源key]
 * @param  {string} sourceOrder [源排序]
 * @param  {string} key         [目标key]
 * @return {SortState}
 */

SortState.getState = function (sourceKey, sourceOrder, key) {
  sourceOrder = sourceOrder.toLowerCase();

  if (sourceKey === key) {
    switch (sourceOrder) {
      case 'desc':
        return DESC;

      case 'asc':
        return ASC;

      default:
        return NONE;
    }
  }

  return NONE;
};