"use strict";
/**
 * 排序功能表格
 * 有两种情况：
 * 1、对现有数据直接排序，
 * 2、通过传参数调接口方式获取排序好的数据。
 *
 * @author: GlenZhao
 * @created: 2017/11/24
 */

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var Table_1 = __importDefault(require("../Table"));

var useSortTable_1 = require("./useSortTable");

var SortTable = function SortTable(props, ref) {
  var _a = props.isLoading,
      isLoading = _a === void 0 ? false : _a,
      _b = props.checkAllAble,
      checkAllAble = _b === void 0 ? false : _b,
      _c = props.defaultSortState,
      defaultSortState = _c === void 0 ? 'Desc' : _c;

  var _d = useSortTable_1.useSortTable(props, ref, SortTable),
      tableRef = _d.tableRef,
      dataState = _d.dataState,
      columnsState = _d.columnsState;

  return react_1["default"].createElement(Table_1["default"], __assign({}, props, {
    isLoading: isLoading,
    checkAllAble: checkAllAble,
    defaultSortState: defaultSortState,
    ref: tableRef,
    data: isLoading ? [] : dataState,
    columns: columnsState
  }));
};

exports["default"] = react_1["default"].forwardRef(SortTable);