"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __createBinding = void 0 && (void 0).__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = void 0 && (void 0).__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = void 0 && (void 0).__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSortTable = void 0;

var react_1 = __importStar(require("react"));

var SortState_1 = require("./SortState");

var lodash_1 = __importDefault(require("lodash"));

var SortTitle_1 = __importDefault(require("./SortTitle"));

exports.useSortTable = function (_a, ref, SortTable) {
  var columns = _a.columns,
      data = _a.data,
      _b = _a.checkAllAble,
      checkAllAble = _b === void 0 ? false : _b,
      defaultSortKey = _a.defaultSortKey,
      _c = _a.defaultSortState,
      defaultSortState = _c === void 0 ? 'Desc' : _c,
      sortKey = _a.sortKey,
      sortState = _a.sortState,
      handleSortChange = _a.handleSortChange; // 生成表格列标题

  var genColumns = function genColumns(sortState, sortKey, _columns) {
    if (_columns === void 0) {
      _columns = columns;
    }

    return _columns.map(function (item) {
      if (item.compare) {
        var sortTitle = react_1["default"].createElement(SortTitle_1["default"], {
          title: item.title,
          onSort: handleSortOptionChange,
          keyValue: item.sortKey || item.key,
          sortState: SortState_1.SortState.getState(sortKey, sortState, item.sortKey || item.key)
        });
        return __assign(__assign({}, item), {
          title: sortTitle
        });
      } else {
        return __assign({}, item);
      }
    });
  };

  var handleSortOptionChange = function handleSortOptionChange(sortState, sortKey) {
    var state = sortState._name;
    var key = sortKey;

    if (state === 'None' && defaultSortKey) {
      if (key === defaultSortKey) {
        state = 'Desc';
      } else {
        key = defaultSortKey;
        state = defaultSortState;
      }
    } // 如果定义了此方法，则回调处理，否则直接排序数据


    if (handleSortChange) {
      handleSortChange(state, key);
      setColumnsState(genColumns(state, key));
    } else {
      setDataState(SortTable.doSort(data, columns, state, key, defaultSortState, defaultSortKey));
      setColumnsState(genColumns(state, key));
    }

    if (checkAllAble) {
      tableRef.current.reset();
    }
  };

  var _d = react_1.useState(data),
      dataState = _d[0],
      setDataState = _d[1];

  var _e = react_1.useState(genColumns(sortState || defaultSortState, sortKey || defaultSortKey)),
      columnsState = _e[0],
      setColumnsState = _e[1];

  react_1.useEffect(function () {
    setDataState(data);
  }, [data]);
  react_1.useEffect(function () {
    setColumnsState(genColumns(sortState || defaultSortState, sortKey || defaultSortKey, columns));
  }, [sortState, defaultSortState, sortKey, defaultSortKey, columns, data]);

  SortTable.doSort = function (data, columns, sortState, sortKey, defaultSortState, defaultSortKey) {
    var finalData = lodash_1["default"].cloneDeep(data);

    if (sortState === 'None') {
      if (defaultSortKey) {
        var column = columns.find(function (item) {
          var key = item.sortKey || item.key;
          return key === defaultSortKey;
        });
        finalData = lodash_1["default"].sortBy(finalData, [column.compare(defaultSortKey)]);

        if (defaultSortState === 'Desc') {
          finalData.reverse();
        }
      }
    } else {
      var column = columns.find(function (item) {
        var key = item.sortKey || item.key;
        return key === sortKey;
      });
      finalData = lodash_1["default"].sortBy(finalData, [column.compare(sortKey)]);
    }

    if (sortState === 'Desc') {
      finalData.reverse();
    }

    return finalData;
  };

  var tableRef = react_1.useRef();

  var reset = function reset() {
    if (checkAllAble) {
      tableRef.current.reset();
    }
  };

  var getSelected = function getSelected() {
    if (checkAllAble) {
      return tableRef.current.getSelected();
    }
  };

  react_1.useImperativeHandle(ref, function () {
    return {
      getSelected: getSelected,
      reset: reset
    };
  });
  return {
    tableRef: tableRef,
    dataState: dataState,
    columnsState: columnsState
  };
};