"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useTable = void 0;

var react_1 = require("react");

exports.useTable = function (_a, ref) {
  var checkAllAble = _a.checkAllAble,
      expandable = _a.expandable,
      data = _a.data;
  var tableRef = react_1.useRef();
  react_1.useEffect(function () {
    if (expandable) {
      var rows = document.getElementsByClassName('ult-row ult-row-level-0');
      var length_1 = rows.length;

      for (var i = 0; i < length_1; i++) {
        if (i % 2 === 0) {
          rows[i].setAttribute('style', 'background: #f6f8fa');
        }
      }
    }
  }, [data]);
  react_1.useImperativeHandle(ref, function () {
    return {
      getSelected: getSelected,
      reset: reset
    };
  });

  var reset = function reset() {
    if (checkAllAble) {
      tableRef.current.reset();
    }
  };

  var getSelected = function getSelected() {
    if (checkAllAble) {
      return tableRef.current.getSelected();
    }
  };

  return {
    tableRef: tableRef
  };
};