"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var useTooltip_1 = require("./useTooltip");

require("./tooltip.less");

function Popover(props) {
  var _a;

  var _b = props.className,
      className = _b === void 0 ? '' : _b,
      _c = props.placement,
      placement = _c === void 0 ? 'top' : _c,
      title = props.title,
      content = props.content,
      _d = props.children,
      children = _d === void 0 ? null : _d,
      _e = props.prefixCls,
      prefixCls = _e === void 0 ? 'ult' : _e,
      _f = props.trigger,
      trigger = _f === void 0 ? 'hover' : _f,
      _g = props.style,
      style = _g === void 0 ? null : _g;

  var _h = useTooltip_1.useTooltip({
    trigger: trigger
  }),
      show = _h.show,
      handleClickToggle = _h.handleClickToggle,
      handleMouseEnter = _h.handleMouseEnter,
      handleMouseLeave = _h.handleMouseLeave;

  var classes = classnames_1["default"]((_a = {}, _a[prefixCls + "-tooltip"] = true, _a["" + className] = !!className, _a[prefixCls + "-tooltip-" + placement] = !!placement, _a));
  return react_1["default"].createElement("div", {
    className: classes,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave,
    onClick: handleClickToggle
  }, react_1["default"].createElement("a", null, children), show ? react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-popover " + prefixCls + "-popover-" + placement),
    style: style
  }, react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-arrow")
  }), title ? react_1["default"].createElement("h3", {
    className: classnames_1["default"](prefixCls + "-popover-title")
  }, title) : null, react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-popover-content")
  }, content)) : null);
}

exports["default"] = Popover;