"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var useTooltip_1 = require("./useTooltip");

require("./tooltip.less");

function Tooltip(props) {
  var _a;

  var _b = props.className,
      className = _b === void 0 ? '' : _b,
      _c = props.style,
      style = _c === void 0 ? null : _c,
      _d = props.placement,
      placement = _d === void 0 ? 'top' : _d,
      _e = props.prefixCls,
      prefixCls = _e === void 0 ? 'ult' : _e,
      _f = props.children,
      children = _f === void 0 ? null : _f,
      _g = props.trigger,
      trigger = _g === void 0 ? 'hover' : _g,
      tips = props.tips;
  var classes = classnames_1["default"]((_a = {}, _a[prefixCls + "-tooltip"] = true, _a[prefixCls + "-tooltip-" + placement] = !!placement, _a), className);

  var _h = useTooltip_1.useTooltip({
    trigger: trigger
  }),
      show = _h.show,
      handleClickToggle = _h.handleClickToggle,
      handleMouseEnter = _h.handleMouseEnter,
      handleMouseLeave = _h.handleMouseLeave;

  return react_1["default"].createElement("div", {
    className: classes,
    style: style,
    onClick: handleClickToggle,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave
  }, children, show ? react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-tips-content")
  }, react_1["default"].createElement("span", {
    className: classnames_1["default"](prefixCls + "-tips")
  }, tips)) : null);
}

exports["default"] = Tooltip;