"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var useTooltip_1 = require("./useTooltip");

require("./tooltipAlign.less");

function TooltipAlign(props) {
  var _a = props.className,
      className = _a === void 0 ? '' : _a,
      style = props.style,
      _b = props.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      _c = props.children,
      children = _c === void 0 ? null : _c,
      _d = props.visible,
      visible = _d === void 0 ? null : _d,
      _e = props.scrollContainer,
      scrollContainer = _e === void 0 ? null : _e,
      tips = props.tips;

  var _f = useTooltip_1.useTooltipAlign(__assign(__assign({}, props), {
    scrollContainer: scrollContainer,
    visible: visible
  }), react_1["default"].createElement("div", {
    className: classnames_1["default"](prefixCls + "-tips-content")
  }, react_1["default"].createElement("span", {
    className: classnames_1["default"](prefixCls + "-tips")
  }, tips)), react_1["default"].createElement("div", null)),
      rooRef = _f.rooRef,
      handleClickToggle = _f.handleClickToggle,
      handleMouseEnter = _f.handleMouseEnter,
      handleMouseLeave = _f.handleMouseLeave;

  return react_1["default"].createElement("div", {
    ref: rooRef,
    className: classnames_1["default"](className, 'ult-tooltip'),
    style: style,
    onClick: handleClickToggle,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave
  }, children);
}

exports["default"] = TooltipAlign;