"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var CheckBox_1 = __importDefault(require("../CheckBox"));

var classnames_1 = __importDefault(require("classnames"));

var CheckBox = CheckBox_1["default"].CheckBox;

var Item = function Item(props) {
  var _a;

  var disabled = props.disabled,
      text = props.text,
      item = props.item,
      checked = props.checked,
      prefixCls = props.prefixCls,
      onClick = props.onClick;
  var className = classnames_1["default"](prefixCls + "-content-item", (_a = {}, _a[prefixCls + "-content-item-disabled"] = disabled || item.disabled, _a[prefixCls + "-content-item-checked"] = checked, _a));

  var handleClick = function handleClick(item) {
    onClick(item);
  };

  return react_1["default"].createElement(react_1["default"].Fragment, null, react_1["default"].createElement("li", {
    className: className,
    title: text,
    onClick: disabled || item.disabled ? undefined : function () {
      return handleClick(item);
    }
  }, react_1["default"].createElement(CheckBox, {
    name: "item-check",
    checked: checked,
    disabled: disabled || item.disabled,
    onClick: function onClick(e) {
      handleClick(item);
      e.stopPropagation();
    }
  }), react_1["default"].createElement("span", null, text)));
};

exports["default"] = Item;