"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var CheckBox_1 = __importDefault(require("../CheckBox"));

var NoData_1 = __importDefault(require("../NoData"));

var NItem_1 = __importDefault(require("./NItem"));

var Input_1 = __importDefault(require("../Input"));

var useTransfer_1 = require("./useTransfer");

var CheckBox = CheckBox_1["default"].CheckBox;

var List = function List(props) {
  var _a = props.prefixCls,
      prefixCls = _a === void 0 ? 'ult' : _a,
      _b = props.titleText,
      titleText = _b === void 0 ? '' : _b,
      _c = props.dataSource,
      dataSource = _c === void 0 ? [] : _c,
      _d = props.filter,
      filter = _d === void 0 ? '' : _d,
      _e = props.style,
      style = _e === void 0 ? {} : _e,
      _f = props.checkedKeys,
      checkedKeys = _f === void 0 ? [] : _f,
      _g = props.handleFilter,
      handleFilter = _g === void 0 ? function () {} : _g,
      _h = props.handleSelectAll,
      handleSelectAll = _h === void 0 ? function () {} : _h,
      _j = props.render,
      render = _j === void 0 ? function () {} : _j,
      _k = props.showSearch,
      showSearch = _k === void 0 ? false : _k,
      _l = props.searchPlaceholder,
      searchPlaceholder = _l === void 0 ? '' : _l,
      _m = props.notFoundContent,
      notFoundContent = _m === void 0 ? react_1["default"].createElement(NoData_1["default"], {
    size: "small"
  }) : _m,
      _o = props.itemUnit,
      itemUnit = _o === void 0 ? '' : _o,
      _p = props.itemsUnit,
      itemsUnit = _p === void 0 ? '' : _p,
      body = props.body,
      footer = props.footer,
      _q = props.disabled,
      disabled = _q === void 0 ? false : _q;

  var _r = useTransfer_1.useTransferList(props),
      checkedAll = _r.checkedAll,
      filteredDataSource = _r.filteredDataSource,
      totalDataSource = _r.totalDataSource,
      handleSelectItem = _r.handleSelectItem;

  var listCls = classnames_1["default"](prefixCls + "-transfer-list");
  var checkAllCheckbox = react_1["default"].createElement(CheckBox, {
    name: "checkAll",
    disabled: disabled,
    checked: checkedAll,
    onChange: function onChange() {
      return handleSelectAll(filteredDataSource, checkedAll);
    }
  });
  var unit = dataSource.length > 1 ? itemsUnit : itemUnit;
  var search = showSearch ? react_1["default"].createElement("div", {
    className: prefixCls + "-body-search-wrapper"
  }, react_1["default"].createElement(Input_1["default"], {
    onChange: function onChange(e) {
      return handleFilter(e.target.value);
    },
    icon: "search",
    iconRight: true,
    placeholder: searchPlaceholder,
    defaultValue: filter,
    disabled: disabled
  })) : null;
  var listBody = body && body(props) || react_1["default"].createElement("div", {
    className: classnames_1["default"](showSearch ? prefixCls + "-body " + prefixCls + "-body-with-search" : prefixCls + "-body")
  }, search, totalDataSource.length > 0 ? react_1["default"].createElement("ul", null, totalDataSource.map(function (item) {
    return react_1["default"].createElement(NItem_1["default"], {
      disabled: disabled,
      key: item.key,
      item: item,
      text: render(item),
      checked: checkedKeys.includes(item.key),
      prefixCls: prefixCls,
      onClick: handleSelectItem
    });
  })) : react_1["default"].createElement("div", {
    className: prefixCls + "-body-not-found"
  }, notFoundContent));
  var footerDom = footer && footer(props);
  var listFooter = footerDom ? react_1["default"].createElement("div", {
    className: prefixCls + "-footer"
  }, footerDom) : null;
  return react_1["default"].createElement("div", {
    className: listCls,
    style: style
  }, react_1["default"].createElement("div", {
    className: prefixCls + "-header"
  }, checkAllCheckbox, react_1["default"].createElement("span", {
    className: prefixCls + "-header-selected"
  }, react_1["default"].createElement("span", null, (checkedKeys.length > 0 ? checkedKeys.length + "/" : '') + totalDataSource.length, ' ', unit), react_1["default"].createElement("span", {
    className: prefixCls + "-header-title"
  }, titleText))), listBody, listFooter);
};

exports["default"] = List;