"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var Button_1 = __importDefault(require("../Button"));

var Operation = function Operation(props) {
  var className = props.className,
      _a = props.leftArrowText,
      leftArrowText = _a === void 0 ? '' : _a,
      _b = props.rightArrowText,
      rightArrowText = _b === void 0 ? '' : _b,
      moveToLeft = props.moveToLeft,
      moveToRight = props.moveToRight,
      leftActive = props.leftActive,
      rightActive = props.rightActive,
      style = props.style,
      disabled = props.disabled;
  return react_1["default"].createElement("div", {
    className: className,
    style: style
  }, react_1["default"].createElement(Button_1["default"], {
    type: "primary",
    size: "small",
    disabled: disabled || !rightActive,
    onClick: moveToRight,
    icon: "right"
  }, rightArrowText), react_1["default"].createElement(Button_1["default"], {
    type: "primary",
    size: "small",
    disabled: disabled || !leftActive,
    onClick: moveToLeft,
    icon: "left"
  }, leftArrowText));
};

exports["default"] = Operation;