import React from 'react';
import './ntransfer.less';
export interface TransferItem {
    key: string;
    title: string;
    description?: string;
    disabled?: boolean;
    [prop: string]: any;
}
export declare type TransferDirection = 'left' | 'right';
export interface TransferProps {
    prefixCls?: string;
    className?: string;
    disabled?: boolean;
    dataSource?: TransferItem[];
    targetKeys?: string[];
    selectedKeys?: string[];
    render?: (record: TransferItem) => React.ReactNode;
    onChange?: (targetKeys: string[], direction: string, moveKeys: string[]) => void;
    onSelectChange?: (sourceSelectedKeys: string[], targetSelectedKeys: string[]) => void;
    style?: React.CSSProperties;
    listStyle?: React.CSSProperties;
    operationStyle?: React.CSSProperties;
    titles?: React.ReactNode[];
    operations?: string[];
    showSearch?: boolean;
    filterOption: (inputValue: any, item: any) => boolean;
    searchPlaceholder?: string;
    notFoundContent?: React.ReactNode;
    footer?: () => React.ReactNode;
    body?: () => React.ReactNode;
    rowKey?: (record: TransferItem) => string;
    onSearch?: (direction: TransferDirection, value: string) => void;
    itemUnit?: string;
    itemsUnit?: string;
}
declare const Transfer: any;
export default Transfer;
