"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var NoData_1 = __importDefault(require("../NoData"));

var NList_1 = __importDefault(require("./NList"));

var NOperation_1 = __importDefault(require("./NOperation"));

var useTransfer_1 = require("./useTransfer");

require("./ntransfer.less");

var Transfer = function Transfer(props) {
  var _a = props.prefixCls,
      prefixCls = _a === void 0 ? 'ult' : _a,
      _b = props.className,
      className = _b === void 0 ? '' : _b,
      _c = props.disabled,
      disabled = _c === void 0 ? false : _c,
      _d = props.render,
      render = _d === void 0 ? function (item) {
    return item.title;
  } : _d,
      _e = props.style,
      style = _e === void 0 ? {} : _e,
      _f = props.listStyle,
      listStyle = _f === void 0 ? {} : _f,
      _g = props.operationStyle,
      operationStyle = _g === void 0 ? {} : _g,
      _h = props.titles,
      titles = _h === void 0 ? ['', ''] : _h,
      _j = props.operations,
      operations = _j === void 0 ? ['', ''] : _j,
      _k = props.showSearch,
      showSearch = _k === void 0 ? false : _k,
      filterOption = props.filterOption,
      _l = props.searchPlaceholder,
      searchPlaceholder = _l === void 0 ? '' : _l,
      _m = props.notFoundContent,
      notFoundContent = _m === void 0 ? react_1["default"].createElement(NoData_1["default"], {
    size: "small"
  }) : _m,
      _o = props.footer,
      footer = _o === void 0 ? function () {
    return null;
  } : _o,
      _p = props.body,
      body = _p === void 0 ? function () {
    return null;
  } : _p,
      _q = props.itemUnit,
      itemUnit = _q === void 0 ? '' : _q,
      _r = props.itemsUnit,
      itemsUnit = _r === void 0 ? '' : _r;

  var _s = useTransfer_1.useTransfer(props),
      leftDataSource = _s.leftDataSource,
      rightDataSource = _s.rightDataSource,
      sourceSelectedKeys = _s.sourceSelectedKeys,
      targetSelectedKeys = _s.targetSelectedKeys,
      leftFilter = _s.leftFilter,
      rightFilter = _s.rightFilter,
      handleLeftFilter = _s.handleLeftFilter,
      handleRightFilter = _s.handleRightFilter,
      handleLeftSelect = _s.handleLeftSelect,
      handleRightSelect = _s.handleRightSelect,
      handleLeftSelectAll = _s.handleLeftSelectAll,
      handleRightSelectAll = _s.handleRightSelectAll,
      moveToRight = _s.moveToRight,
      moveToLeft = _s.moveToLeft;

  var cls = classnames_1["default"](prefixCls + "-transfer-wrapper", className);
  var leftActive = targetSelectedKeys.length > 0;
  var rightActive = sourceSelectedKeys.length > 0;
  return react_1["default"].createElement("div", {
    className: cls,
    style: style
  }, react_1["default"].createElement(NList_1["default"], {
    prefixCls: prefixCls + "-list",
    titleText: titles[0],
    dataSource: leftDataSource,
    filter: leftFilter,
    filterOption: filterOption,
    style: listStyle,
    checkedKeys: sourceSelectedKeys,
    handleFilter: handleLeftFilter,
    handleSelect: handleLeftSelect,
    handleSelectAll: handleLeftSelectAll,
    render: render,
    showSearch: showSearch,
    body: body,
    footer: footer,
    disabled: disabled,
    searchPlaceholder: searchPlaceholder,
    notFoundContent: notFoundContent,
    itemUnit: itemUnit,
    itemsUnit: itemsUnit,
    direction: "left"
  }), react_1["default"].createElement(NOperation_1["default"], {
    className: prefixCls + "-operation",
    rightActive: rightActive,
    rightArrowText: operations[0],
    moveToRight: moveToRight,
    leftActive: leftActive,
    leftArrowText: operations[1],
    moveToLeft: moveToLeft,
    style: operationStyle,
    disabled: disabled
  }), react_1["default"].createElement(NList_1["default"], {
    prefixCls: prefixCls + "-list",
    titleText: titles[1],
    dataSource: rightDataSource,
    filter: rightFilter,
    filterOption: filterOption,
    style: listStyle,
    checkedKeys: targetSelectedKeys,
    handleFilter: handleRightFilter,
    handleSelect: handleRightSelect,
    handleSelectAll: handleRightSelectAll,
    render: render,
    showSearch: showSearch,
    body: body,
    footer: footer,
    disabled: disabled,
    searchPlaceholder: searchPlaceholder,
    notFoundContent: notFoundContent,
    itemUnit: itemUnit,
    itemsUnit: itemsUnit,
    direction: "right"
  }));
};

exports["default"] = Transfer;