"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
/*
 * @Author: SiMeiyu
 * @Date: 2017-07-04 10:08:20
 */

var react_1 = __importDefault(require("react"));

var TreeRoot_1 = __importDefault(require("./TreeRoot"));

var TreeNode_1 = __importDefault(require("./TreeNode"));

var useTree_1 = __importDefault(require("./useTree"));

var Tree = function Tree(props) {
  var isDelete = props.isDelete;

  var _a = useTree_1["default"](props),
      newData = _a.newData,
      selectedKey = _a.selectedKey,
      checkedKeys = _a.checkedKeys,
      _onSelected = _a.onSelected,
      _onChecked = _a.onChecked,
      _onDelete = _a.onDelete,
      _onSwitch = _a.onSwitch;

  var loop = function loop(data) {
    return data.map(function (item) {
      var _prop = {
        key: item.key,
        title: item.name,
        isParent: item.isParent,
        disabled: item.disabled || false,
        open: item.isParent ? item.open === undefined ? true : item.open : null,
        icon: item.icon || null,
        iconOpen: item.iconOpen || null,
        iconClose: item.iconClose || null,
        url: item.url || null,
        depth: item.depth,
        matchSearch: item.matchSearch || false
      };
      return react_1["default"].createElement(TreeNode_1["default"], __assign({}, _prop, {
        key: item.key,
        selectedKey: selectedKey,
        checkedKeys: checkedKeys,
        onSelected: function onSelected() {
          return _onSelected(item.callback, item.key);
        },
        onChecked: function onChecked() {
          return _onChecked(item.key, item.isParent);
        },
        onSwitch: function onSwitch(key, open) {
          return _onSwitch(key, open);
        },
        onDelete: function onDelete() {
          return _onDelete(item.key, item.name);
        },
        isDelete: isDelete
      }), item.children ? loop(item.children) : null);
    });
  };

  var treeNodes = loop(newData);
  var _b = props.prefixCls,
      prefixCls = _b === void 0 ? 'ult' : _b,
      _c = props.className,
      className = _c === void 0 ? '' : _c,
      _d = props.showIcon,
      showIcon = _d === void 0 ? false : _d,
      _e = props.showLine,
      showLine = _e === void 0 ? false : _e,
      _f = props.multiple,
      multiple = _f === void 0 ? false : _f,
      _g = props.switchIcon,
      switchIcon = _g === void 0 ? ['add', 'minus'] : _g;
  var rootProps = {
    prefixCls: prefixCls,
    className: className,
    showIcon: showIcon,
    showLine: showLine,
    multiple: multiple,
    switchIcon: switchIcon
  };
  return react_1["default"].createElement(TreeRoot_1["default"], __assign({}, rootProps, {
    selectedKey: selectedKey,
    checkedKeys: checkedKeys
  }), treeNodes);
};

exports["default"] = Tree;