"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
/*
 * @Author: SiMeiyu
 * @Date: 2017-07-04 10:08:38
 */

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

require("./tree.less");

var TreeRoot = function TreeRoot(props) {
  var _a = props.prefixCls,
      prefixCls = _a === void 0 ? 'ult' : _a,
      _b = props.className,
      className = _b === void 0 ? '' : _b,
      children = props.children,
      _c = props.checkedKeys,
      checkedKeys = _c === void 0 ? [] : _c,
      _d = props.showLine,
      showLine = _d === void 0 ? false : _d,
      _e = props.showIcon,
      showIcon = _e === void 0 ? false : _e,
      _f = props.multiple,
      multiple = _f === void 0 ? false : _f,
      _g = props.selectable,
      selectable = _g === void 0 ? false : _g,
      _h = props.switchIcon,
      switchIcon = _h === void 0 ? [] : _h,
      _j = props.selectedKey,
      selectedKey = _j === void 0 ? '' : _j;
  var classes = classnames_1["default"](prefixCls + "-tree", prefixCls + "-tree-root", className);
  return react_1["default"].createElement("ul", {
    className: classes
  }, react_1["default"].Children.map(children, function (child) {
    var cloneProps = {
      eventKey: child.key,
      prefixCls: prefixCls,
      showLine: showLine,
      showIcon: showIcon,
      multiple: multiple,
      selectable: selectable,
      switchIcon: switchIcon,
      selected: selectedKey === child.key,
      checked: checkedKeys.find(function (k) {
        return k === child.key;
      })
    };
    return react_1["default"].cloneElement(child, cloneProps);
  }));
};

exports["default"] = TreeRoot;