"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _xeditable = _interopRequireDefault(require("./xeditable"));

var _Select = _interopRequireDefault(require("../Select"));

require("./xedit.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Option = _Select["default"].Option;

var EditableSelect = /*#__PURE__*/function (_React$Component) {
  _inherits(EditableSelect, _React$Component);

  var _super = _createSuper(EditableSelect);

  function EditableSelect(props) {
    var _this;

    _classCallCheck(this, EditableSelect);

    _this = _super.call(this, props);
    _this.state = {
      isEditing: false,
      value: _this.props.value,
      defaultText: _this.props.defaultText,
      newValue: _this.props.value
    }; // this.setState = this.setState.bind(this);

    return _this;
  }

  _createClass(EditableSelect, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        value: nextProps.value,
        defaultText: nextProps.defaultText,
        newValue: nextProps.value
      });
    }
  }, {
    key: "save",
    value: function save(newName) {
      // this.props.onUpdate(this.props.name, this.refs.el.value);
      this.setState({
        isEditing: false,
        newValue: newName
      });

      if (this.props.onUpdate) {
        this.props.onUpdate(newName);
      }
    }
  }, {
    key: "selectChange",
    value: function selectChange(type, e) {
      this.setState({
        value: e
      });
    }
  }, {
    key: "cancel",
    value: function cancel() {
      this.setState({
        isEditing: false
      });
    }
  }, {
    key: "handleLinkClick",
    value: function handleLinkClick() {
      var isEditing = this.state.isEditing;
      this.setState({
        isEditing: !isEditing
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          prefixCls = _this$props.prefixCls,
          options = _this$props.options;
      var me = this;
      var _this$state = this.state,
          textStyle = _this$state.textStyle,
          defaultText = _this$state.defaultText,
          value = _this$state.value,
          isEditing = _this$state.isEditing,
          newValue = _this$state.newValue;
      var aClassName = (0, _classnames["default"])('editable editable-click', {
        'editable-empty': !value
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("".concat(prefixCls, "-detail-editable"))
      }, /*#__PURE__*/_react["default"].createElement("a", {
        className: aClassName,
        style: textStyle,
        onClick: me.handleLinkClick.bind(me)
      }, newValue || defaultText, /*#__PURE__*/_react["default"].createElement("i", {
        className: "iconfont icon-edit"
      })), isEditing ? /*#__PURE__*/_react["default"].createElement(_xeditable["default"], {
        isLoading: false,
        save: me.save.bind(me),
        cancel: me.cancel.bind(me),
        newValue: value
      }, /*#__PURE__*/_react["default"].createElement(_Select["default"], {
        placeholder: "\u8BF7\u9009\u62E9...",
        notFoundContent: "\u6CA1\u6709\u627E\u5230" // defaultValue="2"
        // value={this.state.simple}
        ,
        onChange: me.selectChange.bind(this, 'simple')
      }, options.map(function (option, index) {
        return /*#__PURE__*/_react["default"].createElement(Option, {
          key: index,
          value: option
        }, option);
      }))) : null);
    }
  }]);

  return EditableSelect;
}(_react["default"].Component);

EditableSelect.propTypes = {
  prefixCls: _propTypes["default"].string,
  value: _propTypes["default"].any,
  defaultText: _propTypes["default"].string,
  options: _propTypes["default"].array,
  onUpdate: _propTypes["default"].func
};
EditableSelect.defaultProps = {
  prefixCls: 'ult',
  options: [],
  defaultText: '-',
  value: '',
  onUpdate: undefined
};
EditableSelect.defaultProps = {
  prefixCls: 'ult'
};
var _default = EditableSelect;
exports["default"] = _default;