"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Loading = _interopRequireDefault(require("../Loading"));

var _Button = _interopRequireDefault(require("../Button"));

var _RcForm = _interopRequireDefault(require("../RcForm"));

var _AlertBox = require("../AlertBox");

require("./xeditable.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Form = _RcForm["default"].Form,
    Input = _RcForm["default"].Input,
    Textarea = _RcForm["default"].Textarea;
var ButtonList = _Button["default"].List;
var INPUT_TYPE = {
  INPUT: 'input',
  PASSOWRD: 'password'
};

var XEdit = /*#__PURE__*/function (_React$Component) {
  _inherits(XEdit, _React$Component);

  var _super = _createSuper(XEdit);

  function XEdit(props) {
    var _this;

    _classCallCheck(this, XEdit);

    _this = _super.call(this, props);

    _this.handleChange = function (ev) {
      var _this$props = _this.props,
          form = _this$props.form,
          value = _this$props.value;
      var newValue = ev.target.value;

      _this.setState({
        value: newValue || ''
      }, function () {
        form.validateFields(function (error) {
          _this.setState({
            disabled: !!error,
            noChange: value === newValue
          });
        });
      });
    };

    _this.handleSubmit = function (e) {
      var _this$props2 = _this.props,
          form = _this$props2.form,
          type = _this$props2.type,
          save = _this$props2.save;
      var data = form.getFieldsValue(); // 模拟一下调用接口

      _this.setState({
        isSubmitting: true
      });

      var dataToSave = type === INPUT_TYPE.INPUT ? data.name : data.description;
      save(dataToSave);
    };

    _this.state = {
      isSubmitting: false,
      value: props.value,
      disabled: false,
      noChange: true
    };
    _this.handelClick = _this.handelClick.bind(_assertThisInitialized(_this));
    _this.handleSubmit = _this.handleSubmit.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(XEdit, [{
    key: "handelClick",
    value: function handelClick(newValue) {
      this.props.save(newValue);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          isLoading = _this$props3.isLoading,
          isError = _this$props3.isError,
          type = _this$props3.type,
          form = _this$props3.form,
          isRequired = _this$props3.isRequired,
          name = _this$props3.name,
          validRegex = _this$props3.validRegex,
          invalidMessage = _this$props3.invalidMessage,
          minLength = _this$props3.minLength,
          maxLength = _this$props3.maxLength,
          addon = _this$props3.addon,
          alertcontent = _this$props3.alertcontent;
      var _this$state = this.state,
          isSubmitting = _this$state.isSubmitting,
          value = _this$state.value,
          disabled = _this$state.disabled,
          noChange = _this$state.noChange;
      var canclDisabled = form.isFieldsValidating();
      var isTextField = type === INPUT_TYPE.INPUT || type === INPUT_TYPE.PASSOWRD;

      var textfieldRender = /*#__PURE__*/_react["default"].createElement(Input, {
        form: form,
        value: value,
        onChange: this.handleChange,
        name: "name",
        label: name,
        validRegex: validRegex,
        invalidMessage: invalidMessage,
        isRequired: isRequired,
        type: type
      });

      var textareaRender = /*#__PURE__*/_react["default"].createElement(Textarea, {
        form: form,
        value: value,
        onChange: this.handleChange,
        name: "description",
        label: name,
        minLength: minLength,
        maxLength: maxLength,
        addon: addon,
        invalidMessage: invalidMessage,
        isRequired: isRequired
      });

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("editable-container editable-inline"),
        onClick: function onClick(e) {
          e.stopPropagation();
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("editable-arrow")
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("editable-wrapper")
      }, isLoading ? /*#__PURE__*/_react["default"].createElement(_Loading["default"], null) : /*#__PURE__*/_react["default"].createElement(Form, {
        form: form,
        ref: function ref(node) {
          _this2.$form = node;
        },
        className: (0, _classnames["default"])("form-inline editableform"),
        inline: true,
        noLabel: true
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("control-group form-group")
      }, !_.isEmpty(alertcontent) ? /*#__PURE__*/_react["default"].createElement(_AlertBox.AlertBox, {
        className: "m-b-sm",
        alertcontent: alertcontent,
        type: "default",
        closeBtn: false
      }) : null, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])({
          'editable-error': isError
        })
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("editable-input")
      }, isTextField ? textfieldRender : textareaRender), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("editable-buttons")
      }, /*#__PURE__*/_react["default"].createElement(ButtonList, null, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
        type: "default",
        icon: "error",
        disabled: canclDisabled,
        onClick: this.props.cancel
      }), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
        type: "primary",
        icon: "correct",
        disabled: disabled || noChange,
        htmlType: "submit",
        isSubmitting: isSubmitting,
        onClick: this.handleSubmit
      }))))))));
    }
  }]);

  return XEdit;
}(_react["default"].Component);

XEdit.propTypes = {
  isLoading: _propTypes["default"].bool,
  save: _propTypes["default"].func.isRequired,
  form: _propTypes["default"].object.isRequired,
  type: _propTypes["default"].string,
  isError: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  value: _propTypes["default"].string,
  name: _propTypes["default"].string,
  validRegex: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  invalidMessage: _propTypes["default"].string,
  minLength: _propTypes["default"].number,
  maxLength: _propTypes["default"].number,
  addon: _propTypes["default"].string,
  cancel: _propTypes["default"].func,
  alertcontent: _propTypes["default"].string
};
XEdit.defaultProps = {
  isLoading: false,
  type: 'string',
  isError: false,
  isRequired: false,
  value: '',
  name: '',
  validRegex: '',
  invalidMessage: '',
  minLength: undefined,
  maxLength: undefined,
  addon: null,
  cancel: function cancel() {},
  alertcontent: ''
};

var XEditable = _RcForm["default"].create()(XEdit);

var _default = XEditable;
exports["default"] = _default;