"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Loading = _interopRequireDefault(require("../Loading"));

var _Form = _interopRequireDefault(require("../Form"));

var _Button = _interopRequireDefault(require("../Button"));

require("./xeditable.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Form = _Form["default"].Form;
var ButtonList = _Button["default"].List;

var XEditable = /*#__PURE__*/function (_React$Component) {
  _inherits(XEditable, _React$Component);

  var _super = _createSuper(XEditable);

  function XEditable() {
    _classCallCheck(this, XEditable);

    return _super.apply(this, arguments);
  }

  _createClass(XEditable, [{
    key: "handelClick",
    value: function handelClick(newValue) {
      this.props.save(newValue);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          isLoading = _this$props.isLoading,
          newValue = _this$props.newValue,
          className = _this$props.className,
          errorShow = _this$props.errorShow,
          isError = _this$props.isError;
      var classNa = isError ? "editable-error" : null;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("editable-container editable-inline")
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("editable-arrow")
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("editable-wrapper")
      }, isLoading ? /*#__PURE__*/_react["default"].createElement(_Loading["default"], null) : /*#__PURE__*/_react["default"].createElement(Form, {
        className: (0, _classnames["default"])("form-inline editableform"),
        onSubmit: this.props.save,
        noLabel: true
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("control-group form-group")
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: classNa
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("editable-input")
      }, this.props.children), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("editable-buttons")
      }, /*#__PURE__*/_react["default"].createElement(ButtonList, null, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
        disabled: isError,
        type: "primary",
        icon: "correct",
        onClick: this.handelClick.bind(this, newValue)
      }), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
        type: "default",
        icon: "error",
        onClick: this.props.cancel
      }))))))));
    }
  }]);

  return XEditable;
}(_react["default"].Component);

XEditable.propTypes = {
  isLoading: _propTypes["default"].bool,
  save: _propTypes["default"].func.isRequired,
  newValue: _propTypes["default"].any,
  cancel: _propTypes["default"].func,
  children: _propTypes["default"].any.isRequired
};
XEditable.defaultProps = {
  isLoading: false,
  newValue: '',
  cancel: undefined
};
var _default = XEditable;
exports["default"] = _default;