"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.del = exports.get = exports.set = void 0;

/* eslint no-useless-escape: 0 */
function _parseCookieValue(s) {
  if (s.indexOf('"') === 0) {
    // This is a quoted cookie as according to RFC2068, unescape...
    s = s.slice(1, -1).replace(/\\"/g, '"').replace(/\\\\/g, '\\');
  }

  return s;
}
/**
 * 设置cookie
 */


var set = function set(name, value) {
  var day = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 30;
  var exp = new Date();
  exp.setTime(exp.getTime() + day * 24 * 60 * 60 * 1000);
  document.cookie = "".concat(name, "=").concat(encodeURIComponent(value), ";expires=").concat(exp.toGMTString(), "; path=/");
};
/**
 * 读取cookie
 */


exports.set = set;

var get = function get(name) {
  var arr = document.cookie.match(new RegExp("(^| )".concat(name, "=([^;]*)(;|$)")));
  if (arr != null) return decodeURIComponent(_parseCookieValue(arr[2]));
  return null;
};
/**
 * 删除cookie
 */


exports.get = get;

var del = function del(name) {
  var exp = new Date();
  exp.setTime(exp.getTime() - 1);
  var cval = get(name);
  if (cval != null) document.cookie = "".concat(name, "=").concat(cval, ";expires=").concat(exp.toGMTString());
};

exports.del = del;