"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPageRange = exports.pagination = exports.percent = void 0;

/**
 * 百分比
 * @param  {number} used  [description]
 * @param  {number} total [description]
 * @param  {Number} fixed [description]
 * @return {string}       [description]
 */
var percent = function percent(used, total) {
  var fixed = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var res = used / total * 100;

  if (fixed > 0) {
    return "".concat(res.toFixed(fixed), "%");
  }

  return "".concat(parseInt(res), "%");
};
/**
 * 计算分页的start, end
 * @param  {int} page     [description]
 * @param  {int} pageSize [description]
 * @return {object}          [description]
 */


exports.percent = percent;

var pagination = function pagination(page, pageSize) {
  var start = (page - 1) * pageSize;
  var end = page * pageSize;
  return {
    start: start,
    end: end
  };
};

exports.pagination = pagination;

var getPageRange = function getPageRange(total, pageSize, page) {
  var currentPage = parseInt(page);
  var start = (currentPage - 1) * pageSize;
  var end = currentPage * pageSize > total ? total : currentPage * pageSize;
  return {
    start: start,
    end: end
  };
};

exports.getPageRange = getPageRange;