"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isNumber = exports.isPositiveInteger = exports.isInteger = void 0;

/**
 * 判断是否整数
 * @param {object} obj
 */
var isInteger = function isInteger(obj) {
  return (obj | 0) === obj;
};
/**
 * 判断是否为正整数
 * @param s 要判断的字符串
 * @return {boolean}  是否正整数
 */


exports.isInteger = isInteger;

var isPositiveInteger = function isPositiveInteger(s) {
  return /^\+?[1-9][\d]*$/.test(s);
};
/**
 * 判断是否为数字
 * @param s 要判断的字符串
 * @return {boolean}  是否正整数
 */


exports.isPositiveInteger = isPositiveInteger;

var isNumber = function isNumber(s) {
  return /^-?[0-9]+([.]{1}[0-9]+){0,1}$/.test(s);
};

exports.isNumber = isNumber;