"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.format = void 0;

/**
 * 格式化时间
 *
 * @param {string} time 原始时间字符串
 * @param {string} [type='24'] 默认24小时制，可为12小时制
 * @memberof Tools
 */
var format = function format(rawTime) {
  var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '24';
  var Y, M, D, h, m, s;

  var fillZero = function fillZero(value) {
    if (value < 10) {
      value = "0".concat(value);
    }

    return value;
  };

  var time = new Date(rawTime);
  Y = time.getFullYear();
  M = fillZero(time.getMonth() + 1);
  D = fillZero(time.getDate());
  h = fillZero(time.getHours());
  m = fillZero(time.getMinutes());
  s = fillZero(time.getSeconds());

  if (type && type === 12) {
    if (h < 12) {
      h = "\u4E0A\u5348".concat(h);
    } else if (h > 12 && h < 24) {
      h -= 12;
      h = "\u4E0B\u5348".concat(fillZero(h));
    } else if (h === 24) {
      h = '下午00';
    }
  }

  var timeStr = "".concat(Y, "-").concat(M, "-").concat(D, " ").concat(h, ":").concat(m, ":").concat(s);
  return timeStr;
};

exports.format = format;